Automatic Lidar and Ceilometer Framework (ALCF)
===============================================

ALCF is an open source command line tool for processing of automatic lidar and
ceilometer (ALC) data and intercomparison with atmospheric models such as
general circulation models (GCMs), numerical weather prediction models (NWP) and
reanalyses with a lidar simulator using the
[COPS](https://github.com/CFMIP/COSPv2.0) instrument simulator framework running
offline on model output. ALCs are vertically pointing atmospheric lidars,
measuring cloud and aerosol backscatter. The primary focus of ALCF are
atmospheric studies of cloud using ALC observations and model cloud validation.

Please see [alcf.peterkuma.net](https://alcf.peterkuma.net) for more
information.

General notes:
vN.N is version number (e.g. v1.0)
We will assume that the software will be installed in ~/cosp.

This README has been written by Alejandro Bodas (alejandro.bodas at metoffice.gov.uk).
Modified by Dustin Swales (dustin.swales@noaa.gov) on 9/27/2016

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
1.- ABOUT THE CODE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

COSP stands for CFMIP Observation Simulator Package.
This is a code that takes information from atmospheric models as input
and simulates the signal of CloudSat and CALIPSO. It computes summary
statistics from these outputs that can be compared with similar statistics
computed from the observations. It also includes the ISCCP simulator.
There are several groups that have been actively involved in the code development:

  * Met Office Hadley Centre

  * LLNL (Lawrence Livermore National Laboratory)

  * LMD/IPSL (Laboratoire de Meteorologie Dynamique/Institut Pierre Simon Laplace)

  * CSU (Colorado State University)

  * UW (University of Washington)

The approach is to create a modular code in FORTRAN90 (some lower level 
routines are in F77) that can be plugged in different types of models, 
from general circulation models (GCMs) to cloud cloud-resolving models (CRMs).
The logical structure of the code is split into 4 sections:

  * Sub-grid cloud distribution (SCOPS:Subgrid Cloud Overlap Profile Sampler,
    which is already used by the ISCCP simulator)

  * Sub-grid precipitation.

  * Instrument simulators:
      ISCCP simulator
      Radar simulator (QuickBeam)
      Lidar and PARASOL simulators (ACTSIM)
      MISR simulator
      MODIS simulator
      RTTOV simulator

  * Summary statistics diagnostics 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
2.- CONDITIONS OF USE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

The code is distributed under BSD License (http://www.opensource.org/licenses/bsd-license.php).
Each source file includes a copy of this license with details on the Owner, Year 
and Organisation. The license in the file quickbeam/README applies to all the files in 
the directory quickbeam.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
3.- DOWNLOADING AND UNPACKING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
As of September 2015, the code is hosted on gitHub:
https://github.com/CFMIP/COSPv1

You can use git to download the latest stable version of COSP. For example, to clone (git
equivalent of svn co) a copy of the repository to your machine:
git clone https://github.com/CFMIP/COSPv1.git

To view tagged versions of the repository you can use "git log". For example:
[macSWALES:~/Desktop/COSPv1] dswales% git log

   commit 572c53ab941c8019135d147fbdf01a6633487aaa
   Author: Dustin Swales <dustin.swales@noaa.gov>
   Date:   Mon Sep 14 11:53:52 2015 -0600

       COSP version 1.4.0

   commit 9e7d84d735249d95521852e0db0c8eed16b4f070
   Author: Dustin Swales <dustin.swales@noaa.gov>
   Date:   Mon Sep 14 11:15:51 2015 -0600

       COSP version 1.3.2

   commit ce4130ca7334bc30875e7cfc620d6195bf237c73
   Author: Robert.Pincus <Robert.Pincus@colorado.edu>
   Date:   Fri Mar 18 20:52:12 2011 +0000

       Copying v1.3.1 to archive of stable releases.

So for example, lets say you want to use COSPv1.3.2. To accomplish this you need to clone the
repository (described above) and then revert to that tagged version using:
git checkout 9e7d84d735249d95521852e0db0c8eed16b4f070

Test input data and reference data is distributed with COSP (see data/).

Now you can follow the steps in Section 4.

Older versions: 1.3.0 and before
------------------------------------
These versions are not available in the Google code svn repository, only in the CFMIP website.
a) Download cosp.vN.N.tar.gz in your system. I'll assume that you have chosen ~/cosp as your
   target directory.
b) cd ~/cosp
c) Extract the source code
   tar -xvzf cosp.vN.N.tar.gz

You may want to delete the *.tar file as it is no longer needed.

This creates the directory COSP, where the source code for COSP is found.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
4.- COMPILATION AND TESTING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

4.1 - Compilation
--------------------------------------------------------------------------------------------

In order to build COSP you'll need the following libraries:
  a) HDF5 libraries (http://www.hdfgroup.org/HDF5/)
  b) NetCDF4 libraries (http://www.unidata.ucar.edu/software/netcdf/)
  c) CMOR2 libraries (http://www2-pcmdi.llnl.gov/cmor/)

Before building COSP, you will need to edit the Makefile above the following lines
 
########################################################################
#              End of modifications
########################################################################

You will need to change the environment variables so that they point to where the required 
libraries are located in your system.

You can still use CMORv1.3. Please, see section 6.7 for details.

I reccommend to compile the code first with no optimisatons and run the tests. Then, once 
you are confident that is working properly in your system you can increase the level of
optimisations.

Compilation:
make clean
make

This will create the executable cosp_test.

4.2 - Testing
--------------------------------------------------------------------------------------------
a) Setting up the namelists
The input parameters for cosp_test are provided through the  namelist COSP_INPUT,
which can be found in the file cosp_input_nl.txt. You can run two tests by changing
the input file:

 FINPUT='cosp_input_um.nc', ! NetCDF file with 1D inputs
 or
 FINPUT='cosp_input_um_2d.nc', ! NetCDF file with 2D inputs

You will also need to modify the CMOR namelist
in ~/cosp/cosp.vN.N/cmor/cosp_cmor_nl.txt. Specifically, you will need to use
   
   TABLE = 'COSP_table_1D' for 'cosp_input_um.nc'
   TABLE = 'COSP_table_2D' for 'cosp_input_um_2d.nc'
   
COSP_table_2D contains the definitions of the variables in a lon/lat grid.

b) Run cosp_test. This will create the NetCDF outputs in ~/cosp/cosp.vN.N/outputs.
c) Compare these files with the expected outputs, located in:
  ~/cosp/cosp.vN.N/outputs_test
The script cosp_test.sh can be used to check that your outputs are equal to 
the ones in outputs_test. The usage is as follows:
   ./cosp_test.sh arg1 arg2
   arg1: 1D or 2D
   arg2 must be one of these options
     0: use cmp
     1: use nccmp
     2: use nco + diff
     3: use nco to create differences

NOTE: If you get the message "command not found" when trying to run cosp_test.sh, 
change the first line (#!/usr/bin/sh) to point where sh is located in your system.

Option 1 uses nccmp, which is available from http://nccmp.sourceforge.net/. Options 2 and 3 use
the NetCDF Operators (NCO), available from http://nco.sourceforge.net/.
     
I recommend using option 1 first (nccmp). The following lines show an example of output using nccmp,
where the test found differences in two files, meantbisccp_2D.nc and tclisccp_2D.nc.

    Comparing  albisccp_2D.nc ...
    Comparing  atb532_2D.nc ...
    Comparing  boxptopisccp_2D.nc ...
    Comparing  boxtauisccp_2D.nc ...
    Comparing  cfad_dbze94_2D.nc ...
    Comparing  cfad_lidarsr532_2D.nc ...
    Comparing  clMISR_2D.nc ...
    Comparing  clcalipso2_2D.nc ...
    Comparing  clcalipso_2D.nc ...
    Comparing  clhcalipso_2D.nc ...
    Comparing  clisccp2_2D.nc ...
    Comparing  cllcalipso_2D.nc ...
    Comparing  clmcalipso_2D.nc ...
    Comparing  cltcalipso_2D.nc ...
    Comparing  cltlidarradar_2D.nc ...
    Comparing  ctpisccp_2D.nc ...
    Comparing  dbze94_2D.nc ...
    Comparing  meantbclrisccp_2D.nc ...
    Comparing  meantbisccp_2D.nc ...
    DIFFER : VALUES : RECORD : 1 : RECORD VARIABLE : meantbisccp
    Comparing  parasol_refl_2D.nc ...
    Comparing  tauisccp_2D.nc ...
    Comparing  tclisccp_2D.nc ...
    DIFFER : VALUES : RECORD : 1 : RECORD VARIABLE : tclisccp

This is telling you that there are differences at bit-level. Sometimes these differences are 
caused by small differences in floating-point arithmetics when using different compilers,
and are usually negligible. Therefore, if you find differences it is advised to 
run cosp_test.sh again, now with arg2=2, to see if those differences are significant.
cosp_test.sh will show the differences that are greater than the fourth signifcant digit.
You can adapt this by changing the variable PRECISION within cosp_test.sh.

Probably, a better option is to run cosp_test.sh with arg2=3. This computes the differences 
between the new and test files and store them in ~/cosp/cosp.vN.N/temp so that you can look 
at them with a visual analysis program (e.g IDL, Matlab, VCDAT). If you find that these 
differences are scientifically significant, please report them to me.

If nccmp and nco utilities are not available and cmp is used instead (arg2=0), 
then the output will look something like this:
    [...]
    Comparing  tauisccp_2D.nc ...
    572  60  64
    573  61  71
    575  63  61
    576  61  60
    1742  60  64
    1743  61  71
    1745  63  61
    1746  61  60
    Comparing  tclisccp_2D.nc ...
    572  60  64
    573  61  71
    575  63  61
    576  61  60
    1766  60  64
    1767  61  71
    1769  63  61
    1770  61  60
    2621  77  76
    2622  63 372
    2623  63 341
    2624  65 112
    2630 200  63
    2631   0  63
    2632   1  64
    2634 263 172
    2635  63 341
    2636  64 111
    2686 346 241
    2687 146 107
    2688 150 257
    2689  77  76
    2690  63 372
    2691  63 341
    2692  65 112
    2694 200  63
    2695   0  63
    2696   1  64
    2697  77  76
    [...]

A few lines (~10) of differences as in tauisccp_2D.nc are fine, because the time stamp 
in the 'history' attribute will differ. A long list of differences like in tclisccp_2D.nc
means that the files differ. In such a case you will have to look at them with a visual 
analysis program and see if the differences are scientifically significant.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
5.- CHANGES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

5.1 - Changes in v0.2 (not released to the general public)
--------------------------------------------------------------------------------------------
1) Optimisation of initialisation of variables.
Mie tables were reloaded on each call. Variable initialisations moved into CONSTRUCT_GBX,
and GBX strucutre modified as necessary (Code provided by R. Marchand). This also includes
a correct initialisation of the temperature arrays for Ze scaling, which is only done when
not using mie table.
  
2) Minor changes to definition of variables to allow compilation in GNU Fortran 95.

3) Implemented capability of passing effective radius to the radar simulator.

4) Gaseous absorption.
Gaseous absorption is now only calculated once per gridbox. Optional arguments 
have been added to radar_simulator to allow for this.

5) Output on height levels
The standard output is on model levels. A new capability has been added to output the results on 
height levels.

6) Treatment of non-spherical particles in lidar computations
Polynomial coefficients for non spherical particles derived from a composite of
Ray-tracing theory for large particles (e.g. Noel et al., Appl. Opt., 2001)
and FDTD theory for very small particles (Yang et al., JQSRT, 2003).

7) CMOR-compliant outputs
The outputs are now written using the CMOR library, with one variable per file.

8) New outputs have been implemented:
   a) lidar_only_freq_cloud(Npoints,Nlevels): Cloud frequency of 
       occurrence as seen by CALIPSO but not CloudSat
   b) radar_lidar_tcc(Npoints): Total cloud amount as seen by radar or lidar

9) Bug fixes
Pressure was passed in hPa to lidar simulator and lmd_ipsl_stats. Now in Pa.

10) Optional outputs
A new namelist with logical flags that control which variables are written to file
has been added. This includes some flexibility in the memory allocation.
If a particular instrument is not used, the arrays that hold the output 
variables for that instrument are not allocated.

11) Change of order of levels for radar variables
In V0.1, Ze_tot and cfad_ze were swapped in cosp_io.f90, when they were written
onto disk. Now, the swap is done after calling Quickbeam for Ze_tot. This also changes 
the order in cfad_ze.

12) Deleted fr_hydro from type cosp_subgrid.
That array is not used and it would grab a lot of memory.

13) The ISCCP simulator (v3.7) has been added.

5.2 - Changes in v0.3
--------------------------------------------------------------------------------------------
1) Sanity checks of input variables
Several calls to the subroutine cosp_input_check are included in subroutine cosp (cosp.f90)
that check the limits of many of the inputs.

2) Bug fixes
k2 was defined as integer instead of real. Flip of Reff before calling quickbeam so that the
first row is at the top. Assigment of dimensions in cosp_stats.

3) ISSCP simulator outputs are flipped before they are written out. In V0.2, this was done
by the CMOR library.

4) Changes in actsim/lidar_simulator.f90:
* definition q_part changed (now in-cld water content in input of the routine, so
we remove the division by the cloud fraction). Cloud fraction arguments ls_cldf 
and cv_cldf removed from input arguments because of this.
* depolarisation removed (also from the output arguments)
* header: misleading (0 or 1) removed in description of frac_out (because it 
should be the actual output from scops, which is either 0, 1 or 2)
* parasol module added (see below)

5) Redefined bin boundaries in scattering ratio CFAD (in actsim/lmd_ipsl_stats.f90)

6) In cosp_lidar.f90:
* Instructions "Call for large-scale cloud" removed -> sgx%frac_out is used instead.
* Call to lidar_simulator changed (lsca, gbx%cca and depol removed; frac_out
changed in sgx%frac_out)

7) The labels of layered cloud fractions was wrong, now corrected.
(before: low was actually mid, mid was high, high was total, total was low)

8) New PARASOL diagnostics added. This can be switched off by setting ok_parasol=.false. in
actsim/lidar_simulator.f90. PARASOL-like reflectance at 865 nm for 5 solar zenith
angles (SZAs) added to the list of outputs.

5.3 - Changes in v0.4 (not released to the general public)
--------------------------------------------------------------------------------------------
1) Changes to Makefile.
 + -I$(ISCCP_PATH) option added to scops.o that prevented COSP
 to be build in some compilers (e.g. g95).
 + Deleted the use of CDMS_LIB and UDUNITS_LIB (see reason below)
 
2) Change of units in boxptopisccp before is passed to CMOR.
CMOR can be built without CDMS and UDUNITS. This makes the
build process of COSP much easier as UDUNITS and CDAT are not
needed any more. boxptopisccp was the only variable that was using
that capability.

3) New module that includes a MISR simulator.
This module produces a new diagnostic, clMISR. This is the Tau-CTH histogram of
the cloud fraction as calculated by the MISR Simulator. The axes have 7 and 16
bins for tau and cloud top height, respectively. This module and the output
diagnostic can be switched off/on using the logical flags Lmisr_sim and LclMISR, 
in the COSP_OUTPUT namelist.

4) ISCCP simulator changed to version 3.8.
This version of the simulator adds the capability of outputting two new 
diagnostic variables: the grid-box mean of the 10.5 micron 
infrared brightness temperature for all-sky and clear-sky conditions. 
These variables are called "meantb" and "meantbclr".
See ISCCP simulator readme file for more details.

5) Effective radius and mixing ratios treated consistently.
Type COSP_SUBGRID now includes Reff as 4-D array (Npoints,Ncolumns,Nlevels,Nhydro), 
which makes it consistent with mixing the ratios. This will allow for sub-grid 
variability to be included in the future.

6) Possibility of using precipitation mixing ratios.
There is a new logical flag in the COSP_INPUT namelist (use_precipitation_fluxes) 
that controls the use of precipitation fluxes/mixing ratios.

7) Graupel added to precipitating hydrometeor.
Graupel has been included as precipitating hydrometeor, via fl_lsgrpl in the 
netcdf input files, and stored internally in gbx%grpl_ls.
It is treated as large-scale precipitation in the subgrid overlapping distribution.

8) New script, cosp_test.sh, that compares your outputs with the expected outputs.
Please see Section 4 for details.

9) Optimisations
Subroutine pf_to_mr has been optimised slightly.

10) New logical flag, use_reff, added.
This flag controls the use of the effective radius array by the radar simulator.
If true, then that array is used, otherwise the defaults are used. Note that 
this array is always used by the lidar simulator, so it has to be properly filled 
irrespective of the value of use_reff.
        
11) Use of COSP in 'cloud resolving mode' (Ncolumns=1) using the same interface.
In previous versions, if users wanted to use COSP in this mode, they had to bypass 
the module COSP and call directly COSP_SIMULATOR. Now this can be done just by 
using Ncolumns=1. There are a few things you need to be aware when using this mode:
   a) The use of precipitation fluxes is not supported, so the input variables fl_lsrain, 
      fl_lssnow, fl_lsgrpl, fl_ccrain, and fl_ccsnow must contain mixing ratios. The 
      logical flag use_precipitation_fluxes has to be set to .false. or an error 
      message will be issued.
   b) The optical depth (emmissivity) of all clouds must be passed using dtau_s (dem_s).
      This is relevant if the ISCCP or MISR simulators are switched on.
   c) The lidar simulator is currently limited to 4 cloud hydrometeors (2 liquid, 2 ice). 
      All the cloud mixing ratios have to be condensed into 4, and passed by using the
      arrays mr_lsliq, mr_ccliq for liquid and mr_lsice,mr_ccice for ice.

12) Changes in integration the lidar equation
The accumulated optical depth for layer k contained the contribution from layers 
k to nlevels. This caused problems in the cloud identification, like false 
positives in clear areas under medium-thickness clouds. The vertical integration 
of the lidar equation has been modified to get more realistic values of 
ATB (and SR) in presence of optically thick clouds.
As a consequence of this, several changes have been done:
 a) The cloud detection based on the "first fully attenuated layer 
    encountered from above" has been removed. This removes the false 
    cloud detection mentioned above.
 b) The SR threshold value used to detect cloud has been changed from SR=3
    to SR=5 (to allow a better comparison with day-time Calipso data that are
    more noisy than night-time ones).
 c) The values of SR used to built the diagnostic "diagSR" have been changed
    again (but not the number of bins) to cover the variability
    observed and simulated (after the lidar equation modification).

13) New outputs.
The subcolumn cloud configuration produced by SCOPS (frac_out) and the lidar molecular 
backscatter (beta_mol532) have been added to the list of outputs. They are controlled 
by the logical flags Lfrac_out and Lbeta_mol532, respectively. These variables can 
be useful for debugging purposes, but are not recommended as standard output.

14) Rank of beta_mol reduced to save memory. The variable that holds beta_mol had dimensions 
(Npoints,Ncolumns,Nlevels). The second dimension is redundant as it is a gridbox-mean 
quantity. That dimension has been deleted and the statistical routines modified accordingly.

15) Bug fixes when USE_VGRID=.true. Changes in cosp_stats.f90.
  a) Use of correct dimension for ph_in(Npoints,1,Nlevels) in the 
     allocate statement.
  b) Calls to cosp_change_vertical_grid protected by if statements.
  c) Fix treatment of log_units in cosp_change_vertical_grid.

16) Added default grid when for CSAT_VGRID=.false. (and USE_VGRID=.true.).
In previous versions, the user was responsible for filling the structure 
vgrid (type (cosp_vgrid)) if the standar CloudSat grid was not used.
Now, a default vertical grid with constant step between 0 and 20 km is created.
The grid spacing is controlled by the namelist variable NLR.

17) Section 7 has been added to this README file.

18) Changes required to compile and run with NAG f95. 
  a) Inclusion of KIND statements in Quickbeam for portability.
     KR8=selected_real_kind(15,300) statements have been added 
     in several routines to allow compilation in f95 (NAG compiler), 
     instead of the  _8 format, which was not portable. This affects 
     format_input.f90, math_lib.f90, radar_simulator.f90. It would be 
     desirable to put this in an external module to avoid repetition 
     of the same statement.
  b) The 'intent' of the structures that carry output arguments have 
     been changed to inout. This seems to avoid automatic deallocation 
     that caused runtime errors.

19) The input and output namelists have been split in two different files.

20) Corrected bug in when flipping y%fq_isccp in cosp_isccp_simulator.f90.

21) Minor changes/bugs in the lidar simulator.
A bug found in the conversion of the parasol radiance to reflectance has
been corrected. The code has been cleaned, and depolarization is no 
longer available.

22) The COSP_INPUT and COSP_OUTPUT namelists are now in separate files:
cosp_input_nl.txt, and cosp_output_nl.txt.

5.4 - Changes in v1.0
--------------------------------------------------------------------------------------------
1) Corrected bug in cosp.f90. Reff for precipitation were filled in incorrectly.

2) Default effective radius (30 micron) for lidar simulations when use_reff==.false. and
Reff is set to 0.

3) nf90_close() used instead of ncclos() in cosp_io.f90.

4) S_cld = 5.0 in llnl_stats.f90, consistent with changes in lmd_ipsl_stats.f90.

5) Half_levels should be below full_levels.

6) ISCCP simulator version 4.0.

7) Added isccp_emsfc_lw as input argument to construct_cosp_gridbox.

8) cdms target added to Makefile. This links cosp_test with cdms and udunits, for 
those users that have a complete instalation of the CMOR library.

9) Correction of a minor bug in MISR simulator.

10) Deleted array beta_hydro from type cosp_sglidar as it was not used.

11) Added new capability of calling cosp_simulator iteratively,
with the number of points passed in in each iteration
controlled by the variable NPOINTS_IT in namelist COSP_INPUT. This has involved 
significant changes in cosp.f90, as well as the following changes:
- Deleted Reff and mr_hydro from cosp_subgrid.
- Deleted Nhydro as input argument of construct_cosp_subgrid.

12) Section 2 of this README file changed to reflect the changes in the license terms.

13) Minor change in prec_scops.f to make sure there will be convective precipitation 
when the number of columns is set to a small value (less than 20).

14) ISCCP total cloud sometimes produce values slightly greater than 1 (this is probably 
compiler-dependent). Those values are set to 1.0 in cosp_isccp_simulator.f90.

15) The look-up tables rlumA and rlumB in subroutine parasol have been updated with new values.

16) Changes to MIP tables: the attributes "axis: 1" have been removed to comply with CF conventions.

17) Minor bug fix in computation of pmol and pnorm of upper layer in lidar simulator.

5.5 - Changes in v1.1
--------------------------------------------------------------------------------------------
1) Deleted 'include netcdf.inc' from cosp_io.f90.

2) Bug fixes for the lidar simulator :
     - Computation of pmol and pnorm, thanks to Masaki Satoh: a factor 2 
       was missing. This affects the ATB values but not the cloud fraction. 

3)  Bug fixed in llnl/pf_to_mr.f. In the 5 lines defining  the output fields mx_rain_ls, 
mx_snow_ls, etc., the division by rho is placed beyond column 72, which 
means in this f77 file that it is ignored. These lines have been broken with a continuation
lines. Thanks to Richard Hemler for reporting this.

4) Section 6.3 added to this README on running COSP in Cloud Resolving Mode.

5) Section 6.4 added to this README on the configuration for CFMIP-2.

5.6 - Changes in v1.2
--------------------------------------------------------------------------------------------
1) HCLASS_CP set to 0 in cosp_constants.f90. Comment added to note that this is not used by COSP.

2) Added call to construct_cosp_sghydro in cosp.f90. This only affects when NCOLUMNS=1.

3) cosp.f90: The error exit on condition use_reff=.true. and Reff==0.0 has been deleted. This 
 caused trouble when calling COSP iteratively passing a small number of profiles. In this 
 case, there may be iterations with no cloud in all profiles, causing COSP to stop.

4) The timing messages from cosp_simulator.f90 have been commented out to avoid too much
information get printed to the screen. Users who need to know the timing can uncomment them.

5) lmd_ipsl_stats.f90: Warning message regarding PARASOL being valid only over ocean deleted.
This avoids too many warning messages get printed to the screen, specially for those running
in CRM mode.

6) Subroutine cosp_lidar_only_cloud (llnl_stats.f90): Variables lidar_only_freq_cloud and tcc
were not initialised. This produced the wrong results when calling COSP iteratively without 
reinitialising the output structures.

7) Values of SZA in PARASOL reflectance were indices. Now correct values in degrees (0,20,40,60,80).

8) cosp_stats.f90: in subroutine COSP_CHANGE_VERTICAL_GRID, r is now initalised to R_UNDEF. This avoids
a  Floating Point Exception (divide by zero).

9) New MODIS simulator. The simulator is controlled with the logical flag Lmodis_sim in cosp_output_nl.txt.
Fifteen new variables have been added to the list of outputs.

10) Cloud fractions are now in %. The change of units is done in cosp_simulator.f90.

11) The allocation and deallocation of mt_ttl and mt_tti has been deleted. These global arrays have been 
made of fixed shape (non-allocatable) to avoid problems when running in shared memory mode. This implies that
now there is no possibility of running Quickbeam with Mie tables (this option was not used before, anyway).

12) Possibility of running RTTOV within COSP. Please see section 6.6 below.

13) Changes to comply with CMIP5 experiments. The MIP table COSP_table_1D has been replaced by CMIP5_cf3hr. This table
contains the variable definitions of one of the latest revisions of CMOR2, plus additional variables for the simulators
that are not requested by CMIP5. The main changes between these two tables are:
   - Some of the variables have been renamed.
   - Coordinate height_mlev changed to alevel, and units defined as 1.
   - scat_ratio renamed to scatratio.
   - Last value in ISCCP_TAU changed from 50000.0 to 100.0.
   - Coordinate pressure2 renamed to plev7.
   - Coordinate sza renamed to sza5.
   - MISR_CTH_BNDS and MISR_CTH converted from km to m.
   - Coordinate cloud_top_height renamed to cth16.
   - Coordinate time renamed to time1.
   - START_DATE added to CMOR namelist (cosp_cmor_nl.txt).
   - cloud fractions changed to %.
   
14) The namelists in cfmip2 directory have been updated with the new variable names.

5.7 - Changes in v1.2.1
--------------------------------------------------------------------------------------------
1) Some of the file extensions have changed to .F90 so the they are preprocessed automatically.

2) Bug fix to avoid CALIPSO cloud fractions of zero set to undefined. Changes applied to 
cosp_simulator.f90. Thanks to J. Cole for reporting this bug.

3) Three new diagnostics added to MODIS: low-, mid-, and high-level cloud fractions.

5.8 - Changes in v1.2.2
--------------------------------------------------------------------------------------------
1) Changes to the CloudSat and CALIPSO CFADs.
When an evenly-spaced vertical grid was used (USE_VGRID=.true), 
then the CFAD values at the levels in the new grid that fell below the surface were set to 0.
This is not correct, and now they are set to R_UNDEF, to distinguish them from those bins whose 
value is actually 0. This impacted many land points, basically all with with altitude greater
than 480 m. This was particularly relevant when computing the average CFAD over a region that
contained both land and sea points. The frecuency of occurrence at lower levels would be
underestimated due to the contribution of the zeroes from the land regions.

2) Bug-fix in cosp_stats.f90. sglidar%beta_mol is copied within the Llidar_sim if statement to
avoid a mismatch in the shape of the arrays when Llidar_sim=.false..

3) Bounds added to time coordinate.

4) ISCCP_TOPHEIGHT_DIRECTION set to 2 in the COSP_INPUT namelist. This is the default value since
 V4.0 of the ISCCP simulator. Thanks to R. Heimler for reporting this. This has been updated in the 
 namelists in ./cfmip2.

5) nsizes changed from integer*4 to integer in quickbeam/dsd.f90. Thanks to J. Cole for reporting this.

6) cosp_test.sh: two additional arguments added. Test and output directories are now 
requested as arguments.

7) cosp_constants.f90: DBZE_MAX has been increased from 30.0 to 80.0. This may introduce soma changes in your
  CloudSat CFADs if you model produces reflectivities grater than 30 (very unlikely).

8) The directory 'outputs_test' has been replaced by two directories, 'outputs_test.mlev' and
 'outputs_test.slev'. The .mlev directory contains the test outputs for model level outputs, and 
 the .slev for the standard 40 levels outputs.

9) MODIS simulator: Minor bug fixes. Retrieved 
CloudTopPressure, retrievedSize and retrievedTau set
 to R_UNDEF (rather than 0.0) in subroutine modis_L2_simulator_twoTaus when cloudMask is 
.false..
 This would be consistent with the way ISCCP handles the equivalent fields, and makes it apparent in the plots 
 where MODIS is seeing clouds.
 
10) USE_VGRID=.true. use as default in COSP_INPUT namelist.

5.9 - Changes in v1.3
--------------------------------------------------------------------------------------------
1) MODIS simulator: LWP_conversion multiplied by 1000. This affects iwpmodis and lwpmodis, which are now output in the
  correct units (kg m-2).

2) Bug fix in NC_READ_INPUT_FILE: surface emmisivity was not read properly. This impacted some of the ISCCP and MODIS
  diagnostics. This affects the following variables: albisccp, boxptopisccp, boxtauisccp, clisccp, cllmodis, clmmodis, clmodis, cltisccp, meantbclrisccp, meantbisccp, pctisccp, pctmodis, tauisccp. This only affects results that were 
  created with the off-line version.

3) In NC_READ_INPUT_FILE: added error trapping in all calls to NetCDF routines.

4) sunlit was set always to 1 in cosp_test.F90. This has been fixed and it is now properly filled from the input file.

5) ISCCP simulator upgraded to version 4.1. This fixes a bug where the cloud temperature is greater than any temperature in the troposphere.

6) Bug fix in NC_WRITE_COSP_1D/2D. Trim input arguments to cmor_setup and cmor_dataset. This solves problems with CMOR2rc9/10.

6) Bux fix in MODIS. Small bug in the way the MODIS simulator included in COSP calculates cloud top pressure, in function cloud_top_pressure. Also, a slightly increase efficiency by changing how Cloud_Top_Pressure_Total_Mean is computed in modis_L3_simulator.

7) RTTOV instructions have been updated, in Section 6.6 of this Makefile.

8) New global attribute cosp_version in output files generated with CMOR2.

9) The vertical interpolation routine COSP_CHANGE_VERTICAL_GRID has been optimised for NEC SXs (thanks, Tokuta!). Please see how to switch them on in Section 6.8.

10) Tabs have been replaced with spaces to avoid issues with some compilers.

11) Most of the unused variables have been deleted.

12) rttov_multprof has been put into a module, cosp_rttov.F90.

13) Bug fix in READ_COSP_OUTPUT_NL. The logical flags for the radar&lidar joint diagnostics were not correctly set. They both were set to .true. whenever one of them was requested (and the radar and lidar simulators were on, as needed).

14) If statement added in NC_WRITE_COSP_1D to avoid calling cmor_axis for axes that are not defined in CMIP5_cf3hr. This is not very elegant but works for the CFMIP2 offline experiments.

15) New variables BRANCH_TIME, PARENT_EXPERIMENT_ID, FORCING, INSTITUTE_ID added to CMOR namelist, as requested by the CMOR2 MIP tables for CMIP5.

5.10 - Changes in v1.3.1
--------------------------------------------------------------------------------------------
1) Changes in CMOR output to produce data compliant with the CMIP5 table cf3hr. Latitude and longitude are now
   coordinate variables in each file. New 1D variable produced, toffset.
2) Changes in cosp_rttov to make it compatible with integers promoted to 64-bit. This involves some type-casting.
3) cosp.F90. Added comments that allow to set the seed the way it was done in the ISCCP simulator.
4) The effective radius is now computed by cosp_precip_mxratio, if not supplied as input. This fixes an inconsistency
   when Reff=0.0 and use_precipitation_fluxes=.true. Two new data statements have been added to cosp that define
   gamma_3 and gamma_4, as explained in Section 3 of the user's manual
5) New capability for processing multiple time steps. Please see Section 6 of the user's manual.
6) New text file that gives information on installation in a Mac. See section 6.9 of this README.txt. Thanks to Mike Bauer.
7) New optional variable (verbosity) added to NC_READ_INPUT_FILE. Not used by default. Set this to 1 in the call to 
   NC_READ_INPUT_FILE in cosp_test if you want more information on variables read.
8) Bug fix. Initialise values of axis ids that may not be used in NC_READ_INPUT_FILE.
9) Bug fix. Change of lidar CFAD scattering ratio bounds.
10) New CMOR global attributes: parent_experiment_rip, initialization_method, and physics_version. They are set
    in CMOR namelist.
11) Several standard names have been added to table COSP_table_2D.
12) COSP_table_1D has been updated to keep it parallel to CMIP5_cf3hr.
13) Changes to user's manual.
14) Minor modifications in MODIS simulator to help compilation in some compilers.
15) Extra tau bin (tau<0.3) has been included in MODIS simulator, this makes the MODIS and ISCCP histograms consistent.
    Necessary modifications have been made to the 1D and 2D MIP tables.
16) The CFMIP2 namelists in the cfmip2 directory have been updated to reflect the latest changes.

5.11 - Changes in v1.3.2
--------------------------------------------------------------------------------------------
1) Bug fix in modis_simulator.F90. Runtime error in Lahey compilers when using negative arguments to
  log10. No impact in results as these values were masked out. More details in message sent
  to the users group (2011/02/25).
2) Deleted call to flush subroutine in modis_simulator.F90.
3) Minor correction of this README, section 4.2.
4) Changes to cosp_io.F90. If surface emissivity is not present in input file then it is set to 1.0,
   and a warning message is issued.
5) N_MAX_INPUT_FILES increased to 10000 in cosp_test.F90. The value of this constant can be modified
   to suit the user requirements.
6) Bug fix in cosp_stats.F90/COSP_CHANGE_VERTICAL_GRID. dz goes out of bounds in certain configurations.
   More details in message sent to the users group (2011/03/22).

5.11 - Changes in v1.4
--------------------------------------------------------------------------------------------
1) Improvements in radar simulator:
  - New attenuation integration scheme, possibility of using a look up table, partial support of two-moment microphysics.
  - Several optimisations.
  - Optimisations in gaseous absorption.
  - Selection of microphysics via cosp_defs.h.
2) Optimised version of cosp_change_vertical_grid in cosp_stats.

3) New timing variables that estimate the performance of each simulator.

4) New CALIPSO cloud phase diagnostics.
  - A large list of new cloud diagnostics developed by Gregory Cesana (reference: Cesana G. and H. Chepfer (2013), J. Geophys. Res., doi: 10.1002/jgrd.50376.)
5) Deleted support for CMOR1.
6) Restructure of calls to CMOR functions. A new, improved append mode is used in the the off-line version (see changes in cosp_test.F90).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
6.- ADDITIONAL NOTES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
6.1 - Using the NAG f95 compiler
--------------------------------------------------------------------------------------------
In addition to the changes described in item section 5.3(18) for v0.4, the NAG compiler does not support
the FLUSH subroutine (it is not f95 standard). If you want to use this compiler, then you'll need 
to comment out the call to this subroutine in icarus.f (ISCCP simulator).

6.2 - Running COSP in Cloud Resolving Mode (Ncolumns=1)
--------------------------------------------------------------------------------------------
In addition what it is said in section 5.3.11, if you want to run COSP in CRM mode, you will 
need to fill in gbx%mr_hydro with the appropriate precipitation mixing ratios in the driver
program. This can be done by changing the following lines in cosp_test.f90

from
        gbx%mr_hydro(:,:,I_CVCICE) = mr_ccice
        gbx%rain_ls = fl_lsrain
        gbx%snow_ls = fl_lssnow
        gbx%grpl_ls = fl_lsgrpl
        gbx%rain_cv = fl_ccrain
        gbx%snow_cv = fl_ccsnow

to
        gbx%mr_hydro(:,:,I_CVCICE) = mr_ccice
        gbx%mr_hydro(:,:,I_LSRAIN) = fl_lsrain
        gbx%mr_hydro(:,:,I_LSSNOW) = fl_lssnow
        gbx%mr_hydro(:,:,I_LSGRPL) = fl_lsgrpl

6.3 - Configuration of COSP for CFMIP-2
--------------------------------------------------------------------------------------------
The directory ./cfmip2 contains the namelists with the configuration for the CFMIP-2 experiments.
These files are also available on the CFMIP web site.
There are two different configurations:
a) Long time series (*long_inline.txt). This is the configuration for the 30 yr monthly and daily 
means from ISCCP and CALIPSO/PARASOL. These are global gridded data computed from model gridded inputs, 
with the simulators run inline.

b) Short time series (*short_offline.txt). This is the configuration for the 1 yr time series, both
for the curtain outputs and global gridded monthly means from curtain outputs.
Outputs from CloudSat and CALIPSO/PARASOL are requested.

6.4 - Using your own cloud generator/subgrid variability in hydrometeor water contents
--------------------------------------------------------------------------------------------
If your model requires different overlapping assumptions or the water contents, particle sizes, optical thickness and emissivities, are not horizontally homogeneous, then you will have to make modifications to the code. Below is a list 
of things that Jason Cole did to make it work in his model. Below I attach an the e-mail where he explains the steps 
he followed to do this.

1. Commented out calls to SCOPS in cosp.f90.

2. COSP_TYPES
Added new arrays to subgrid data type "COSP_SUBGRID"

      real,dimension(:,:,:),pointer :: mr_liq ! Non-precipitating cloud liquid mixing ratio
      real,dimension(:,:,:),pointer :: mr_ice ! Non-precipitating cloud ice mixing ratio
      real,dimension(:,:,:),pointer :: reff_liq ! Non-precipitating cloud liquid effective radius
      real,dimension(:,:,:),pointer :: reff_ice ! Non-precipitating cloud ice effective radius
      real,dimension(:,:,:),pointer :: dtau_s   ! Stratiform cloud optical thickness at ~0.65 microns
      real,dimension(:,:,:),pointer :: dtau_c   ! Convective cloud optical thickness at ~0.65 microns
      real,dimension(:,:,:),pointer :: dems_s   ! Stratiform cloud emissivity at ~10.5 microns
      real,dimension(:,:,:),pointer :: dems_c   ! Convective cloud emissivity at ~10.5 microns

3. CONSTRUCT_COSP_SUBGRID
Allocate the new arrays
      allocate(y%mr_liq(Npoints,Ncolumns,Nlevels))
      allocate(y%mr_ice(Npoints,Ncolumns,Nlevels))
      allocate(y%reff_liq(Npoints,Ncolumns,Nlevels))
      allocate(y%reff_ice(Npoints,Ncolumns,Nlevels))
      allocate(y%dtau_s(Npoints,Ncolumns,Nlevels))
      allocate(y%dtau_c(Npoints,Ncolumns,Nlevels))
      allocate(y%dems_s(Npoints,Ncolumns,Nlevels))
      allocate(y%dems_c(Npoints,Ncolumns,Nlevels))

4. FREE_COSP_SUBGRID
Make sure to deallocate the arrays
      deallocate(y%prec_frac, y%frac_out, y%mr_liq, y%mr_ice,
     1           y%reff_liq, y%reff_ice, y%dtau_s, y%dtau_c,
     2           y%dems_s, y%dems_c)

5. I have a "driver" code that is based heavily on "cosp_test.f90" which is provided the fields from the GCM which are assigned to the appropriate variables before calling "cosp" and then assigns the fields from cosp into variables used by the GCM.  For example,

      SUBROUTINE COSP_SIM_DRIVER(
     +                           ICCF,       ! TOTAL CLOUD FRACTION 
ISCCP/COSP (OUTPUT)
...
         call construct_cosp_misr(cfg,Npoints,misr)

        
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ! Compute various fields from GCM input
        
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!         print *, 'Generating necessary fields....'
         call create_fields_cosp(gbx,      ! OUTPUT
     +                           sgx,
     +                           CLW_SUB,  ! INPUT
     +                           CIC_SUB,   
     +                           REL_SUB,   
....
        
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ! Call simulator
        
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!         print *, 'Calling simulator...'
         call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,
     1             isccp,misr,stradar,stlidar)
...

      END SUBROUTINE COSP_SIM_DRIVER

Within the subroutine "create_fields_cosp" I make sure that the duplicate fields in the structures "sgx" and "sghydro" are consistent.  
For example, sgx%reff_liq and sghydro%Reff(:,:,:,I_LSCLIQ) have the same values, etc..

6. COSP_LIDAR
Instead of passing gbx%Reff(:,:,I_LSCLIQ), etc pass the subgrid-scale values located in sghydro%Reff(:,i,:,I_LSCLIQ)

7. ICARUS
The call to "icarus" are changed slightly so that the subgrid-scale emissivities and optical thicknesses are passed in:

Original:
  call icarus(0,0,gbx%npoints,sunlit,gbx%nlevels,gbx%ncolumns, &
            pfull,phalf,qv,cc,conv,dtau_s,dtau_c, &
            gbx%isccp_top_height,gbx%isccp_top_height_direction, &
            gbx%isccp_overlap,frac_out, &
            
gbx%skt,gbx%isccp_emsfc_lw,at,dem_s,dem_c,y%fq_isccp,y%totalcldarea, &
            y%meanptop,y%meantaucld,y%meanalbedocld, &
            y%meantb,y%meantbclr,y%boxtau,y%boxptop)

New:
      call icarus(0,0,gbx%npoints,sunlit,gbx%nlevels,gbx%ncolumns,
     1 pfull,phalf,qv,cc,conv,sgx%dtau_s,sgx%dtau_c,
     2 gbx%isccp_top_height,gbx%isccp_top_height_direction,
     3 gbx%isccp_overlap,frac_out,
     4 gbx%skt,gbx%isccp_emsfc_lw,at,sgx%dems_s,sgx%dems_c,y%fq_isccp,
     5 y%totalcldarea, y%meanptop,y%meantaucld,y%meanalbedocld,
     6 y%meantb,y%meantbclr,y%boxtau,y%boxptop)

The file icarus_modified.f shows the changes needed in icarus.f.

6.5 - Incorporating RTTOV in COSP
--------------------------------------------------------------------------------------------
RTTOV is a fast radiative transfer code that provides radiances (and optionally the jacobians) for many infrared and passive microwave sensors. As it is not distributed under an open software license, it is not distributed as part of COSP, althoug it  can be included as an option.
Version 9_1 of RTTOV was released in March 2008 and is available to licensed users free of charge. To become
a licensed user of RTTOV v9, first you will need to register to access the specialist science area of the Met Office:
http://www.metoffice.gov.uk/science/creating/register.html

Then, please send a request using the RTTOV-9 Request Form:
http://www.metoffice.com/research/interproj/nwpsaf/request_forms/request_rttov_9.html

Please follow the instructions to build  RTTOV in your system. 

To build RTTOV within COSP, follow these steps:

1) Build the RTTOV library, following RTTOV instructions. Basically, you will need to execute the following commands in rttovXX/src directory 

../build/Makefile.PL
export ARCH=<architecture>
make all


2) Modify the following environment variables in your COSP Makefile to point
to your local build of RTTOV:
RTTOV_PATH     = /data/cr2/hadac/software/rttov
RTTOV_LIB_PATH = $(RTTOV_PATH)/rttov92.$(F90)/lib 
RTTOV_INC_PATH = $(RTTOV_PATH)/rttov92.$(F90)/include 
RTTOV_MOD_PATH = $(RTTOV_PATH)/rttov92.$(F90)/mod 

3) Modify the following environment variables in your COSP Makefile to point to your local build of RTTOV:
RTTOV_PATH     = /data/cr2/hadac/software/rttov
RTTOV_LIB_PATH = $(RTTOV_PATH)/rttovXX.$(F90)/lib RTTOV_INC_PATH = $(RTTOV_PATH)/rttovXX.$(F90)/include
RTTOV_MOD_PATH = $(RTTOV_PATH)/rttovXX.$(F90)/mod 

4) Depending on the RTTOV version you use, you may need to change the name of the RTTOV library in the make file. Search for llrttov9.1 and replace it with the correct version.

5) Uncomment the following line in cosp_defs.h:
#define RTTOV rttov

6) Run 'make rttov'

7) From your COSP directory, make soft links to the spectral files:
ln -s $RTTOV_PATH/rtcoef/*.dat .

We have tested COSP with RTTOV9, so it is discouraged to use any other version of RTTOV.

The logical Lrttov_sim, in cosp_output_nl.txt switches on/off RTTOV within COSP. 
Ltbrttov switches on/off the RTTOV outputs, i.e. the brighness temperatures. 
The COSP input arguments that control which instrument and channels you want to 
simulate are found in cosp_input_nl.txt, below the lines
  !----------------------------------------------------------------------------------
  !-------------- RTTOV inputs
  !----------------------------------------------------------------------------------
The possible values for the arguments Platform, Satellite, Instrument, Nchannels, Channels can
be found in the RTTOV documentation.

NOTE: the current implementation of RTTOV in COSP only computes clear-sky brightness temperatures. All sky support will be
added in the future.

6.6 - Running COSP on vector computers
--------------------------------------------------------------------------------------------
Since v1.3, COSP includes some optimisations for the vector architectures (tested on NEC SXs). These are protected by #ifdef SYS_SX directives. If you want to switch them on, please uncomment the line 

#define SYS_SX sys_sx

in cosp_defs.h.

Thanks to Tokuta Yokohata, Teruyuki Nishimura and Koji Ogochi for providing these optimisations.

6.7 - Installing COSP in Mac computers
--------------------------------------------------------------------------------------------
The file mac_info.txt contains information on the installation process in a Mac computer. This is a step-by-step 
process for a particular installation in one computer, so it may not be general. It contains information on the 
installation of all the libraries required. Thanks to Mike Bauer for providing this.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
7.- OBSERVATIONAL DATASETS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

7.1 - GCM Oriented Calipso Cloud Product
--------------------------------------------------------------------------------------------
LMD have prepared the Calipso/Parasol observational datasets, which
are fully consistent with COSP outputs. This work has been done in
collaboration with the PIs of the two missions (D. Winker for Calipso and
D. Tanre for Parasol). These observational datasets are available on
http://climserv.ipsl.polytechnique.fr/cfmip-atrain.html.

# ALCF-COSP

COSP is the Cloud Feedback Model Intercomparison Project
([CFMIP](https://www.earthsystemcog.org/projects/cfmip/)) Observation Simulator
Package.

This is a fork of [CFMIP/COSPv1](https://github.com/CFMIP/COSPv1) for use with
the Automatic Lidar and Ceilometer Framework
([ALCF](https://alcf-lidar.github.io)). It includes support for a surface
lidar and additional lidar wavelengths: 532 nm, 910 nm and 1064 nm.

Known issues:

- No precipitation or aerosol simulation (not present in COSPv1).

Additional COSP configuration options:

- `surface_lidar` – Surface lidar switch (1 – surface, 0 – spaceborne)
- `lidar_wavelength` – Lidar wavelength (nm)

See the original [README](README.txt) for more information.

Release notes
-------------

### 1.1.0 (2023-04-22)

- Radar scheme information is not printed to prevent output clutter.

### 1.0.0 (2021-11-30)

- CMOR dependencies removed to simplify installation.

1/24/2015 (Dustin Swales):
A small fix was made to MODIS/moid_simulator.F90. The patch for inline COSP has also been updated
The following were added @ lines 539-541 of MODIS/moid_simulator.F90
+    Cloud_Fraction_Total_Mean(1:nPoints) = Cloud_Fraction_Total_Mean(1:nPoints) /nSubcols
+    Cloud_Fraction_Ice_Mean(1:nPoints)   = Cloud_Fraction_Ice_Mean(1:nPoints)   /nSubcols
+    Cloud_Fraction_Water_Mean(1:nPoints) = Cloud_Fraction_Water_Mean(1:nPoints) /nSubcols

module main_module
    use cosp_run_mod
    use nc_utils
    implicit none
contains
    function arg(i)
        integer, intent(in) :: i
        character(len=:), allocatable :: arg
        integer :: len

        call get_command_argument(i, arg, len)
        allocate(character(len=len) :: arg)
        call get_command_argument(i, arg, len)
    end function

    subroutine read_input(file, input, time, time_bnds)
        character(len=*), intent(in) :: file
        type(cosp_input_fields), intent(out) :: input
        real(8), dimension(:), allocatable, intent(out) :: &
            time
        real(8), dimension(:,:), allocatable, intent(out) :: &
            time_bnds
        integer :: ncid
        real(8), dimension(:), allocatable :: &
            lon, &
            lat, &
            ps, &
            orog
        real(8), dimension(:,:), allocatable :: &
            zfull, &
            ta, &
            pfull, &
            clw, &
            cli, &
            cl
        integer :: &
            nlon, &
            nlat, &
            npoints, &
            nlev, &
            nhydro
        integer, dimension(256) :: shp
        integer :: i, j
        integer :: ilon, ilat

        call nc_check(nf90_open(file, NF90_NOWRITE, ncid))

        call nc_get_var_1d_real(ncid, 'lon', lon)
        call nc_get_var_1d_real(ncid, 'lat', lat)
        call nc_get_var_1d_real(ncid, 'time', time)
        call nc_get_var_2d_real(ncid, 'time_bnds', time_bnds)
        call nc_get_var_1d_real(ncid, 'ps', ps)
        call nc_get_var_1d_real(ncid, 'orog', orog)
        call nc_get_var_2d_real(ncid, 'zfull', zfull)
        call nc_get_var_2d_real(ncid, 'ta', ta)
        call nc_get_var_2d_real(ncid, 'pfull', pfull)
        call nc_get_var_2d_real(ncid, 'clw', clw)
        call nc_get_var_2d_real(ncid, 'cli', cli)
        call nc_get_var_2d_real(ncid, 'cl', cl)

        shp(1:2) = shape(ta)
        npoints = shp(2)
        nlev = shp(1)
        nhydro = N_HYDRO

        call allocate_cosp_input_fields(input, npoints, nlev)

        input%npoints = npoints
        input%nlevels = nlev
        input%emsfc_lw = 1.
        input%Reff = 10e-6
        input%time = 1.
        input%lon = lon
        input%lat = lat
        input%orog = orog
        input%T = transpose(ta)
        input%p = transpose(pfull)
        input%tca = transpose(cl)*0.01
        input%zlev = transpose(zfull)
        do i = 1, npoints
            input%zlev(i,:) = input%zlev(i,:) - orog(i)
        end do
        input%zlev_half(:,2:nlev) = 0.5*(input%zlev(:,1:(nlev-1)) + input%zlev(:,2:nlev))
        input%mr_hydro(:,:,1) = transpose(clw)
        input%mr_hydro(:,:,2) = transpose(cli)
        input%ph(:,2:(nlev-1)) = 0.5*(input%p(:,1:(nlev-1)) + input%p(:,2:nlev))

        do i = 1, npoints
            do j = 1, nlev
                if (input%zlev(i,j) <= 0.) then
                    input%zlev(i,j) = 0.
                    input%zlev_half(i,j) = 0.
                    input%p(i,j) = ps(i)
                    input%ph(i,j) = ps(i)
                    input%T(i,j) = 273.15
                    input%tca(i,j) = 0.
                    input%mr_hydro(i,j,:) = 0.
                else
                    input%zlev_half(i,j) = 0.
                    input%ph(i,j) = ps(i)
                    exit
                end if
            end do
        end do

        where (input%mr_hydro < 0.)
            input%mr_hydro = 0.
        end where

        call nc_check(nf90_close(ncid))
    end subroutine

    subroutine write_output(file, config, input, time, time_bnds, output)
        character(len=*), intent(in) :: file
        type(cosp_run_config) :: config
        type(cosp_input_fields), intent(inout) :: input
        real(8), dimension(:), allocatable, intent(in) :: time
        real(8), dimension(:,:), allocatable, intent(in) :: time_bnds
        type(cosp_output_fields), intent(inout) :: output
        integer :: ncid
        integer :: column_dimid, level_dimid, time_dimid, bnds_dimid
        integer :: &
            lon_varid, &
            lat_varid, &
            time_varid, &
            time_bnds_varid, &
            altitude_varid, &
            zlev_varid, &
            zlev_half_varid, &
            p_varid, &
            ph_varid, &
            beta_mol_varid, &
            beta_tot_varid
        integer :: status
        integer :: npoints, nlevels, ncolumns
        integer :: i, j, k

        npoints = input%npoints
        nlevels = input%nlevels
        ncolumns = size(output%sglidar%beta_tot, 2)

        do i = 1, npoints
            do j = 1, nlevels
                if (input%zlev(i,j) > config%lidar_max_range) then
                    do k = 1, ncolumns
                        output%sglidar%beta_tot(i,k,j) = 0.
                    end do
                    output%sglidar%beta_mol(i,j) = 0.
                end if
            end do
        end do

        do i = 1, npoints
            input%zlev(i,:) = input%zlev(i,:) + input%orog(i)
        end do

        call nc_check(nf90_create(file, 0, ncid))
        call nc_check(nf90_def_dim(ncid, 'time', npoints, time_dimid))
        call nc_check(nf90_def_dim(ncid, 'bnds', 2, bnds_dimid))
        call nc_check(nf90_def_dim(ncid, 'level', nlevels, level_dimid))
        call nc_check(nf90_def_dim(ncid, 'column', ncolumns, column_dimid))
        call nc_check(nf90_def_var(ncid, 'lon', nf90_double, time_dimid, lon_varid))
        call nc_check(nf90_put_att(ncid, lon_varid, "long_name", "longitude"))
        call nc_check(nf90_put_att(ncid, lon_varid, "standard_name", "longitude"))
        call nc_check(nf90_put_att(ncid, lon_varid, "units", "degrees_east"))
        call nc_check(nf90_def_var(ncid, 'lat', nf90_double, time_dimid, lat_varid))
        call nc_check(nf90_put_att(ncid, lat_varid, "long_name", "latitude"))
        call nc_check(nf90_put_att(ncid, lat_varid, "standard_name", "latitude"))
        call nc_check(nf90_put_att(ncid, lat_varid, "units", "degrees_north"))
        call nc_check(nf90_def_var(ncid, 'altitude', nf90_double, time_dimid, altitude_varid))
        call nc_check(nf90_put_att(ncid, altitude_varid, "long_name", "instrument altitude"))
        call nc_check(nf90_put_att(ncid, altitude_varid, "standard_name", "altitude"))
        call nc_check(nf90_put_att(ncid, altitude_varid, "units", "m"))
        call nc_check(nf90_def_var(ncid, 'zfull', nf90_double, (/level_dimid, time_dimid/), zlev_varid))
        call nc_check(nf90_put_att(ncid, zlev_varid, "long_name", "altitude of model full-levels"))
        call nc_check(nf90_put_att(ncid, zlev_varid, "standard_name", "height_above_reference_ellipsoid"))
        call nc_check(nf90_put_att(ncid, zlev_varid, "units", "m"))
        !call nc_check(nf90_def_var(ncid, 'zhalf', nf90_double, (/level_dimid, time_dimid/), zlev_half_varid))
        call nc_check(nf90_def_var(ncid, 'pfull', nf90_double, (/level_dimid, time_dimid/), p_varid))
        call nc_check(nf90_put_att(ncid, p_varid, "long_name", "pressure at model full-levels"))
        call nc_check(nf90_put_att(ncid, p_varid, "standard_name", "air_pressure"))
        call nc_check(nf90_put_att(ncid, p_varid, "units", "Pa"))
        !call nc_check(nf90_def_var(ncid, 'phalf', nf90_double, (/level_dimid, time_dimid/), ph_varid))
        call nc_check(nf90_def_var(ncid, 'backscatter', nf90_double, (/column_dimid, level_dimid, time_dimid/), beta_tot_varid))
        call nc_check(nf90_put_att(ncid, beta_tot_varid, "long_name", "total attenuated volume backscattering coefficient"))
        call nc_check(nf90_put_att(ncid, beta_tot_varid, "units", "m-1 sr-1"))
        call nc_check(nf90_def_var(ncid, 'backscatter_mol', nf90_double, (/level_dimid, time_dimid/), beta_mol_varid))
        call nc_check(nf90_put_att(ncid, beta_mol_varid, "long_name", "total attenuated molecular volume backscattering coefficient"))
        call nc_check(nf90_put_att(ncid, beta_mol_varid, "units", "m-1 sr-1"))
        call nc_check(nf90_def_var(ncid, 'time', nf90_double, time_dimid, time_varid))
        call nc_check(nf90_put_att(ncid, time_varid, "long_name", "time"))
        call nc_check(nf90_put_att(ncid, time_varid, "standard_name", "time"))
        call nc_check(nf90_put_att(ncid, time_varid, "units", "days since -4713-11-24 12:00 UTC"))
        call nc_check(nf90_put_att(ncid, time_varid, "calendar", "proleptic_gregorian"))
        call nc_check(nf90_def_var(ncid, 'time_bnds', nf90_double, (/bnds_dimid, time_dimid/), time_bnds_varid))
        call nc_check(nf90_put_att(ncid, time_bnds_varid, "long_name", "time bounds"))
        call nc_check(nf90_put_att(ncid, time_bnds_varid, "standard_name", "time"))
        call nc_check(nf90_put_att(ncid, time_bnds_varid, "units", "days since -4713-11-24 12:00 UTC"))
        call nc_check(nf90_put_att(ncid, time_bnds_varid, "calendar", "proleptic_gregorian"))
        call nc_check(nf90_enddef(ncid))
        call nc_check(nf90_put_var(ncid, lon_varid, input%lon))
        call nc_check(nf90_put_var(ncid, lat_varid, input%lat))
        call nc_check(nf90_put_var(ncid, altitude_varid, input%orog))
        call nc_check(nf90_put_var(ncid, beta_tot_varid, reshape(output%sglidar%beta_tot, (/ncolumns, nlevels, npoints/), order=(/3,1,2/))))
        call nc_check(nf90_put_var(ncid, beta_mol_varid, reshape(output%sglidar%beta_mol, (/nlevels, npoints/), order=(/2,1/))))
        call nc_check(nf90_put_var(ncid, zlev_varid, reshape(input%zlev, (/nlevels, npoints/), order=(/2,1/))))
        !call nc_check(nf90_put_var(ncid, zlev_half_varid, reshape(input%zlev_half, (/nlevels, npoints/), order=(/2,1/))))
        call nc_check(nf90_put_var(ncid, p_varid, reshape(input%p, (/nlevels, npoints/), order=(/2,1/))))
        !call nc_check(nf90_put_var(ncid, ph_varid, reshape(input%ph, (/nlevels, npoints/), order=(/2,1/))))
        call nc_check(nf90_put_var(ncid, time_varid, time))
        call nc_check(nf90_put_var(ncid, time_bnds_varid, time_bnds))
        call nc_check(nf90_close(ncid))
    end subroutine
end module

program main
    use iso_fortran_env
    use cosp_run_mod
    use main_module
    implicit none

    character(len=:), allocatable :: program_name
    character(len=:), allocatable :: input_file
    character(len=:), allocatable :: output_file
    character(len=:), allocatable :: config_file
    integer :: unit
    type(cosp_run_config) :: config
    type(cosp_input_fields) :: input
    type(cosp_output_fields) :: output
    namelist /config_nml/ config
    real(8), dimension(:), allocatable ::  time
    real(8), dimension(:,:), allocatable ::  time_bnds

    program_name = arg(0)
    if (command_argument_count() /= 3) then
        write(error_unit, "('Usage: ',a,' <config> <input> <output>')") program_name
        stop ''
    end if
    config_file = arg(1)
    input_file = arg(2)
    output_file = arg(3)

    open(newunit=unit, file=config_file, status='old')
    read(unit, nml=config_nml)
    close(unit)

    call read_input(input_file, input, time, time_bnds)
    call cosp_run(config, input, output)
    call write_output(output_file, config, input, time, time_bnds, output)
end program

! *****************************COPYRIGHT****************************
! (c) British Crown Copyright 2009, the Met Office.
! All rights reserved.
! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/icarus-scops-4.1-bsd/test_isccp_cloud_types.f $
! 
! Redistribution and use in source and binary forms, with or without 
! modification, are permitted provided that the
! following conditions are met:
! 
!     * Redistributions of source code must retain the above 
!       copyright  notice, this list of conditions and the following 
!       disclaimer.
!     * Redistributions in binary form must reproduce the above 
!       copyright notice, this list of conditions and the following 
!       disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its 
!       contributors may be used to endorse or promote products
!       derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
! 
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************

!       npoints     # of model points in the horizontal
!       nlev        # of model levels
!       ncol        # of columns each grid box is subdivided into
!       emsfc_lw    longwave emissivity of surface at 10.5 microns

          implicit none 

          integer npoints,i,j,k,nlev,ncol,ntau,npres
          real emsfc_lw

          PARAMETER(npoints=24,nlev=6,ncol=40,
     &              emsfc_lw=0.99,
     &              ntau=7,npres=7)
       
          integer itau,top_height,top_height_direction,overlap,ibox
          integer seed(npoints)
          real skt(npoints)
          real pfull(npoints,nlev)
          real at(npoints,nlev)
          real qv(npoints,nlev)
          real cc(npoints,nlev)
          real conv(npoints,nlev)
          real dtau_s(npoints,nlev)
          real dtau_c(npoints,nlev)
          real dem_s(npoints,nlev)
          real dem_c(npoints,nlev)
          real phalf(npoints,nlev+1)
          integer sunlit(npoints)

          REAL fq_isccp(npoints,ntau,npres)
          real totalcldarea(npoints)
          real meantaucld(npoints)
          real meanalbedocld(npoints)
          real meanptop(npoints)
	  real meantb(npoints)
	  real meantbclr(npoints)
          real boxtau(npoints,ncol)
          real boxptop(npoints,ncol)
          real lastboxptop
          real tb(npoints,ncol)

          integer debug
          integer debugcol
          integer ncolprint

          real frac_out(npoints,ncol,nlev) 

        write(6,*) 'Please enter top_height: '
	write(6,*) ' 1 = adjusted top IR+VIS '
	write(6,*) ' 2 = real top '
	write(6,*) ' 3 = adjusted top IR only'
	  read(5,*) top_height
	  write(6,'(i2)') top_height
	write(6,*) 'Please enter overlap type (1=max,2=rand,3=max/rand)'
	  read(5,*) overlap
	  write(6,'(i2)') overlap
	write(6,*) 'Please enter top_height_direction (1=original method,2=new method)'
	  read(5,*) top_height_direction
	  write(6,'(i2)') top_height_direction

          ncolprint=0

          do j=1,npoints 

          open(1,file='input.data',form='formatted')
          open(2,file='input.data.halved',form='formatted')

          if (j.lt.13) then
              sunlit(j)=1
          else
              sunlit(j)=0
          endif
              
          k=mod(j-1,12) + 1
          
          if (k.eq.2) then 
              read(1,*) skt(j)
              read(2,*) skt(j)
          else
              read(2,*) skt(j)
              read(1,*) skt(j)
          endif
!          write(6,'(12X,3(f12.3,4X))') skt(j)

          if (k.eq.3) then 
              read(1,*) (pfull(j,i),i=1,nlev)
              read(2,*) (pfull(j,i),i=1,nlev)
          else
              read(2,*) (pfull(j,i),i=1,nlev)
              read(1,*) (pfull(j,i),i=1,nlev)
          endif
!          write(6,'(12X,3(f12.3,4X))') (pfull(j,i),i=1,nlev)

          if (k.eq.4) then 
              read(1,*) (at(j,i),i=1,nlev)
              read(2,*) (at(j,i),i=1,nlev)
          else
              read(2,*) (at(j,i),i=1,nlev)
              read(1,*) (at(j,i),i=1,nlev)
          endif
!          write(6,'(12X,3(f12.3,4X))') (at(j,i),i=1,nlev)

          if (k.eq.5) then 
              read(1,*) (qv(j,i),i=1,nlev)
              read(2,*) (qv(j,i),i=1,nlev)
          else
              read(2,*) (qv(j,i),i=1,nlev)
              read(1,*) (qv(j,i),i=1,nlev)
          endif
!          write(6,'(12X,3(f12.3,4X))') (qv(j,i),i=1,nlev)

          if (k.eq.6) then 
              read(1,*) (cc(j,i),i=1,nlev)
              read(2,*) (cc(j,i),i=1,nlev)
          else
              read(2,*) (cc(j,i),i=1,nlev)
              read(1,*) (cc(j,i),i=1,nlev)
          endif
!          write(6,'(12X,3(f12.3,4X))') (cc(j,i),i=1,nlev)

          if (k.eq.7) then 
              read(1,*) (conv(j,i),i=1,nlev)
              read(2,*) (conv(j,i),i=1,nlev)
          else
              read(2,*) (conv(j,i),i=1,nlev)
              read(1,*) (conv(j,i),i=1,nlev)
          endif
!          write(6,'(12X,3(f12.3,4X))') (conv(j,i),i=1,nlev)

          if (k.eq.8) then 
              read(1,*) (dtau_s(j,i),i=1,nlev)
              read(2,*) (dtau_s(j,i),i=1,nlev)
          else
              read(2,*) (dtau_s(j,i),i=1,nlev)
              read(1,*) (dtau_s(j,i),i=1,nlev)
          endif
!          write(6,'(12X,3(f12.3,4X))') (dtau_s(j,i),i=1,nlev)

          if (k.eq.9) then 
              read(1,*) (dtau_c(j,i),i=1,nlev)
              read(2,*) (dtau_c(j,i),i=1,nlev)
          else
              read(2,*) (dtau_c(j,i),i=1,nlev)
              read(1,*) (dtau_c(j,i),i=1,nlev)
          endif
!          write(6,'(12X,3(f12.3,4X))') (dtau_c(j,i),i=1,nlev)

          if (k.eq.10) then 
              read(1,*) (dem_s(j,i),i=1,nlev)
              read(2,*) (dem_s(j,i),i=1,nlev)
          else
              read(2,*) (dem_s(j,i),i=1,nlev)
              read(1,*) (dem_s(j,i),i=1,nlev)
          endif
!          write(6,'(12X,3(f12.3,4X))') (dem_s(j,i),i=1,nlev)

          if (k.eq.11) then 
              read(1,*) (dem_c(j,i),i=1,nlev)
              read(2,*) (dem_c(j,i),i=1,nlev)
          else
              read(2,*) (dem_c(j,i),i=1,nlev)
              read(1,*) (dem_c(j,i),i=1,nlev)
          endif
!          write(6,'(12X,3(f12.3,4X))') (dem_c(j,i),i=1,nlev)

          if (k.eq.12) then 
              read(1,*) (phalf(j,i),i=1,nlev+1)
              read(2,*) (phalf(j,i),i=1,nlev+1)
          else
              read(2,*) (phalf(j,i),i=1,nlev+1)
              read(1,*) (phalf(j,i),i=1,nlev+1)
          endif
!          write(6,'(12X,3(f12.3,4X))') (phalf(j,i),i=1,nlev+1)

          close(1)
          close(2)
          
        seed(j)=50  ! Note you want this to vary in a GCM - see
		     ! the README file

        enddo

        debug=1     !  These should be zero when running for real
        debugcol=1  !  1 is required in the test suite, but you might want
		    !  something like 1000 if debugging in a GCM


        call ISCCP_CLOUD_TYPES(debug,
     &                         debugcol,
     &                         npoints,
     &                         sunlit,
     &                         nlev,
     &                         ncol,
     &                         seed,
     &                         pfull,
     &                         phalf,
     &                         qv,
     &                         cc,
     &                         conv,
     &                         dtau_s,
     &                         dtau_c,
     &                         top_height,
     &                         top_height_direction,
     &                         overlap,
     &                         frac_out,
     &                         skt,
     &                         emsfc_lw,
     &                         at,
     &                         dem_s,
     &                         dem_c,
     &                         fq_isccp,
     &                         totalcldarea,
     &                         meanptop,
     &                         meantaucld,
     &                         meanalbedocld,
     &                         meantb,
     &                         meantbclr,
     &                         boxtau,
     &                         boxptop
     & )

          do j=1,npoints 
          write (6,'(a5)') "j="
          write (6,'(I3)') j

          write(6,'(12X,3(f12.3,4X))') skt(j)
          write(6,'(12X,3(f12.3,4X))') (pfull(j,i),i=1,nlev)
          write(6,'(12X,3(f12.3,4X))') (at(j,i),i=1,nlev)
          write(6,'(12X,3(f12.3,4X))') (qv(j,i),i=1,nlev)
          write(6,'(12X,3(f12.3,4X))') (cc(j,i),i=1,nlev)
          write(6,'(12X,3(f12.3,4X))') (conv(j,i),i=1,nlev)
          write(6,'(12X,3(f12.3,4X))') (dtau_s(j,i),i=1,nlev)
          write(6,'(12X,3(f12.3,4X))') (dtau_c(j,i),i=1,nlev)
          write(6,'(12X,3(f12.3,4X))') (dem_s(j,i),i=1,nlev)
          write(6,'(12X,3(f12.3,4X))') (dem_c(j,i),i=1,nlev)
          write(6,'(12X,3(f12.3,4X))') (phalf(j,i),i=1,nlev+1)

          !print results
          if (top_height .eq. 1) then
          print *, '      ISCCP PCTAU DIAGRAM WITH ',
     &             'IR-VIS CLOUD TOP HEIGHT ADJUSTMENT'
          else if (top_height .eq. 2) then
          print *, '      ISCCP PCTAU DIAGRAM WITHOUT ',
     &             'CLOUD TOP HEIGHT ADJUSTMENT'
          else if (top_height .eq. 3) then
          print *, '      ISCCP PCTAU DIAGRAM WITH ',
     &             'IR ONLY CLOUD TOP HEIGHT ADJUSTMENT'
          end if
          print *, ' '
          print *, '                            TAU '
          print *, ' '
          print *, '              taumin    1.3     3.6     9.4',
     &                     '     23.     60.'
          print *, ' '
          print *, '     50 '
          write(6,'(12X,7(f4.3,4X))') (fq_isccp(j,itau,1),itau=1,7)
          print *, '    180 '
          write(6,'(12X,7(f4.3,4X))') (fq_isccp(j,itau,2),itau=1,7)
          print *, '    310 '
          write(6,'(12X,7(f4.3,4X))') (fq_isccp(j,itau,3),itau=1,7)
          print *, 'PC  440 '
          write(6,'(12X,7(f4.3,4X))') (fq_isccp(j,itau,4),itau=1,7)
          print *, '    560 '
          write(6,'(12X,7(f4.3,4X))') (fq_isccp(j,itau,5),itau=1,7)
          print *, '    680 '
          write(6,'(12X,7(f4.3,4X))') (fq_isccp(j,itau,6),itau=1,7)
          print *, '    800 '
          write(6,'(12X,7(f4.3,4X))') (fq_isccp(j,itau,7),itau=1,7)
          print *, '    sfc '
          print *, ' '
          if (top_height .ne. 2. and. top_height_direction .eq. 1) then
          print *, 'TOP HEIGHT IDENTIFIED AS LOWEST ALTITUDE OR HIGHEST'
          print *, 'PRESSURE WITH MATCHING CLOUD TOP TEMPERATURE'
          end if
	  if (top_height .ne. 2. and. top_height_direction .eq. 2) then
          print *, 'TOP HEIGHT IDENTIFIED AS HIGHEST ALTITUDE OR LOWEST'
          print *, 'PRESSURE WITH MATCHING CLOUD TOP TEMPERATURE'
          end if
	  print *, ' '
          print *, ' '
	  if (totalcldarea(j).ge.0.) then
	  write (6,'(a,f10.3)') 'totalcldarea =', totalcldarea(j)
	  else
	  write (6,'(a,e10.3)') 'totalcldarea =', totalcldarea(j)
	  end if
	  if (totalcldarea(j).gt.0.) then
	  write (6,'(a,f10.3)') 'meanptop     =', meanptop(j)
	  write (6,'(a,f10.3)') 'meantaucld   =', meantaucld(j)
	  write (6,'(a,f10.3)') 'meanalbedocld   =', meanalbedocld(j)
	  else
	  write (6,'(a,e10.3)') 'meanptop     =', meanptop(j)
	  write (6,'(a,e10.3)') 'meantaucld   =', meantaucld(j)
	  write (6,'(a,e10.3)') 'meanalbedocld   =', meanalbedocld(j)
	  end if
          if (top_height .ne. 2.) then
	  write (6,'(a,f10.3)') 'meantb =', meantb(j)
	  write (6,'(a,f10.3)') 'meantbclr =', meantbclr(j)
	  end if
	  print *, '  box #         ptop           tau  '
	  print *, ' -------       -------       -------'

          lastboxptop=-1
	  do 25 ibox = 1, ncol
            if (boxptop(j,ibox) .ne. lastboxptop) then
	      if (boxptop(j,ibox).gt.0. .or. boxtau(j,ibox).gt.0.) then
	        write(6,'(2X,i4,a,9X,f7.2,7X,f7.1)') 
     &          ibox,' - ',boxptop(j,ibox),boxtau(j,ibox)
              else
	        write(6,'(2X,i4,a,9X,e10.3,7X,e10.3)') 
     &          ibox,' - ',boxptop(j,ibox),boxtau(j,ibox)
              end if
            end if
            lastboxptop=boxptop(j,ibox)
25        continue
          print *, ' '
	  print *, ' '
	  print *, ' '

          enddo

          stop
          end

! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.3.2/quickbeam/load_hydrometeor_classes.f90 $
  subroutine load_hydrometeor_classes(Nprmts_max,dist_prmts_hydro,hp,nhclass)
  use radar_simulator_types
  implicit none
  
! Purpose:
!   Loads the hydrometeor classes to be used in calculations
!   Part of QuickBeam v1.03 by John Haynes
!   http://reef.atmos.colostate.edu/haynes/radarsim
!
! Inputs:  
!   [dist_prmts_hydro]   from data in hydrometeor class input 
!
! Outputs:
!   [hp]            structure that define hydrometeor types
!
! Modified:
!   08/23/2006  placed into subroutine form (Roger Marchand)
   
! ----- INPUT -----
  integer, intent(in) :: nhclass,Nprmts_max
  real,dimension(Nprmts_max,nhclass), intent(in) :: dist_prmts_hydro
! ----- OUTPUTS -----  
  type(class_param), intent(out) :: hp
  
! ----- INTERNAL -----  
  integer :: i
     
    hp%rho(:) = -1

    do i = 1,nhclass,1
    hp%dtype(i) = dist_prmts_hydro(1,i)
    hp%col(i) = dist_prmts_hydro(2,i)
    hp%phase(i) = dist_prmts_hydro(3,i)
    hp%cp(i) = dist_prmts_hydro(4,i)
    hp%dmin(i) = dist_prmts_hydro(5,i)
    hp%dmax(i) = dist_prmts_hydro(6,i)
    hp%apm(i) = dist_prmts_hydro(7,i)
    hp%bpm(i) = dist_prmts_hydro(8,i)
    hp%rho(i) = dist_prmts_hydro(9,i)
    hp%p1(i) = dist_prmts_hydro(10,i)
    hp%p2(i) = dist_prmts_hydro(11,i)
    hp%p3(i) = dist_prmts_hydro(12,i)
    enddo
        
!   // setup scaling arrays
    hp%fc = -999.
    hp%scaled = .false.  
    hp%z_flag = .false.
    hp%rho_eff = -999.
    hp%ifc = -9
    hp%idd = -9
   
  
  end subroutine load_hydrometeor_classes

! *****************************COPYRIGHT****************************
! (c) British Crown Copyright 2009, the Met Office.
! All rights reserved.
! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/icarus-scops-4.1-bsd/test_congvec.f $
! 
! Redistribution and use in source and binary forms, with or without 
! modification, are permitted provided that the
! following conditions are met:
! 
!     * Redistributions of source code must retain the above 
!       copyright  notice, this list of conditions and the following 
!       disclaimer.
!     * Redistributions in binary form must reproduce the above 
!       copyright notice, this list of conditions and the following 
!       disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its 
!       contributors may be used to endorse or promote products
!       derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
! 
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************

      ! $Id: test_congvec.f,v 4.0 2009/02/13 08:12:22 hadmw Exp $

       implicit none

       integer npoints,niterations,j,i
       integer i2_16,huge32,irand,overflow_32
       PARAMETER(huge32=2147483647)

       PARAMETER(npoints=100,niterations=100)
       
       integer seed(npoints)
       real ran(npoints)
       i2_16=65536

       do j=1,npoints 
          seed(j)=j*129
       enddo

       do i=1,100
       include 'congvec.f'
           write (6,'(f8.3)') (ran(j),j=1,npoints)
       enddo

      end

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/cosp_misr_simulator.F90 $
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Nov 2008 - A. Bodas-Salcedo - Initial version
!
!

MODULE MOD_COSP_MISR_SIMULATOR
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
  IMPLICIT NONE

CONTAINS


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!-------------- SUBROUTINE COSP_MISR_SIMULATOR -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_MISR_SIMULATOR(gbx,sgx,y)
  
  ! Arguments
  type(cosp_gridbox),intent(in) :: gbx  ! Gridbox info
  type(cosp_subgrid),intent(in) :: sgx  ! Subgridbox info
  type(cosp_misr),intent(inout) :: y    ! MISR simulator output
  
  ! Local variables 
  integer :: Nlevels,Npoints
  real :: dtau_s(gbx%Npoints, gbx%Nlevels)
  real :: dtau_c(gbx%Npoints, gbx%Nlevels)
  real :: at(gbx%Npoints, gbx%Nlevels)
  real :: frac_out(gbx%Npoints, gbx%Ncolumns, gbx%Nlevels)
  integer :: sunlit(gbx%Npoints)
  
  real :: zfull(gbx%Npoints, gbx%Nlevels) !  height (in meters) of full model levels (i.e. midpoints)
                                          !  zfull(npoints,1)    is    top level of model
                                          !  zfull(npoints,nlev) is bottom level of model
     
    
  Nlevels = gbx%Nlevels
  Npoints = gbx%Npoints
  ! Levels from TOA to surface
  zfull  = gbx%zlev(:,Nlevels:1:-1)
  at     = gbx%T(:,Nlevels:1:-1) 
  dtau_s = gbx%dtau_s(:,Nlevels:1:-1) 
  dtau_c = gbx%dtau_c(:,Nlevels:1:-1) 
  frac_out(1:Npoints,:,1:Nlevels) = sgx%frac_out(1:Npoints,:,Nlevels:1:-1)
  sunlit = int(gbx%sunlit)
 
  call MISR_simulator(gbx%npoints,gbx%nlevels,gbx%ncolumns,&
                     sunlit,zfull,at,dtau_s,dtau_c,frac_out, R_UNDEF, &
                     y%fq_MISR,y%MISR_dist_model_layertops,y%MISR_meanztop,y%MISR_cldarea)
            
END SUBROUTINE COSP_MISR_SIMULATOR

END MODULE MOD_COSP_MISR_SIMULATOR

! 
! Copyright (c) 2009,  Roger Marchand, version 1.2
! All rights reserved.
! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/MISR_simulator/MISR_simulator.f $
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list of 
!       conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list 
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the University of Washington nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
! BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
! SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
! INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

      SUBROUTINE MISR_simulator(
     &     npoints,
     &     nlev,
     &     ncol,
     &     sunlit,
     &     zfull,
     &     at,
     &     dtau_s,
     &     dtau_c,
     &     frac_out,
     &     missing_value,
     &     fq_MISR_TAU_v_CTH,
     &     dist_model_layertops,
     &     MISR_mean_ztop,
     &     MISR_cldarea
     & )
    

      implicit none
      integer n_MISR_CTH
      parameter(n_MISR_CTH=16)
         
!     -----
!     Input 
!     -----

      INTEGER npoints                   !  if ncol ==1, the number of model points in the horizontal grid  
                            !   else    the number of GCM grid points
                            
      INTEGER nlev                      !  number of model vertical levels
      
      INTEGER ncol                      !  number of model sub columns 
                        !  (must already be generated in via scops and passed to this
                        !   routine via the variable frac_out )
  
      INTEGER sunlit(npoints)           !  1 for day points, 0 for night time

      REAL zfull(npoints,nlev)          !  height (in meters) of full model levels (i.e. midpoints)
                                        !  zfull(npoints,1)    is    top level of model
                                        !  zfull(npoints,nlev) is bottom level of model (closest point to surface)  

      REAL at(npoints,nlev)             !  temperature in each model level (K)
 
      REAL dtau_s(npoints,nlev)         !  visible wavelength cloud optical depth ... for "stratiform" condensate
                                        !  NOTE:  this the cloud optical depth of only the
                    !     the model cell (i,j)
                    
      REAL dtau_c(npoints,nlev)         !  visible wavelength cloud optical depth ... for "convective" condensate
                                        !  NOTE:  this the cloud optical depth of only the
                    !     the model cell (i,j)
                                     
      REAL frac_out(npoints,ncol,nlev)  !  NOTE: only need if columns>1 ... subgrid scheme in use.
      
      REAL missing_value
                                 
!     ------
!     Outputs
!     ------
            
      REAL fq_MISR_TAU_v_CTH(npoints,7,n_MISR_CTH)      
      REAL dist_model_layertops(npoints,n_MISR_CTH)
      REAL MISR_cldarea(npoints)               ! fractional area coverged by clouds 
      REAL MISR_mean_ztop(npoints)             ! mean cloud top hieght(m) MISR would observe
                                   ! NOTE: == 0 if area ==0
                            

!     ------
!     Working variables 
!     ------

      REAL tau(npoints,ncol)        ! total column optical depth ... 

      INTEGER j,ilev,ilev2,ibox,k
      INTEGER itau
         
      LOGICAL box_cloudy(npoints,ncol)
      
      real isccp_taumin
      real boxarea
      real tauchk
      REAL box_MISR_ztop(npoints,ncol)  ! cloud top hieght(m) MISR would observe
      
      integer thres_crossed_MISR 
      integer loop,iMISR_ztop
      
      real dtau, cloud_dtau, MISR_penetration_height,ztest     
      
      real MISR_CTH_boundaries(n_MISR_CTH+1)
      
      DATA MISR_CTH_boundaries / -99, 0, 0.5, 1, 1.5, 2, 2.5, 3,
     c                    4, 5, 7, 9, 11, 13, 15, 17, 99 /
      
      DATA isccp_taumin / 0.3 /
    
      tauchk = -1.*log(0.9999999)
        
      !
      ! For each GCM cell or horizontal model grid point ...
      ! 
      do j=1,npoints    

         !
         !  estimate distribution of Model layer tops
         !  
         dist_model_layertops(j,:)=0

       do ilev=1,nlev 
            
        ! define location of "layer top"
        if(ilev.eq.1 .or. ilev.eq.nlev) then
            ztest=zfull(j,ilev)
        else
            ztest=0.5*(zfull(j,ilev)+zfull(j,ilev-1)) 
        endif   

        ! find MISR layer that contains this level
        ! note, the first MISR level is "no height" level
        iMISR_ztop=2
        do loop=2,n_MISR_CTH
        
            if ( ztest .gt.
     &                1000*MISR_CTH_boundaries(loop+1) ) then
        
                iMISR_ztop=loop+1
            endif
        enddo

        dist_model_layertops(j,iMISR_ztop)=
     &          dist_model_layertops(j,iMISR_ztop)+1
       enddo
    
    
         !
         ! compute total cloud optical depth for each column
         !       
       do ibox=1,ncol     
       
        ! Initialize tau to zero in each subcolum
            tau(j,ibox)=0. 
        box_cloudy(j,ibox)=.false.
        box_MISR_ztop(j,ibox)=0  
        
        ! initialize threshold detection for each sub column 
        thres_crossed_MISR=0;
       
        do ilev=1,nlev
     
             dtau=0
             
             if (frac_out(j,ibox,ilev).eq.1) then
                        dtau = dtau_s(j,ilev)
                 endif
                 
                 if (frac_out(j,ibox,ilev).eq.2) then
                        dtau = dtau_c(j,ilev)
                 end if 
                 
             tau(j,ibox)=tau(j,ibox)+ dtau
              
                     
        ! NOW for MISR ..
        ! if there a cloud ... start the counter ... store this height
        if(thres_crossed_MISR .eq. 0 .and. dtau .gt. 0.) then
        
            ! first encountered a "cloud"
            thres_crossed_MISR=1  
            cloud_dtau=0            
        endif   
                
        if( thres_crossed_MISR .lt. 99 .and.
     &              thres_crossed_MISR .gt. 0 ) then
     
                if( dtau .eq. 0.) then
        
                    ! we have come to the end of the current cloud
                ! layer without yet selecting a CTH boundary.
                ! ... restart cloud tau counter 
                cloud_dtau=0
            else
                ! add current optical depth to count for 
                ! the current cloud layer
                cloud_dtau=cloud_dtau+dtau
            endif
                
            ! if the cloud is continuous but optically thin (< 1)
            ! from above the current layer cloud top to the current level
            ! then MISR will like see a top below the top of the current 
            ! layer
            if( dtau.gt.0 .and. (cloud_dtau-dtau) .lt. 1) then
            
                if(dtau .lt. 1 .or. ilev.eq.1 .or. ilev.eq.nlev) then

                    ! MISR will likely penetrate to some point
                    ! within this layer ... the middle
                    MISR_penetration_height=zfull(j,ilev)

                else
                    ! take the OD = 1.0 level into this layer
                    MISR_penetration_height=
     &                     0.5*(zfull(j,ilev)+zfull(j,ilev-1)) - 
     &                     0.5*(zfull(j,ilev-1)-zfull(j,ilev+1))
     &                  /dtau 
                endif   

                box_MISR_ztop(j,ibox)=MISR_penetration_height
                
            endif
        
            ! check for a distinctive water layer
            if(dtau .gt. 1 .and. at(j,ilev).gt.273 ) then
     
                    ! must be a water cloud ... 
                ! take this as CTH level
                thres_crossed_MISR=99
            endif
        
            ! if the total column optical depth is "large" than
            ! MISR can't seen anything else ... set current point as CTH level
            if(tau(j,ibox) .gt. 5) then 

                thres_crossed_MISR=99           
            endif

        endif ! MISR CTH booundary not set
        
        enddo  !ilev - loop over vertical levesl
    
        ! written by roj 5/2006
        ! check to see if there was a cloud for which we didn't 
        ! set a MISR cloud top boundary
        if( thres_crossed_MISR .eq. 1) then
    
        ! if the cloud has a total optical depth of greater
        ! than ~ 0.5 MISR will still likely pick up this cloud
        ! with a height near the true cloud top
        ! otherwise there should be no CTH
        if( tau(j,ibox) .gt. 0.5) then

            ! keep MISR detected CTH
            
        elseif(tau(j,ibox) .gt. 0.2) then

            ! MISR may detect but wont likley have a good height
            box_MISR_ztop(j,ibox)=-1
            
        else
            ! MISR not likely to even detect.
            ! so set as not cloudy
            box_MISR_ztop(j,ibox)=0

        endif
                        
        endif
    
       enddo  ! loop of subcolumns
       enddo    ! loop of gridpoints
       

        !     
        !   Modify MISR CTH for satellite spatial / pattern matcher effects
    !
    !   Code in this region added by roj 5/2006 to account
    !   for spatial effect of the MISR pattern matcher.
    !   Basically, if a column is found between two neighbors
    !   at the same CTH, and that column has no hieght or
    !   a lower CTH, THEN misr will tend to but place the
    !   odd column at the same height as it neighbors.
    !
    !   This setup assumes the columns represent a about a 1 to 4 km scale
    !   it will need to be modified significantly, otherwise
        if(ncol.eq.1) then
    
       ! adjust based on neightboring points ... i.e. only 2D grid was input
           do j=2,npoints-1
            
            if(box_MISR_ztop(j-1,1).gt.0 .and. 
     &             box_MISR_ztop(j+1,1).gt.0       ) then

                if( abs( box_MISR_ztop(j-1,1) -  
     &                   box_MISR_ztop(j+1,1) ) .lt. 500 
     &              .and.
     &                   box_MISR_ztop(j,1) .lt. 
     &                   box_MISR_ztop(j+1,1)     ) then
            
                    box_MISR_ztop(j,1) =
     &                      box_MISR_ztop(j+1,1)    
                endif

            endif
         enddo
        else
         
         ! adjust based on neighboring subcolumns ....
         do ibox=2,ncol-1
            
            if(box_MISR_ztop(1,ibox-1).gt.0 .and. 
     &             box_MISR_ztop(1,ibox+1).gt.0        ) then

                if( abs( box_MISR_ztop(1,ibox-1) -  
     &                   box_MISR_ztop(1,ibox+1) ) .lt. 500 
     &              .and.
     &                   box_MISR_ztop(1,ibox) .lt. 
     &                   box_MISR_ztop(1,ibox+1)     ) then
            
                    box_MISR_ztop(1,ibox) =
     &                      box_MISR_ztop(1,ibox+1)    
                endif

            endif
         enddo
      
        endif

        !     
    !     DETERMINE CLOUD TYPE FREQUENCIES
    !
    !     Now that ztop and tau have been determined, 
    !     determine amount of each cloud type
        boxarea=1./real(ncol)  
        do j=1,npoints 

         ! reset frequencies -- modified loop structure, roj 5/2006 
         do ilev=1,7  ! "tau loop"  
            do  ilev2=1,n_MISR_CTH                      
            fq_MISR_TAU_v_CTH(j,ilev,ilev2)=0.     
            enddo
         enddo
           
         MISR_cldarea(j)=0.
         MISR_mean_ztop(j)=0.

         do ibox=1,ncol

            if (tau(j,ibox) .gt. (tauchk)) then
               box_cloudy(j,ibox)=.true.
            endif
  
            itau = 0
        
            if (box_cloudy(j,ibox)) then
    
          !determine optical depth category
              if (tau(j,ibox) .lt. isccp_taumin) then
                  itau=1
              else if (tau(j,ibox) .ge. isccp_taumin                                    
     &          .and. tau(j,ibox) .lt. 1.3) then
                  itau=2
              else if (tau(j,ibox) .ge. 1.3 
     &          .and. tau(j,ibox) .lt. 3.6) then
                  itau=3
              else if (tau(j,ibox) .ge. 3.6 
     &          .and. tau(j,ibox) .lt. 9.4) then
                  itau=4
              else if (tau(j,ibox) .ge. 9.4 
     &          .and. tau(j,ibox) .lt. 23.) then
                  itau=5
              else if (tau(j,ibox) .ge. 23. 
     &          .and. tau(j,ibox) .lt. 60.) then
                  itau=6
              else if (tau(j,ibox) .ge. 60.) then
                  itau=7
              endif
              
             endif  

       ! update MISR histograms and summary metrics - roj 5/2005
       if (sunlit(j).eq.1) then 
                     
              !if cloudy added by roj 5/2005
          if( box_MISR_ztop(j,ibox).eq.0) then
          
            ! no cloud detected
            iMISR_ztop=0

          elseif( box_MISR_ztop(j,ibox).eq.-1) then

            ! cloud can be detected but too thin to get CTH
            iMISR_ztop=1    

            fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop)=
     &            fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop) + boxarea

          else
            
            !
            ! determine index for MISR bin set
            !

            iMISR_ztop=2
            
            do loop=2,n_MISR_CTH
        
                if ( box_MISR_ztop(j,ibox) .gt.
     &                1000*MISR_CTH_boundaries(loop+1) ) then
        
                  iMISR_ztop=loop+1

                endif
            enddo
          
            if(box_cloudy(j,ibox)) then
            
               ! there is an isccp clouds so itau(j) is defined
               fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop)=
     &            fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop) + boxarea
     
            else
                ! MISR CTH resolution is trying to fill in a
                ! broken cloud scene where there is no condensate.
                ! The MISR CTH-1D-OD product will only put in a cloud
                ! if the MISR cloud mask indicates cloud.
                ! therefore we will not include this column in the histogram
                ! in reality aerosoal and 3D effects or bright surfaces
                ! could fool the MISR cloud mask

                ! the alternative is to count as very thin cloud ??
!               fq_MISR_TAU_v_CTH(1,iMISR_ztop)=
!     &                     fq_MISR_TAU_v_CTH(1,iMISR_ztop) + boxarea
            endif


            MISR_mean_ztop(j)=MISR_mean_ztop(j)+
     &                       box_MISR_ztop(j,ibox)*boxarea          

            MISR_cldarea(j)=MISR_cldarea(j) + boxarea 
 
          endif
       else
          ! Set to issing data. A. Bodas - 14/05/2010
          do loop=1,n_MISR_CTH
             do k=1,7
                fq_MISR_TAU_v_CTH(j,k,loop) = missing_value
             enddo
             dist_model_layertops(j,loop) = missing_value
          enddo
          MISR_cldarea(j) = missing_value
          MISR_mean_ztop(npoints) = missing_value

       endif ! is sunlight ?
       
       enddo ! ibox - loop over subcolumns          
      
       if( MISR_cldarea(j) .gt. 0.) then
        MISR_mean_ztop(j)= MISR_mean_ztop(j) / MISR_cldarea(j)   ! roj 5/2006
       endif

       enddo  ! loop over grid points

      return
      end 

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! $Revision: 88 $, $Date: 2013-11-13 07:08:38 -0700 (Wed, 13 Nov 2013) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/cosp_rttov_simulator.F90 $
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Aug 2008 - V. John - Initial version
! Feb 2009 - V. John - Trace gases and max number of profiles
!


#include "cosp_defs.h"
MODULE MOD_COSP_RTTOV_SIMULATOR
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
#ifdef RTTOV
  USE MOD_COSP_RTTOV
#endif
  IMPLICIT NONE

CONTAINS


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE COSP_RTTOV_SIMULATOR ---------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_RTTOV_SIMULATOR(gbx,y)
  
  ! Arguments
  type(cosp_gridbox),intent(in)  :: gbx ! Gridbox info
  type(cosp_rttov),intent(inout) :: y   ! RTTOV output
  
  ! some local variables for profile conversions etc.
  real, parameter :: eps    =  0.622
  real, parameter :: Mdry   =  28.966
  real, parameter :: Mo3    =  47.9983
  real, parameter :: Mco2   =  44.0096
  real, parameter :: Mch4   =  16.0426
  real, parameter :: Mn2o   =  44.0129
  real, parameter :: Mco    =  28.0102
  integer, parameter :: MaxLim  =  100
  
  ! Local variables 
  integer :: Npoints
  real :: sh(gbx%Npoints, gbx%Nlevels)
  real :: pp(gbx%Npoints, gbx%Nlevels)
  real :: tt(gbx%Npoints, gbx%Nlevels)
  real :: o3(gbx%Npoints, gbx%Nlevels)

  real :: co2,ch4,n2o,co
  real :: tt_surf(gbx%Npoints) ! 1.5 m T
  real :: sh_surf(gbx%Npoints) ! 1.5 m q 
  integer :: nloop,rmod,il
  integer :: istart,istop
  integer :: nprof,nlevels
    
  Nlevels = gbx%Nlevels
  Npoints = gbx%Npoints
  ! Reverting Levels from TOA to surface
  sh  = gbx%sh(:,Nlevels:1:-1) 
  pp  = gbx%p(:,Nlevels:1:-1) / 100.
  tt  = gbx%t(:,Nlevels:1:-1) 
  o3  = gbx%mr_ozone(:,Nlevels:1:-1)
  
  ! FIXME: 1.5 m T and q should be added to input
  tt_surf  =  tt(:, Nlevels)
  sh_surf  =  sh(:, Nlevels)
  
  !Converting Specific Humidity to PPMV
  sh  =  ( sh / ( sh + eps * ( 1. - sh ) ) ) * 1e6

  !Converting Mass mixing ratio of other trace gases to ppmv
  o3   =  ( Mdry / Mo3  ) *     o3  * 1e6
  co2  =  ( Mdry / Mco2 ) * gbx%co2 * 1e6
  ch4  =  ( Mdry / Mch4 ) * gbx%ch4 * 1e6  
  n2o  =  ( Mdry / Mn2o ) * gbx%n2o * 1e6
  co   =  ( Mdry / Mco  ) * gbx%co  * 1e6
  
  !! RTTOV can handle only about 100 profiles at a time (FIXME: Check this with Roger) 
  !! So we are putting a loop of 100 
  
  nloop  =  Npoints / MaxLim
  rmod   =  MOD( Npoints, MaxLim )
  
  if( rmod .ne. 0 ) then  
     nloop = nloop + 1
  endif
  
  !! looping over MaxLim number of profiles
  do il = 1, nloop
     istart  =  (il - 1) * MaxLim + 1
     istop   =  min(il * MaxLim, Npoints) 
     
     if( ( il .eq. nloop ) .and. ( rmod .ne. 0 ) ) then
        nprof   =  rmod
     else
        nprof   =  MaxLim
     endif
          
#ifdef RTTOV
     call  rttov_multprof(              &
          gbx%Nchan,                    &
          gbx%ichan,                    &
          gbx%surfem,                   &
          nprof,                        &
          Nlevels,                      &
          gbx%Plat,                     &
          gbx%Sat,                      &
          gbx%Inst,                     &
          gbx%ZenAng,                   &
          pp(istart:istop, :),          &
          tt(istart:istop, :),          &
          sh(istart:istop, :),          &
          o3(istart:istop, :),          &
          co2,                          &
          ch4,                          &
          n2o,                          &
          co,                           &
          gbx%zlev_half(istart:istop,1), &
          gbx%u_wind(istart:istop),     &
          gbx%v_wind(istart:istop),     &
          gbx%skt(istart:istop),        &
          gbx%psfc(istart:istop)/100.,  &
          tt_surf(istart:istop),        &
          sh_surf(istart:istop),        &
          gbx%land(istart:istop),       &
          gbx%latitude(istart:istop),   &
          y%tbs(istart:istop, :) )
#endif
  enddo
  
END SUBROUTINE COSP_RTTOV_SIMULATOR

END MODULE MOD_COSP_RTTOV_SIMULATOR

! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.3.2/quickbeam/load_mie_table.f90 $
  subroutine load_mie_table(mie_table_name,mt)
  use radar_simulator_types
  implicit none
  
! Purpose:
!   Loads the Mie table data
!   Part of Quickbeam v1.03
!   http://reef.atmos.colostate.edu/haynes/radarsim
!
! Inputs:  
!   [mie_table_name]   Mie table input file
!
! Outputs:
!   [mt]            structure of Mie table data
!
! Created from Quickbeam v1.02 08/24/2006 by Roger Marchand  

! ----- INPUT -----
  character*200, intent(in) :: mie_table_name

! ----- OUTPUT -----
  type(mie), intent(out) :: mt

! ----- INTERNAL -----  
  integer :: i

  integer*4 :: dummy_in(4)
     
    open(51,file=mie_table_name,action='read')
 
    read(51,*) dummy_in 

     if(dummy_in(1).ne. mt_nfreq .or. &
        dummy_in(2).ne. mt_ntt .or. &
        dummy_in(3).ne. mt_nf .or. &
        dummy_in(4).ne. mt_nd) then

          print *,'Mie file is of size :',dummy_in(:)
          print *,'  expected a size of:',mt_nfreq, mt_ntt,mt_nf,mt_nf
          print *,'  change paramters in radar_simulator_types.f90 ?? '
          stop
     endif

    read(51,*) mt%freq
    read(51,*) mt%tt
    read(51,*) mt%f
    read(51,*) mt%phase
    read(51,*) mt%D
    read(51,*) mt%qext
    read(51,*) mt%qbsca
    
    close(51)

! // create arrays of liquid/ice temperature
  cnt_liq = 0
  cnt_ice = 0
  do i=1,mt_ntt
    if (mt%phase(i) == 0) cnt_liq = cnt_liq + 1
    if (mt%phase(i) == 1) cnt_ice = cnt_ice + 1
  enddo
  allocate(mt_ttl(cnt_liq),mt_tti(cnt_ice))
  do i=1,cnt_liq
    mt_ttl(i) = mt%tt(i)
  enddo
  do i=1,cnt_ice
    mt_tti(i) = mt%tt(cnt_liq+i)
  enddo

  end subroutine load_mie_table

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/cosp_rttov.F90 $
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Aug 2008 - V. John - Initial version
! Jun 2010 - A. Bodas-Salcedo - Conversion to module and tidy up
! 
MODULE MOD_COSP_RTTOV
    USE RTTOV_CONST, only : errorstatus_fatal, errorstatus_warning, errorstatus_success
    USE RTTOV_TYPES, only : rttov_coef, profile_type, transmission_type,   &
                            radiance_type, rttov_coef_scatt_ir, rttov_optpar_ir
    USE PARKIND1, Only : jpim, jprb
    IMPLICIT NONE
#include "rttov_errorreport.interface"
#include "rttov_setup.interface"
#include "rttov_errorhandling.interface"
#include "rttov_direct.interface"
#include "rttov_alloc_prof.interface"
#include "rttov_alloc_rad.interface"
#include "rttov_dealloc_coef.interface"
CONTAINS
    SUBROUTINE RTTOV_MULTPROF( &
        nch_in,     & ! number of channels 
        ichan_in,   & ! channel indices
        surfem_in,  & ! surface emissivity values 
        prf_num_in, & ! number of profiles to simulate
        nlevels_in, & ! number of pressure levels
        plat_in,    & ! platform number
        sat_in,     & ! satellite number
        sens_in,    & ! instrument number
        zenang_in,  & ! zenith angle 
        p_in,       & ! Pressure [hPa]
        t_in,       & ! Temperature [ K ]
        q_in,       & ! Specific humidity [ ppmv ]
        o3_in,      & ! Ozone VMR [ ppmv ]
        co2_in,     & ! CO2 VMR [ ppmv ] *This is a single value* 
        ch4_in,     & ! CH4 VMR [ ppmv ] *This is a single value*
        n2o_in,     & ! N2O VMR [ ppmv ] *This is a single value*
        co_in,      & ! CO VMR [ ppmv ]  *This is a single value*
        h_surf,     & ! Surface height [ m ]
        u_surf,     & ! U wind at 10 m  [ m/s ]
        v_surf,     & ! V wind at 10 m [ m/s ]
        t_skin,     & ! Skin Temperatre [ K ] 
        p_surf,     & ! Surface pressure 
        t_surf,     & ! 1.5 m Temperature [ K ]
        q_surf,     & ! 1.5 m specific humidity [ ppmv ]
        lsmask,     & ! land sea mask
        latitude,   & ! Latitude [ deg north ]
        tbs         & ! Brightness temperature [ K ] (OUTPUT)
        )
    
    !------ Input arguments. No RTTOV kinds should be used here -----------------
    integer  :: nch_in             ! number of channels to be computed
    integer  :: ichan_in(nch_in)   ! Indices of selected channels 
    Real     :: surfem_in(nch_in)  ! Surface emissivities for the channels
    Integer  :: prf_num_in
    Integer  :: nlevels_in
    Integer plat_in  ! Satellite platform
    Integer sat_in   ! Satellite number
    Integer sens_in  ! Satellite sensor
    Real     :: zenang_in          ! Satellite zenith angle
    Real p_in(prf_num_in, nlevels_in)  ! Pressure profiles  
    Real t_in(prf_num_in, nlevels_in)  ! Temperature profiles
    Real q_in(prf_num_in, nlevels_in)  ! Humidity profiles
    Real o3_in(prf_num_in, nlevels_in) ! Ozone profiles
    ! The following trace gases contain constant values
    Real co2_in ! Carbon dioxide 
    Real ch4_in ! methane 
    Real n2o_in ! n2o 
    Real co_in  ! carbon monoxide
    Real h_surf(prf_num_in)         ! Surface height
    Real u_surf(prf_num_in)         ! U component of surface wind
    Real v_surf(prf_num_in)         ! V component of surface wind
    Real t_skin(prf_num_in)         ! Surface skin temperature
    Real p_surf(prf_num_in)         ! Surface pressure
    Real t_surf(prf_num_in)         ! 1.5 m Temperature
    Real q_surf(prf_num_in)         ! 1.5 m Specific humidity
    Real lsmask(prf_num_in)         ! land-sea mask
    Real latitude(prf_num_in)       ! Latitude
    Real tbs(prf_num_in, nch_in)  ! Tbs (in the right format)
    
    !------ Local variables. Use only RTTOV kinds or derived types.
    !       logical variables are declared with the same kind
    !       as integers, as they are affected inthe same way by flags like -qintsize=8
    type( rttov_coef ), allocatable      :: coef(:)       ! coefficients
    type(profile_type), allocatable      :: profiles(:)
    type(transmission_type)              :: transmission
    type(radiance_type)                  :: radiance
    type(rttov_coef_scatt_ir), allocatable:: coef_scatt_ir(:)
    type(rttov_optpar_ir), allocatable    :: optp(:)
    
    Integer(Kind=jpim), Allocatable :: instrument(:,:) ! instrument id
    Integer(Kind=jpim), Allocatable :: nchan(:,:) ! number of channels per instrument and profile
    Integer(Kind=jpim), Allocatable :: nchan1(:) ! number of channels per instrument and profile
    Integer(Kind=jpim), Allocatable :: nchannels(:) ! number of channels per instrument 
    Integer(Kind=jpim), Allocatable :: ifull(:)   ! full test (with TL,AD,K) per instrument
    Integer(Kind=jpim), Allocatable :: nprof(:)   ! number of profiles per instrument
    Integer(Kind=jpim), Allocatable :: nsurf(:)   ! surface id number per instrument
    Integer(Kind=jpim), Allocatable :: nwater(:)  ! water id number per instrument
    Integer(Kind=jpim), Allocatable :: ichan(:,:)   ! channel list per instrument
    Integer(Kind=jpim), Allocatable :: channels(:)    ! channel list per instrument*profiles
    Integer(Kind=jpim), Allocatable :: lprofiles  (:)
    Integer(Kind=jpim) :: nprofiles, iref, isun, asw 
    Integer(Kind=jpim), Allocatable :: rttov_errorstatus(:)  ! rttov error return code
    Integer(Kind=jpim), Allocatable :: setup_errorstatus(:)  ! setup return code
    Integer(Kind=jpim) :: mxchn 
    Integer(Kind=jpim) :: Err_Unit        ! Logical error unit (<0 for default)
    Integer(Kind=jpim) :: verbosity_level ! (<0 for default)
    Integer(Kind=jpim) :: nrttovid     ! maximum number of instruments
    Integer(Kind=jpim) :: no_id        ! instrument loop index
    Integer(Kind=jpim) :: i, j, jch
    Integer(Kind=jpim) :: Nprofs  ! Number of calls to RTTOV
    Integer(Kind=jpim) :: nch ! intermediate variable
    Integer(Kind=jpim) :: errorstatus, io_status
    Integer(Kind=jpim) :: ioout, interp
    Integer(Kind=jpim), Parameter :: jpnav  =  31    ! no. of profile variables
    Integer(Kind=jpim), Parameter :: jpnsav =  6       ! no. of surface air variables
    Integer(Kind=jpim), Parameter :: jpnssv =  6       ! no. of skin variables
    Integer(Kind=jpim), Parameter :: jpncv  =  2       ! no. of cloud variables
    Integer(Kind=jpim), Parameter :: sscvar = jpnsav+jpnssv+jpncv ! no of surface,skin,cloud vars
    Integer(Kind=jpim) :: alloc_status(60)
    
    Real(Kind=jprb),    Allocatable :: surfem(:,:)   ! surface input emissivity per channel , instrument
    Real(Kind=jprb),    Allocatable :: emissivity (:)
    Real(Kind=jprb),    Allocatable :: fresnrefl  (:)
    Real(Kind=jprb),    Allocatable :: input_emissivity (:)
    Real(Kind=jprb) :: tbs_temp(nch_in * prf_num_in) ! A temporary variable to hold Tbs
    Real(Kind=jprb) :: zenang, azang, sunzang, sunazang

    Character (len=3)  :: cref
    Character (len=3)  :: csun
    Character (len=80) :: errMessage
    Character (len=14)  :: NameOfRoutine = 'rttov_multprof'
    
    Logical :: addinterp  ! switch for the interpolator
    Logical,Allocatable :: calcemis  (:)
    logical :: refrac, solrad, laerosl, lclouds, lsun, all_channels

    ! Local variables for input arguments that need type casting to avoid type-mismatch with 
    ! RTTOV kinds. This happens with some compiler flags (-qintsize=8).
    Integer(Kind=jpim)  :: prof_num
    Integer(Kind=jpim)  :: nlevels
    
    ! Type-casting of input arguments that need to be passed to RTTOV
    prof_num = prf_num_in
    nlevels  = nlevels_in
                
    ! Unit numbers for input/output
    IOOUT = 2
    !- End of header --------------------------------------------------------
    
    ! Curretly we plan to calculate only 1 instrument per call
    nrttovid  =  1
    
    mxchn  =  nch_in
    
    errorstatus     = 0
    alloc_status(:) = 0
    all_channels = .false.
    sunzang = 0._jprb
    sunazang = 0._jprb
    !
    !Initialise error management with default value for
    ! the error unit number and
    ! Fatal error message output
    Err_unit = -1
    verbosity_level = 0
    ! All error message output
!     verbosity_level = 3
    call rttov_errorhandling( Err_unit, verbosity_level, print_checkinput_warnings=.false. )
    
    io_status = 0
    errmessage = ''
    
    ! Assigning the zenith angle
    zenang = zenang_in
    
    ! Beginning of Routine.
    ! ---------------------
    
    allocate (coef(nrttovid),stat= alloc_status(1))
    allocate (coef_scatt_ir(nrttovid),stat= alloc_status(2))
    allocate (optp(nrttovid),stat= alloc_status(3))
    
    allocate (instrument(3,nrttovid),stat= alloc_status(4))
    allocate (ifull(nrttovid),stat= alloc_status(5))
    allocate (nprof(nrttovid),stat= alloc_status(6))
    allocate (nsurf(nrttovid),stat= alloc_status(7))
    allocate (nwater(nrttovid),stat= alloc_status(8))
    allocate (nchannels(nrttovid),stat= alloc_status(9))
    allocate (nchan1(nrttovid),stat= alloc_status(10))
    !maximum number of channels allowed for one instrument is mxchn
    allocate (surfem(mxchn,nrttovid),stat= alloc_status(11))
    allocate (ichan (mxchn,nrttovid),stat= alloc_status(12))
    If( any(alloc_status /= 0) ) then
        errorstatus = errorstatus_fatal
        Write( errMessage, '( "mem allocation error")' )
        Call Rttov_ErrorReport (errorstatus, errMessage, NameOfRoutine)
        Stop
    End If
    
    surfem(:,:)  =  0.0_JPRB
    ichan(:,:)   =  0
    
    !!! FIXME: Shall we get rid of this loop? We use only one instrument
    DO NO_ID = 1, NRTTOVID
        
        instrument(1,no_id) = plat_in
        instrument(2,no_id) = sat_in
        instrument(3,no_id) = sens_in
                
        !! Forward model only (0) or TL and AD (1) or K (2)?'
        !  This version supports only Forward model
        IFULL(no_id) = 0
        
        !! ' Number of profiles to test per call? '
        NPROF(no_id)  = prof_num
        nprofiles = NPROF(no_id)
        
        !! ' Total number of profiles to process? '
        NPROFS  = prof_num
        NPROFS = NPROFS / NPROF(no_id)   ! Number of calls to RTTOV
        
        !FIXME: I am directly using a land -sea mask. 
        !FIXME: Check whether it is 0 for land and 1 for sea in the mask. 
        !FIXME: Otherwise provide a reverse mask
        !
        !PRINT  *, ' Surface type (0=land, 1=sea, 2=ice/snow)? '
        !NSURF(no_id)  = 0
    
    
        !PRINT  *, ' Water type (0=fresh water, 1=ocean water)'
        !! FIXME: Check whether it is OK to use ocean all the time
        !
        NWATER(no_id) = 1
    
        !..SET UP CHANNEL NUMBERS
        allocate (nchan(nprof(no_id),nrttovid),stat= alloc_status(3))
        nchan(1:nprof(no_id),no_id) = nch_in
            
        ichan(:, 1)   =  ichan_in
        surfem(:, 1)  =  surfem_in
    
        ! nchan(1,no_id) is now the real number of channels selected
        do j = 1 , nprof(no_id)
            nchan(j,no_id) = nch_in  
        enddo
        
        ! compute channels*profiles
        nchannels(no_id) = 0
        Do j = 1 , nprof(no_id)
            nchannels(no_id) = nchannels(no_id) + nchan (j,no_id)
        End Do
        nchan1(no_id) = nchan(1,no_id)
        !
    END DO
    
    !write(6,*)'Do you want to include aerosols?' No!!
    !iaer    = 0
    laerosl = .False.
    
    !write(6,*)'Do you want to include clouds?' No!!
    !icld    = 0
    lclouds = .False.
    
    !---------------------------------------------------------
    ! Beginning of rttov_setup test
    !---------------------------------------------------------
    alloc_status = 0
    allocate ( setup_errorstatus(nrttovid),stat= alloc_status(1))
    If( any(alloc_status /= 0) ) then
        errorstatus = errorstatus_fatal
        Write( errMessage, '( "mem allocation error for errorsetup")' )
        Call Rttov_ErrorReport (errorstatus, errMessage, NameOfRoutine)
        Stop
    End If
    
    If (all_channels)Then
        Call rttov_setup (&
            & setup_errorstatus,  &! out
            & Err_unit,           &! in
            & verbosity_level,    &! in
            & nrttovid,           &! in
            & laerosl,            &! in
            & lclouds,            &! in
            & coef,               &! out
            & coef_scatt_ir,      &! out
            & optp,               &
            & instrument)         ! in
    Else
        Call rttov_setup (&
            & setup_errorstatus,  &! out
            & Err_unit,           &! in
            & verbosity_level,    &! in
            & nrttovid,           &! in
            & laerosl,            &! in
            & lclouds,            &! in
            & coef,               &! out
            & coef_scatt_ir,      &! out
            & optp,               &
            & instrument,         &! in
            & ichan              ) ! in Optional 
    Endif
    if(any(setup_errorstatus(:) /= errorstatus_success ) ) then
        print*, 'rttov_setup fatal error'
        stop
    endif
    
    deallocate( setup_errorstatus ,stat=alloc_status(1))
    If( any(alloc_status /= 0) ) then
        errorstatus = errorstatus_fatal
        Write( errMessage, '( "mem deallocation error for setup_errorstatus")' )
        Call Rttov_ErrorReport (errorstatus, errMessage, NameOfRoutine)
        Stop
    End If
    
    DO no_id = 1, NRTTOVID
        if( any(coef(no_id)%ff_val_chn( : ) /= 1 )) then
        WRITE(*,*) ' some requested channels have bad validity parameter'
        do i = 1, nchan1(no_id)
            write(*,*) i, coef(no_id)%ff_val_chn(i)
            end do
        endif
    End Do
    !---------------------------------------------------------
    ! End of rttov_setup test
    !---------------------------------------------------------
    !
    
    DO no_id = 1, NRTTOVID
        
    !-----------------------------------
        ! Memory allocation for RTTOV_Direct
        !-----------------------------------
        allocate( rttov_errorstatus(nprof(no_id)),stat= alloc_status(3))
        ! Allocate profiles
        allocate( profiles(nprof(no_id)),stat= alloc_status(1))
        
        ! Allow profile interpolation
        interp  =  1
        
        if(interp == 0) addinterp = .false.
        if(interp == 1) addinterp = .true.
        asw = 1 ! allocate
        
        !if( no_id .gt. 1 ) stop
        
        call rttov_alloc_prof ( &
            &  errorstatus,          &
            &  nprof(no_id),         &
            &  profiles,             &
            &  nlevels,              &
            &  coef_scatt_ir(no_id), &
            &  asw,                  &
            &  addclouds = lclouds,  &
            &  addaerosl = laerosl,  &
            &  init = .true.         )
        
    
        !profiles(1) % nlevels = nlevels
        
        Do j = 1 , nprof(no_id)
            profiles(j) % nlevels =  nlevels
        Enddo
        
        alloc_status = 0_jpim
        ! number of channels per RTTOV call is only nchannels
        allocate( lprofiles  ( nchannels(no_id) )       ,stat= alloc_status(9))
        allocate( channels   ( nchannels(no_id) )        ,stat= alloc_status(10))
        allocate( emissivity ( nchannels(no_id) )       ,stat= alloc_status(12))
        allocate( fresnrefl  ( nchannels(no_id) )       ,stat= alloc_status(13))
        allocate( input_emissivity ( nchannels(no_id) ) ,stat= alloc_status(14))
        allocate( calcemis   ( nchannels(no_id) )        ,stat= alloc_status(15))
    
        ! allocate transmittance arrays with number of channels
        allocate( transmission % tau_layers (profiles(1) % nlevels,nchannels(no_id) ), &
            stat= alloc_status(11))
        allocate( transmission % tau_total (nchannels(no_id) )                       , &
            stat= alloc_status(12))
        
        If( Any(alloc_status /= 0) ) Then
            errorstatus = errorstatus_fatal
            Write( errMessage, '( "allocation of transmission")' )
            Call Rttov_ErrorReport (errorstatus_fatal, errMessage, NameOfRoutine)
            !IF (LHOOK) CALL DR_HOOK('RTTOV_DIRECT',1,ZHOOK_HANDLE)
            Stop
        End If
        
        transmission % tau_layers = 0._jprb
        transmission % tau_total = 0._jprb
    
        ! allocate radiance results arrays with number of channels
        asw = 1 ! allocate
        call rttov_alloc_rad (errorstatus,nchannels(no_id),radiance, &
            profiles(1)%nlevels,asw)
        
        AZANG  =  0
        ISUN   =  0
        IREF   =  1
    
        if(iref==0)then
            cref='NO'
            refrac=.False.
        else if(iref==1)then
            cref='YES'
            refrac=.True.
        endif
    
        if(sunzang<=87._JPRB)then
            solrad=.True.
        else
            solrad=.False.
        endif
        
        if(isun==1)then
            lsun=.true.
            if(sunzang<=87._JPRB)then
            csun='YES'
            solrad=.True.
            else
            csun='NO'
            solrad=.False.
            endif
        else
            csun='NO'
            solrad=.False.
        endif
        
        do i = 1, NPROF(no_id)
            profiles(i) %  p(:)  =  p_in(i, :)
            
            profiles(i) %  t(:)  =  t_in(i, :)
            profiles(i) %  q(:)  =  q_in(i, :)
            profiles(i) % o3(:)  =  o3_in(i, :)
            profiles(i) % co2(:) =  co2_in
            profiles(i) % ch4(:) =  ch4_in
            profiles(i) % n2o(:) =  n2o_in
            profiles(i) % co(:)  =  co_in
            
            profiles(i) % ozone_Data  =  .False.
            profiles(i) % co2_Data    =  .True.
            profiles(i) % n2o_data    =  .True.
            profiles(i) % ch4_Data    =  .True.
            profiles(i) % co_Data     =  .True.
            
            !FIXME: Make Cloud variables as passing ones if we go for all sky
            profiles(i) % cfraction  =  0.
            profiles(i) % ctp        =  500.
            
            profiles(i) % clw_Data   =  .False.
    
            ! 2m parameters 
            profiles(i) % s2m % p  =  p_surf(i)
            profiles(i) % s2m % t  =  t_in(i, 1)!t_surf(i)
            profiles(i) % s2m % q  =  q_in(i, 1)!q_surf(i)
            profiles(i) % s2m % u  =  2!u_surf(i)
            profiles(i) % s2m % v  =  2!v_surf(i)
        
            ! Skin variables for emissivity calculations
            profiles(i) % skin % t          =  t_skin(i)
            profiles(i) % skin % fastem(1)  =  3.0
            profiles(i) % skin % fastem(2)  =  5.0
            profiles(i) % skin % fastem(3)  =  15.0
            profiles(i) % skin % fastem(4)  =  0.1
            profiles(i) % skin % fastem(5)  =  0.3
            
            profiles(i) % zenangle      = zenang
            profiles(i) % azangle       = azang
            profiles(i) % latitude      = latitude(i)
            profiles(i) % elevation     = h_surf(i)
            profiles(i) % sunzenangle   = SUNZANG
            profiles(i) % sunazangle    = SUNAZANG
            profiles(i) % addsolar      = solrad
            profiles(i) % addrefrac     = refrac
            ! surface type
            profiles(i) % skin % surftype  = lsmask(i)
            !! FIXME: Check this one
            profiles(i) % skin % watertype = nwater(no_id)
            
            profiles(i) % aer_data   = laerosl
            profiles(i) % cld_data   = lclouds
            profiles(i) %idg         = 0._jprb
            profiles(i) %ish         = 0._jprb
            if( lclouds ) then
            profiles(i) %cloud(:,:)  = 0._jprb
            profiles(i) %cfrac(:,:)  = 0._jprb
            endif
        enddo
    
        ! Build the list of channels/profiles indices
        emissivity(:) = 0.0_JPRB
        channels(:) = 0_jpim
        lprofiles(:) = 0_jpim
        nch = 0_jpim
        Do j = 1 , nprof(no_id)
            DO  jch = 1,nchan1(no_id)
            nch = nch +1_jpim
            lprofiles ( nch ) = j
            if (all_channels)then
                channels( nch ) = ichan(jch,no_id)
            else 
                channels( nch ) = jch
            endif
            emissivity( nch ) = surfem(jch,no_id)
        End Do
        End Do
        
        input_emissivity(:) = emissivity(:)
        calcemis(:) = emissivity(:) < 0.01_JPRB
    
    
        ! FIXME: Check this one with Roger
        do j = 1 , NPROFS
        call rttov_direct(           &
                & rttov_errorstatus,    &! out
                & nprof(no_id),         &! in
                & nchannels(no_id),     &! in
                & channels,             &! in
                & lprofiles,            &! in
                & addinterp,            &! in
                & profiles,             &! in
                & coef(no_id),          &! in
                & coef_scatt_ir(no_id), &
                & optp(no_id)         , &
                & lsun,                 &! in
                & laerosl,              &! in
                & lclouds,              &! in
                & calcemis,             &! in
                & emissivity,           &! inout
                & transmission,         &! out
                & radiance  )            ! inout 
        enddo
    
        ! Initialising tbs array
        tbs(:, :)    =  0.0
        tbs_temp(:)  =  0.0
        tbs_temp     =  radiance%bt
    
        do i = 1, prof_num
        tbs(i, :)  =  tbs_temp((i-1)*nch_in+1:i*nch_in)
        enddo
        
    
        If ( any( rttov_errorstatus(:) == errorstatus_warning ) ) Then
        Do j = 1, nprof(no_id)
            If ( rttov_errorstatus(j) == errorstatus_warning ) Then
                write ( ioout, * ) 'rttov warning for profile', j
            End If
        End Do
        End If
        
        If ( any( rttov_errorstatus(:) == errorstatus_fatal ) ) Then
        Do j = 1, nprof(no_id)
            If ( rttov_errorstatus(j) == errorstatus_fatal ) Then
                write ( ioout, * ) 'rttov error for profile',j
            End If
        End Do
        Stop
        End If
    
        ! Deallocate
        ! number of channels per RTTOV call is only nchannels
        deallocate( channels   ,stat=alloc_status(2))
        deallocate( lprofiles  ,stat=alloc_status(3))
        deallocate( emissivity ,stat=alloc_status(4))
        deallocate( fresnrefl  ,stat=alloc_status(5))
        deallocate( calcemis   ,stat=alloc_status(6))
        deallocate( input_emissivity ,stat= alloc_status(14))
        If( any(alloc_status /= 0) ) then
        errorstatus = errorstatus_fatal
        Write( errMessage, '( "mem deallocation error for channels etc")' )
        Call Rttov_ErrorReport (errorstatus, errMessage, NameOfRoutine)
        Stop
        End If
        
        asw = 0 ! deallocate radiance arrays
        call rttov_alloc_rad (errorstatus,nchan1(no_id),radiance,profiles(1) % nlevels,asw)
        If(errorstatus /= errorstatus_success) Then
        Write( errMessage, '( "deallocation error for radiances")' )
        Call Rttov_ErrorReport (errorstatus, errMessage, NameOfRoutine)
        Endif
        
        ! deallocate transmittances
        Deallocate( transmission % tau_total   ,stat= alloc_status(7))
        Deallocate( transmission % tau_layers  ,stat= alloc_status(8))
        If(errorstatus /= errorstatus_success) Then
        Write( errMessage, '( "deallocation error for transmittances")' )
        Call Rttov_ErrorReport (errorstatus, errMessage, NameOfRoutine)
        Stop
        Endif
        
        asw = 0 ! deallocate profile arrays
        call rttov_alloc_prof (errorstatus,nprof(no_id),profiles,profiles(1)%nlevels,coef_scatt_ir(no_id),asw,&
            & addclouds = lclouds, addaerosl = laerosl )
        deallocate( profiles,stat=alloc_status(1))
        If( any(alloc_status /= 0) ) then
        errorstatus = errorstatus_fatal
        Write( errMessage, '( "mem deallocation error for profiles")' )
        Call Rttov_ErrorReport (errorstatus, errMessage, NameOfRoutine)
        Stop
        End If
    
    EndDo
    
    DO no_id = 1, NRTTOVID 
        Call rttov_dealloc_coef (errorstatus, coef(no_id),coef_scatt_ir(no_id),optp(no_id))
        If(errorstatus /= errorstatus_success) Then
        Write( errMessage, '( "deallocation error for coeffs")' )
        Call Rttov_ErrorReport (errorstatus, errMessage, NameOfRoutine)
        Endif
    EndDo
    
    END SUBROUTINE RTTOV_MULTPROF
END MODULE MOD_COSP_RTTOV

c $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
c $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/quickbeam/predict_psd07.f $
      program predict_psd07

c 14 Feb 2007

c This procedure uses the second moment and in-cloud temperature
c to predict the ice particle size distribution. 
c The moment relations use the 2nd moment as a reference moment.


c For more details please read 'Snow size distribution parameterization for midlatitude and tropical ice clouds' by Field et al JAS2007

c !!!!!!!!!!!variables!!!!!!!!!!!!!!!!!!!!
c Input
c tc in C
c iwc in g m^-3
c x,y prefactor and exponent in mass-size relation m=xD^y
c for the UM    x=0.069, y=2.0    (SI units)
c regime: 'T' for tropical, 'M' for midlatitude

c Output
c D particle size in microns
c dN_dD particle size distribution: dN/dD m^-4
c L23 ratio of M3/M2 - mean mass weighted size if y=2


       real D(500),dN_dD(500),phi(500)
       real x,y,tc,iwc,iwcsi,My,m2,n,m3,xx
       character regime


c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c    read in input file
       open(unit=2,file="input.txt")
       read(2,*) iwc,tc,x,y,regime
       close(2)


c incloud temperature check

      if (tc.gt.0) then
         print*,'in-cloud temperature too warm (>0C)'
         goto 1000
      endif  
      if (tc.lt.-70) then 
         print*,'Warning: in-cloud temp colder than in original data'
      endif  

c !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



c Calculate 2nd moment
      iwcsi=iwc/1e3  !kg m^-3

      My=iwcsi/x  !yth moment

c use moment relations to get 2nd moment required for predicting psd

      m2=My 
c default for UM y=2 

c if y ne 2 then need to find second moment before proceeding
      if(y.ne.2.0) then 
         m2=-9999
         call predict_mom07(m2,tc,y,My)
      endif
c !!M2 range check (1e-5 3e-2 m^-1)!!!!!!!!!!!!!!!!!!!!!

      if (m2.lt.0.0) then
         print*,'Negative M2'
         goto 1000
      endif
      if (m2.lt.1e-5.or.m2.gt.0.1) then
        print*,'Warning: M2 outside of range in original data'
      endif 
c !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

c Use 2nd and 3rd moment to predict psd;;;;;;;;;;;;;;;;;;;;


       n=3
       call predict_mom07(m2,tc,n,m3)
        

c !!!define universal psd!!!!
      do 10 i=1,500
        xx=i/40. !dimensionless size
        if (regime.eq.'T') then 
               phi(i)=152.0*exp(-12.4*xx)+3.28*xx**(-0.78)*exp(-1.94*xx)
        endif

        if (regime.eq.'M') then 
               phi(i)=141.0*exp(-16.8*xx)+102.0*xx**(2.07)*exp(-4.82*xx)
        endif
 	
        D(i)=1e6*xx*(m3/m2)
        dN_dD(i)=phi(i)*m2**4/m3**3
 10   continue




c !write output file

      open(unit=2,file="output.txt")
      write(2,*) 'Input values'
      write(2,*) 'IWC [g/m3]=',iwc
      write(2,*) 'T [C] =',tc
      write(2,*) 'x , y [SI]=', x, y
      write(2,*),'Regime =',regime
      write(2,*) ' '
      write(2,*) 'Output values'
      write(2,*) 'L32 [microns]=',1e6*m3/m2
      write(2,*) 'D (microns) dN/dD (m^-4)'
      do 20 i=1,500
        write(2,*),D(i),dN_dD(i)
 20   continue
      close(2)	       
 

 1000   continue

        stop 
        end


        subroutine predict_mom07(m2,tc,n,m)

c subroutine to predict nth moment m given m2, tc, n
c if m2=-9999 then the routine will predict m2 given m,n,tc
 
        real a1,a2,a3,b1,b2,b3,c1,c2,c3
        real m2,tc,n,m,a_,b_,c_,A,B,C

       a1=      13.6078
       a2=     -7.76062
       a3=     0.478694
       b1=   -0.0360722
       b2=    0.0150830
       b3=   0.00149453
       c1=     0.806856
       c2=   0.00581022
       c3=    0.0456723


       a_=a1+a2*n+a3*n**2.0
       b_=b1+b2*n+b3*n**2.0
       c_=c1+c2*n+c3*n**2.0

       A=exp(a_)
       B=b_
       C=c_
       
c predict m from m2 and tc
        if(m2.ne.-9999) then 
           m=A*exp(B*tc)*m2**C
        endif
c get m2 if mass-dimension relationship not proportional to D**2
        if(m2.eq.-9999) then 
           m2=(m/(A*exp(B*tc)))**(1.0/C)    
        endif
        

       return
       end

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/cosp_htfrtc.F90 $
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Dec 2010 - J.C. Thelen, S. Haveman - Initial version
!

MODULE MOD_COSP_HTFRTC
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
  IMPLICIT NONE

CONTAINS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!------------------- SUBROUTINE COSP_HTFRTC ----------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SUBROUTINE COSP_HTFRTC(gbx,sgx,sghydro,y)

  ! Arguments
  type(cosp_gridbox),intent(in) :: gbx  ! Gridbox info
  type(cosp_subgrid),intent(in) :: sgx  ! Subgrid info
  type(cosp_sghydro),intent(in) :: sghydro  ! Subgrid info for hydrometeors
  type(cosp_tphtfrtc),intent(inout) :: y ! Subgrid output

  ! Local variables


  ! Allocate memory for local arrays
  
  ! Reshape arrays as requested
  
  ! Do calculations
  call htfrtc(sgx%Npoints, sgx%Nlevels, ....., y%rad )

  ! Free local arrays

END SUBROUTINE COSP_MOD_COSP_HTFRTC

! $Revision: 88 $, $Date: 2013-11-13 07:08:38 -0700 (Wed, 13 Nov 2013) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/icarus-scops-4.1-bsd/icarus.f $
      SUBROUTINE ICARUS(
     &     debug,
     &     debugcol,
     &     npoints,
     &     sunlit,
     &     nlev,
     &     ncol,
     &     pfull,
     &     phalf,
     &     qv,
     &     cc,
     &     conv,
     &     dtau_s,
     &     dtau_c,
     &     top_height,
     &     top_height_direction,
     &     overlap,
     &     frac_out,
     &     skt,
     &     emsfc_lw,
     &     at,
     &     dem_s,
     &     dem_c,
     &     fq_isccp,
     &     totalcldarea,
     &     meanptop,
     &     meantaucld,
     &     meanalbedocld,
     &     meantb,
     &     meantbclr,
     &     boxtau,
     &     boxptop
     &)

!$Id: icarus.f,v 4.1 2010/05/27 16:30:18 hadmw Exp $

! *****************************COPYRIGHT****************************
! (c) 2009, Lawrence Livermore National Security Limited Liability 
! Corporation.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without 
! modification, are permitted provided that the
! following conditions are met:
! 
!     * Redistributions of source code must retain the above 
!       copyright  notice, this list of conditions and the following 
!       disclaimer.
!     * Redistributions in binary form must reproduce the above 
!       copyright notice, this list of conditions and the following 
!       disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Lawrence Livermore National Security 
!       Limited Liability Corporation nor the names of its 
!       contributors may be used to endorse or promote products
!       derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
! 
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************

      implicit none

!     NOTE:   the maximum number of levels and columns is set by
!             the following parameter statement

      INTEGER ncolprint
      
!     -----
!     Input 
!     -----

      INTEGER npoints       !  number of model points in the horizontal
      INTEGER nlev          !  number of model levels in column
      INTEGER ncol          !  number of subcolumns

      INTEGER sunlit(npoints) !  1 for day points, 0 for night time

      REAL pfull(npoints,nlev)
                       !  pressure of full model levels (Pascals)
                  !  pfull(npoints,1) is top level of model
                  !  pfull(npoints,nlev) is bot of model

      REAL phalf(npoints,nlev+1)
                  !  pressure of half model levels (Pascals)
                  !  phalf(npoints,1) is top of model
                  !  phalf(npoints,nlev+1) is the surface pressure

      REAL qv(npoints,nlev)
                  !  water vapor specific humidity (kg vapor/ kg air)
                  !         on full model levels

      REAL cc(npoints,nlev)   
                  !  input cloud cover in each model level (fraction) 
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by clouds

      REAL conv(npoints,nlev) 
                  !  input convective cloud cover in each model
                  !   level (fraction) 
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by convective clouds

      REAL dtau_s(npoints,nlev) 
                  !  mean 0.67 micron optical depth of stratiform
                !  clouds in each model level
                  !  NOTE:  this the cloud optical depth of only the
                  !  cloudy part of the grid box, it is not weighted
                  !  with the 0 cloud optical depth of the clear
                  !         part of the grid box

      REAL dtau_c(npoints,nlev) 
                  !  mean 0.67 micron optical depth of convective
                !  clouds in each
                  !  model level.  Same note applies as in dtau_s.

      INTEGER overlap                   !  overlap type
                              !  1=max
                              !  2=rand
                              !  3=max/rand

      INTEGER top_height                !  1 = adjust top height using both a computed
                                        !  infrared brightness temperature and the visible
                              !  optical depth to adjust cloud top pressure. Note
                              !  that this calculation is most appropriate to compare
                              !  to ISCCP data during sunlit hours.
                                        !  2 = do not adjust top height, that is cloud top
                                        !  pressure is the actual cloud top pressure
                                        !  in the model
                              !  3 = adjust top height using only the computed
                              !  infrared brightness temperature. Note that this
                              !  calculation is most appropriate to compare to ISCCP
                              !  IR only algortihm (i.e. you can compare to nighttime
                              !  ISCCP data with this option)

      INTEGER top_height_direction ! direction for finding atmosphere pressure level
                                 ! with interpolated temperature equal to the radiance
				 ! determined cloud-top temperature
				 !
				 ! 1 = find the *lowest* altitude (highest pressure) level
				 ! with interpolated temperature equal to the radiance
				 ! determined cloud-top temperature
				 !
				 ! 2 = find the *highest* altitude (lowest pressure) level
				 ! with interpolated temperature equal to the radiance 
				 ! determined cloud-top temperature
				 ! 
				 ! ONLY APPLICABLE IF top_height EQUALS 1 or 3
				 !				 !
				 ! 1 = old setting: matches all versions of 
				 ! ISCCP simulator with versions numbers 3.5.1 and lower
				 !
				 ! 2 = default setting: for version numbers 4.0 and higher
!
!     The following input variables are used only if top_height = 1 or top_height = 3
!
      REAL skt(npoints)                 !  skin Temperature (K)
      REAL emsfc_lw                     !  10.5 micron emissivity of surface (fraction)                                            
      REAL at(npoints,nlev)                   !  temperature in each model level (K)
      REAL dem_s(npoints,nlev)                !  10.5 micron longwave emissivity of stratiform
                              !  clouds in each
                                        !  model level.  Same note applies as in dtau_s.
      REAL dem_c(npoints,nlev)                  !  10.5 micron longwave emissivity of convective
                              !  clouds in each
                                        !  model level.  Same note applies as in dtau_s.

      REAL frac_out(npoints,ncol,nlev) ! boxes gridbox divided up into
                              ! Equivalent of BOX in original version, but
                              ! indexed by column then row, rather than
                              ! by row then column



!     ------
!     Output
!     ------

      REAL fq_isccp(npoints,7,7)        !  the fraction of the model grid box covered by
                                        !  each of the 49 ISCCP D level cloud types

      REAL totalcldarea(npoints)        !  the fraction of model grid box columns
                                        !  with cloud somewhere in them.  NOTE: This diagnostic
					! does not count model clouds with tau < isccp_taumin
                              ! Thus this diagnostic does not equal the sum over all entries of fq_isccp.
			      ! However, this diagnostic does equal the sum over entries of fq_isccp with
			      ! itau = 2:7 (omitting itau = 1)
      
      
      ! The following three means are averages only over the cloudy areas with tau > isccp_taumin.  
      ! If no clouds with tau > isccp_taumin are in grid box all three quantities should equal zero.      
                              
      REAL meanptop(npoints)            !  mean cloud top pressure (mb) - linear averaging
                                        !  in cloud top pressure.
                              
      REAL meantaucld(npoints)          !  mean optical thickness 
                                        !  linear averaging in albedo performed.
      
      real meanalbedocld(npoints)        ! mean cloud albedo
                                        ! linear averaging in albedo performed
					
      real meantb(npoints)              ! mean all-sky 10.5 micron brightness temperature
      
      real meantbclr(npoints)           ! mean clear-sky 10.5 micron brightness temperature
      
      REAL boxtau(npoints,ncol)         !  optical thickness in each column
      
      REAL boxptop(npoints,ncol)        !  cloud top pressure (mb) in each column
                              
                                                                                          
!
!     ------
!     Working variables added when program updated to mimic Mark Webb's PV-Wave code
!     ------

      REAL dem(npoints,ncol),bb(npoints)     !  working variables for 10.5 micron longwave 
                              !  emissivity in part of
                              !  gridbox under consideration

      REAL ptrop(npoints)
      REAL attrop(npoints)
      REAL attropmin (npoints)
      REAL atmax(npoints)
      REAL btcmin(npoints)
      REAL transmax(npoints)

      INTEGER i,j,ilev,ibox,itrop(npoints)
      INTEGER ipres(npoints)
      INTEGER itau(npoints),ilev2
      INTEGER acc(nlev,ncol)
      INTEGER match(npoints,nlev-1)
      INTEGER nmatch(npoints)
      INTEGER levmatch(npoints,ncol)
      
      !variables needed for water vapor continuum absorption
      real fluxtop_clrsky(npoints),trans_layers_above_clrsky(npoints)
      real taumin(npoints)
      real dem_wv(npoints,nlev), wtmair, wtmh20, Navo, grav, pstd, t0
      real press(npoints), dpress(npoints), atmden(npoints)
      real rvh20(npoints), wk(npoints), rhoave(npoints)
      real rh20s(npoints), rfrgn(npoints)
      real tmpexp(npoints),tauwv(npoints)
      
      character*1 cchar(6),cchar_realtops(6)
      integer icycle
      REAL tau(npoints,ncol)
      LOGICAL box_cloudy(npoints,ncol)
      REAL tb(npoints,ncol)
      REAL ptop(npoints,ncol)
      REAL emcld(npoints,ncol)
      REAL fluxtop(npoints,ncol)
      REAL trans_layers_above(npoints,ncol)
      real isccp_taumin,fluxtopinit(npoints),tauir(npoints)
      REAL albedocld(npoints,ncol)
      real boxarea
      integer debug       ! set to non-zero value to print out inputs
                    ! with step debug
      integer debugcol    ! set to non-zero value to print out column
                    ! decomposition with step debugcol
      integer rangevec(npoints),rangeerror

      integer index1(npoints),num1,jj,k1,k2
      real rec2p13,tauchk,logp,logp1,logp2,atd
      real output_missing_value

      character*10 ftn09
      
      DATA isccp_taumin / 0.3 /
      DATA output_missing_value / -1.E+30 /
      DATA cchar / ' ','-','1','+','I','+'/
      DATA cchar_realtops / ' ',' ','1','1','I','I'/

!     ------ End duplicate definitions common to wrapper routine

      tauchk = -1.*log(0.9999999)
      rec2p13=1./2.13

      ncolprint=0

      if ( debug.ne.0 ) then
          j=1
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write(6,'(a10)') 'debug='
          write(6,'(8I10)') debug
          write(6,'(a10)') 'debugcol='
          write(6,'(8I10)') debugcol
          write(6,'(a10)') 'npoints='
          write(6,'(8I10)') npoints
          write(6,'(a10)') 'nlev='
          write(6,'(8I10)') nlev
          write(6,'(a10)') 'ncol='
          write(6,'(8I10)') ncol
          write(6,'(a11)') 'top_height='
          write(6,'(8I10)') top_height
	  write(6,'(a21)') 'top_height_direction='
          write(6,'(8I10)') top_height_direction
          write(6,'(a10)') 'overlap='
          write(6,'(8I10)') overlap
          write(6,'(a10)') 'emsfc_lw='
          write(6,'(8f10.2)') emsfc_lw
        do j=1,npoints,debug
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write(6,'(a10)') 'sunlit='
          write(6,'(8I10)') sunlit(j)
          write(6,'(a10)') 'pfull='
          write(6,'(8f10.2)') (pfull(j,i),i=1,nlev)
          write(6,'(a10)') 'phalf='
          write(6,'(8f10.2)') (phalf(j,i),i=1,nlev+1)
          write(6,'(a10)') 'qv='
          write(6,'(8f10.3)') (qv(j,i),i=1,nlev)
          write(6,'(a10)') 'cc='
          write(6,'(8f10.3)') (cc(j,i),i=1,nlev)
          write(6,'(a10)') 'conv='
          write(6,'(8f10.2)') (conv(j,i),i=1,nlev)
          write(6,'(a10)') 'dtau_s='
          write(6,'(8g12.5)') (dtau_s(j,i),i=1,nlev)
          write(6,'(a10)') 'dtau_c='
          write(6,'(8f10.2)') (dtau_c(j,i),i=1,nlev)
          write(6,'(a10)') 'skt='
          write(6,'(8f10.2)') skt(j)
          write(6,'(a10)') 'at='
          write(6,'(8f10.2)') (at(j,i),i=1,nlev)
          write(6,'(a10)') 'dem_s='
          write(6,'(8f10.3)') (dem_s(j,i),i=1,nlev)
          write(6,'(a10)') 'dem_c='
          write(6,'(8f10.3)') (dem_c(j,i),i=1,nlev)
        enddo
      endif

!     ---------------------------------------------------!

      if (ncolprint.ne.0) then
      do j=1,npoints,1000
        write(6,'(a10)') 'j='
        write(6,'(8I10)') j
      enddo
      endif

      if (top_height .eq. 1 .or. top_height .eq. 3) then 

      do j=1,npoints 
          ptrop(j)=5000.
          attropmin(j) = 400.
          atmax(j) = 0.
          attrop(j) = 120.
          itrop(j) = 1
      enddo 

      do 12 ilev=1,nlev
        do j=1,npoints 
         if (pfull(j,ilev) .lt. 40000. .and.
     &          pfull(j,ilev) .gt.  5000. .and.
     &          at(j,ilev) .lt. attropmin(j)) then
                ptrop(j) = pfull(j,ilev)
                attropmin(j) = at(j,ilev)
                attrop(j) = attropmin(j)
                itrop(j)=ilev
           end if
        enddo
12    continue

      do 13 ilev=1,nlev
        do j=1,npoints 
           if (at(j,ilev) .gt. atmax(j) .and.
     &              ilev  .ge. itrop(j)) atmax(j)=at(j,ilev)
        enddo
13    continue

      end if


      if (top_height .eq. 1 .or. top_height .eq. 3) then
          do j=1,npoints
              meantb(j) = 0.
	      meantbclr(j) = 0. 
          end do
      else
          do j=1,npoints
              meantb(j) = output_missing_value
       	      meantbclr(j) = output_missing_value
          end do
      end if
      
!     -----------------------------------------------------!

!     ---------------------------------------------------!

      do ilev=1,nlev
        do j=1,npoints

          rangevec(j)=0

          if (cc(j,ilev) .lt. 0. .or. cc(j,ilev) .gt. 1.) then
!           error = cloud fraction less than zero
!           error = cloud fraction greater than 1
            rangevec(j)=rangevec(j)+1
          endif

          if (conv(j,ilev) .lt. 0. .or. conv(j,ilev) .gt. 1.) then
!           ' error = convective cloud fraction less than zero'
!           ' error = convective cloud fraction greater than 1'
            rangevec(j)=rangevec(j)+2
          endif

          if (dtau_s(j,ilev) .lt. 0.) then
!           ' error = stratiform cloud opt. depth less than zero'
            rangevec(j)=rangevec(j)+4
          endif

          if (dtau_c(j,ilev) .lt. 0.) then
!           ' error = convective cloud opt. depth less than zero'
            rangevec(j)=rangevec(j)+8
          endif

          if (dem_s(j,ilev) .lt. 0. .or. dem_s(j,ilev) .gt. 1.) then
!             ' error = stratiform cloud emissivity less than zero'
!             ' error = stratiform cloud emissivity greater than 1'
            rangevec(j)=rangevec(j)+16
          endif

          if (dem_c(j,ilev) .lt. 0. .or. dem_c(j,ilev) .gt. 1.) then
!             ' error = convective cloud emissivity less than zero'
!             ' error = convective cloud emissivity greater than 1'
              rangevec(j)=rangevec(j)+32
          endif
        enddo

        rangeerror=0
        do j=1,npoints
            rangeerror=rangeerror+rangevec(j)
        enddo

        if (rangeerror.ne.0) then 
              write (6,*) 'Input variable out of range'
              write (6,*) 'rangevec:'
              write (6,*) rangevec
              STOP
        endif
      enddo

!
!     ---------------------------------------------------!

      
!
!     ---------------------------------------------------!
!     COMPUTE CLOUD OPTICAL DEPTH FOR EACH COLUMN and
!     put into vector tau
 
      !initialize tau and albedocld to zero
      do 15 ibox=1,ncol
        do j=1,npoints 
            tau(j,ibox)=0.
          albedocld(j,ibox)=0.
          boxtau(j,ibox)=output_missing_value
          boxptop(j,ibox)=output_missing_value
          box_cloudy(j,ibox)=.false.
        enddo
15    continue

      !compute total cloud optical depth for each column     
      do ilev=1,nlev
            !increment tau for each of the boxes
            do ibox=1,ncol
              do j=1,npoints 
                 if (frac_out(j,ibox,ilev).eq.1) then
                        tau(j,ibox)=tau(j,ibox)
     &                     + dtau_s(j,ilev)
                 endif
                 if (frac_out(j,ibox,ilev).eq.2) then
                        tau(j,ibox)=tau(j,ibox)
     &                     + dtau_c(j,ilev)
                 end if
              enddo
            enddo ! ibox
      enddo ! ilev
          if (ncolprint.ne.0) then

              do j=1,npoints ,1000
                write(6,'(a10)') 'j='
                write(6,'(8I10)') j
                write(6,'(i2,1X,8(f7.2,1X))') 
     &          ilev,
     &          (tau(j,ibox),ibox=1,ncolprint)
              enddo
          endif 
!
!     ---------------------------------------------------!



!     
!     ---------------------------------------------------!
!     COMPUTE INFRARED BRIGHTNESS TEMPERUATRES
!     AND CLOUD TOP TEMPERATURE SATELLITE SHOULD SEE
!
!     again this is only done if top_height = 1 or 3
!
!     fluxtop is the 10.5 micron radiance at the top of the
!              atmosphere
!     trans_layers_above is the total transmissivity in the layers
!             above the current layer
!     fluxtop_clrsky(j) and trans_layers_above_clrsky(j) are the clear
!             sky versions of these quantities.

      if (top_height .eq. 1 .or. top_height .eq. 3) then


        !----------------------------------------------------------------------
        !    
        !             DO CLEAR SKY RADIANCE CALCULATION FIRST
        !
        !compute water vapor continuum emissivity
        !this treatment follows Schwarkzopf and Ramasamy
        !JGR 1999,vol 104, pages 9467-9499.
        !the emissivity is calculated at a wavenumber of 955 cm-1, 
        !or 10.47 microns 
        wtmair = 28.9644
        wtmh20 = 18.01534
        Navo = 6.023E+23
        grav = 9.806650E+02
        pstd = 1.013250E+06
        t0 = 296.
        if (ncolprint .ne. 0) 
     &         write(6,*)  'ilev   pw (kg/m2)   tauwv(j)      dem_wv'
        do 125 ilev=1,nlev
          do j=1,npoints 
               !press and dpress are dyne/cm2 = Pascals *10
               press(j) = pfull(j,ilev)*10.
               dpress(j) = (phalf(j,ilev+1)-phalf(j,ilev))*10
               !atmden = g/cm2 = kg/m2 / 10 
               atmden(j) = dpress(j)/grav
               rvh20(j) = qv(j,ilev)*wtmair/wtmh20
               wk(j) = rvh20(j)*Navo*atmden(j)/wtmair
               rhoave(j) = (press(j)/pstd)*(t0/at(j,ilev))
               rh20s(j) = rvh20(j)*rhoave(j)
               rfrgn(j) = rhoave(j)-rh20s(j)
               tmpexp(j) = exp(-0.02*(at(j,ilev)-t0))
               tauwv(j) = wk(j)*1.e-20*( 
     &           (0.0224697*rh20s(j)*tmpexp(j)) + 
     &                (3.41817e-7*rfrgn(j)) )*0.98
               dem_wv(j,ilev) = 1. - exp( -1. * tauwv(j))
          enddo
               if (ncolprint .ne. 0) then
               do j=1,npoints ,1000
               write(6,'(a10)') 'j='
               write(6,'(8I10)') j
               write(6,'(i2,1X,3(f8.3,3X))') ilev,
     &           qv(j,ilev)*(phalf(j,ilev+1)-phalf(j,ilev))/(grav/100.),
     &           tauwv(j),dem_wv(j,ilev)
               enddo
             endif
125     continue

        !initialize variables
        do j=1,npoints 
          fluxtop_clrsky(j) = 0.
          trans_layers_above_clrsky(j)=1.
        enddo

        do ilev=1,nlev
          do j=1,npoints 
 
            ! Black body emission at temperature of the layer

              bb(j)=1 / ( exp(1307.27/at(j,ilev)) - 1. )
              !bb(j)= 5.67e-8*at(j,ilev)**4

              ! increase TOA flux by flux emitted from layer
              ! times total transmittance in layers above

                fluxtop_clrsky(j) = fluxtop_clrsky(j) 
     &            + dem_wv(j,ilev)*bb(j)*trans_layers_above_clrsky(j) 
            
                ! update trans_layers_above with transmissivity
              ! from this layer for next time around loop

                trans_layers_above_clrsky(j)=
     &            trans_layers_above_clrsky(j)*(1.-dem_wv(j,ilev))
                   

          enddo   
            if (ncolprint.ne.0) then
             do j=1,npoints ,1000
              write(6,'(a10)') 'j='
              write(6,'(8I10)') j
              write (6,'(a)') 'ilev:'
              write (6,'(I2)') ilev
    
              write (6,'(a)') 
     &        'emiss_layer,100.*bb(j),100.*f,total_trans:'
              write (6,'(4(f7.2,1X))') dem_wv(j,ilev),100.*bb(j),
     &             100.*fluxtop_clrsky(j),trans_layers_above_clrsky(j)
             enddo   
            endif

        enddo   !loop over level
        
        do j=1,npoints 
          !add in surface emission
          bb(j)=1/( exp(1307.27/skt(j)) - 1. )
          !bb(j)=5.67e-8*skt(j)**4

          fluxtop_clrsky(j) = fluxtop_clrsky(j) + emsfc_lw * bb(j) 
     &     * trans_layers_above_clrsky(j)
     
          !clear sky brightness temperature
          meantbclr(j) = 1307.27/(log(1.+(1./fluxtop_clrsky(j))))
	  
        enddo

        if (ncolprint.ne.0) then
        do j=1,npoints ,1000
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write (6,'(a)') 'id:'
          write (6,'(a)') 'surface'

          write (6,'(a)') 'emsfc,100.*bb(j),100.*f,total_trans:'
          write (6,'(5(f7.2,1X))') emsfc_lw,100.*bb(j),
     &      100.*fluxtop_clrsky(j),
     &       trans_layers_above_clrsky(j), meantbclr(j)
        enddo
      endif
    

        !
        !           END OF CLEAR SKY CALCULATION
        !
        !----------------------------------------------------------------



        if (ncolprint.ne.0) then

        do j=1,npoints ,1000
            write(6,'(a10)') 'j='
            write(6,'(8I10)') j
            write (6,'(a)') 'ts:'
            write (6,'(8f7.2)') (skt(j),ibox=1,ncolprint)
    
            write (6,'(a)') 'ta_rev:'
            write (6,'(8f7.2)') 
     &       ((at(j,ilev2),ibox=1,ncolprint),ilev2=1,nlev)

        enddo
        endif 
        !loop over columns 
        do ibox=1,ncol
          do j=1,npoints
            fluxtop(j,ibox)=0.
            trans_layers_above(j,ibox)=1.
          enddo
        enddo

        do ilev=1,nlev
              do j=1,npoints 
                ! Black body emission at temperature of the layer

              bb(j)=1 / ( exp(1307.27/at(j,ilev)) - 1. )
              !bb(j)= 5.67e-8*at(j,ilev)**4
              enddo

            do ibox=1,ncol
              do j=1,npoints 

              ! emissivity for point in this layer
                if (frac_out(j,ibox,ilev).eq.1) then
                dem(j,ibox)= 1. - 
     &             ( (1. - dem_wv(j,ilev)) * (1. -  dem_s(j,ilev)) )
                else if (frac_out(j,ibox,ilev).eq.2) then
                dem(j,ibox)= 1. - 
     &             ( (1. - dem_wv(j,ilev)) * (1. -  dem_c(j,ilev)) )
                else
                dem(j,ibox)=  dem_wv(j,ilev)
                end if
                

                ! increase TOA flux by flux emitted from layer
              ! times total transmittance in layers above

                fluxtop(j,ibox) = fluxtop(j,ibox) 
     &            + dem(j,ibox) * bb(j)
     &            * trans_layers_above(j,ibox) 
            
                ! update trans_layers_above with transmissivity
              ! from this layer for next time around loop

                trans_layers_above(j,ibox)=
     &            trans_layers_above(j,ibox)*(1.-dem(j,ibox))

              enddo ! j
            enddo ! ibox

            if (ncolprint.ne.0) then
              do j=1,npoints,1000
              write (6,'(a)') 'ilev:'
              write (6,'(I2)') ilev
    
              write(6,'(a10)') 'j='
              write(6,'(8I10)') j
              write (6,'(a)') 'emiss_layer:'
              write (6,'(8f7.2)') (dem(j,ibox),ibox=1,ncolprint)
        
              write (6,'(a)') '100.*bb(j):'
              write (6,'(8f7.2)') (100.*bb(j),ibox=1,ncolprint)
        
              write (6,'(a)') '100.*f:'
              write (6,'(8f7.2)') 
     &         (100.*fluxtop(j,ibox),ibox=1,ncolprint)
        
              write (6,'(a)') 'total_trans:'
              write (6,'(8f7.2)') 
     &          (trans_layers_above(j,ibox),ibox=1,ncolprint)
            enddo
          endif

        enddo ! ilev


          do j=1,npoints 
            !add in surface emission
            bb(j)=1/( exp(1307.27/skt(j)) - 1. )
            !bb(j)=5.67e-8*skt(j)**4
          end do

        do ibox=1,ncol
          do j=1,npoints 

            !add in surface emission

            fluxtop(j,ibox) = fluxtop(j,ibox) 
     &         + emsfc_lw * bb(j) 
     &         * trans_layers_above(j,ibox) 
            
          end do
        end do

        !calculate mean infrared brightness temperature
        do ibox=1,ncol
          do j=1,npoints 
            meantb(j) = meantb(j)+1307.27/(log(1.+(1./fluxtop(j,ibox))))
	  end do
        end do
	  do j=1, npoints
	    meantb(j) = meantb(j) / real(ncol)
	  end do        

        if (ncolprint.ne.0) then

          do j=1,npoints ,1000
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write (6,'(a)') 'id:'
          write (6,'(a)') 'surface'

          write (6,'(a)') 'emiss_layer:'
          write (6,'(8f7.2)') (dem(1,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') '100.*bb(j):'
          write (6,'(8f7.2)') (100.*bb(j),ibox=1,ncolprint)
    
          write (6,'(a)') '100.*f:'
          write (6,'(8f7.2)') (100.*fluxtop(j,ibox),ibox=1,ncolprint)
          
	  write (6,'(a)') 'meantb(j):'
          write (6,'(8f7.2)') (meantb(j),ibox=1,ncolprint)
      
          end do
      endif
    
        !now that you have the top of atmosphere radiance account
        !for ISCCP procedures to determine cloud top temperature

        !account for partially transmitting cloud recompute flux 
        !ISCCP would see assuming a single layer cloud
        !note choice here of 2.13, as it is primarily ice
        !clouds which have partial emissivity and need the 
        !adjustment performed in this section
        !
      !If it turns out that the cloud brightness temperature
      !is greater than 260K, then the liquid cloud conversion
        !factor of 2.56 is used.
      !
        !Note that this is discussed on pages 85-87 of 
        !the ISCCP D level documentation (Rossow et al. 1996)
           
          do j=1,npoints  
            !compute minimum brightness temperature and optical depth
            btcmin(j) = 1. /  ( exp(1307.27/(attrop(j)-5.)) - 1. ) 
          enddo 
        do ibox=1,ncol
          do j=1,npoints  
            transmax(j) = (fluxtop(j,ibox)-btcmin(j))
     &                /(fluxtop_clrsky(j)-btcmin(j))
          !note that the initial setting of tauir(j) is needed so that
          !tauir(j) has a realistic value should the next if block be
          !bypassed
            tauir(j) = tau(j,ibox) * rec2p13
            taumin(j) = -1. * log(max(min(transmax(j),0.9999999),0.001))

          enddo 

          if (top_height .eq. 1) then
            do j=1,npoints  
              if (transmax(j) .gt. 0.001 .and. 
     &          transmax(j) .le. 0.9999999) then
                fluxtopinit(j) = fluxtop(j,ibox)
              tauir(j) = tau(j,ibox) *rec2p13
              endif
            enddo
            do icycle=1,2
              do j=1,npoints  
                if (tau(j,ibox) .gt. (tauchk            )) then 
                if (transmax(j) .gt. 0.001 .and. 
     &            transmax(j) .le. 0.9999999) then
                  emcld(j,ibox) = 1. - exp(-1. * tauir(j)  )
                  fluxtop(j,ibox) = fluxtopinit(j) -   
     &              ((1.-emcld(j,ibox))*fluxtop_clrsky(j))
                  fluxtop(j,ibox)=max(1.E-06,
     &              (fluxtop(j,ibox)/emcld(j,ibox)))
                  tb(j,ibox)= 1307.27
     &              / (log(1. + (1./fluxtop(j,ibox))))
                  if (tb(j,ibox) .gt. 260.) then
                  tauir(j) = tau(j,ibox) / 2.56
                  end if                   
                end if
                end if
              enddo
            enddo
                
          endif
        
          do j=1,npoints
            if (tau(j,ibox) .gt. (tauchk            )) then 
                !cloudy box 
		!NOTE: tb is the cloud-top temperature not infrared brightness temperature 
		!at this point in the code
                tb(j,ibox)= 1307.27/ (log(1. + (1./fluxtop(j,ibox))))
                if (top_height.eq.1.and.tauir(j).lt.taumin(j)) then
                         tb(j,ibox) = attrop(j) - 5. 
                   tau(j,ibox) = 2.13*taumin(j)
                end if
            else
                !clear sky brightness temperature
                tb(j,ibox) = meantbclr(j)
            end if
          enddo ! j
        enddo ! ibox

        if (ncolprint.ne.0) then

          do j=1,npoints,1000
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j

          write (6,'(a)') 'attrop:'
          write (6,'(8f7.2)') (attrop(j))
    
          write (6,'(a)') 'btcmin:'
          write (6,'(8f7.2)') (btcmin(j))
    
          write (6,'(a)') 'fluxtop_clrsky*100:'
          write (6,'(8f7.2)') 
     &      (100.*fluxtop_clrsky(j))

          write (6,'(a)') '100.*f_adj:'
          write (6,'(8f7.2)') (100.*fluxtop(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'transmax:'
          write (6,'(8f7.2)') (transmax(ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'tau:'
          write (6,'(8f7.2)') (tau(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'emcld:'
          write (6,'(8f7.2)') (emcld(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'total_trans:'
          write (6,'(8f7.2)') 
     &        (trans_layers_above(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'total_emiss:'
          write (6,'(8f7.2)') 
     &        (1.0-trans_layers_above(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'total_trans:'
          write (6,'(8f7.2)') 
     &        (trans_layers_above(j,ibox),ibox=1,ncolprint)
    
          write (6,'(a)') 'ppout:'
          write (6,'(8f7.2)') (tb(j,ibox),ibox=1,ncolprint)
          enddo ! j
      endif

      end if

!     ---------------------------------------------------!

!     
!     ---------------------------------------------------!
!     DETERMINE CLOUD TOP PRESSURE
!
!     again the 2 methods differ according to whether
!     or not you use the physical cloud top pressure (top_height = 2)
!     or the radiatively determined cloud top pressure (top_height = 1 or 3)
!

      !compute cloud top pressure
      do 30 ibox=1,ncol
        !segregate according to optical thickness
        if (top_height .eq. 1 .or. top_height .eq. 3) then  
          !find level whose temperature
          !most closely matches brightness temperature
          do j=1,npoints 
            nmatch(j)=0
          enddo
          do 29 k1=1,nlev-1
	    if (top_height_direction .eq. 2) then
	      ilev = nlev - k1 
	    else
	      ilev = k1
	    end if
            !cdir nodep
            do j=1,npoints 
	     if (ilev .ge. itrop(j)) then
              if ((at(j,ilev)   .ge. tb(j,ibox) .and. 
     &          at(j,ilev+1) .le. tb(j,ibox)) .or.
     &          (at(j,ilev) .le. tb(j,ibox) .and. 
     &          at(j,ilev+1) .ge. tb(j,ibox))) then 
                nmatch(j)=nmatch(j)+1
		match(j,nmatch(j))=ilev
              end if  
	     end if                         
            enddo
29        continue

          do j=1,npoints 
            if (nmatch(j) .ge. 1) then
              k1 = match(j,nmatch(j))
	      k2 = k1 + 1
              logp1 = log(pfull(j,k1))
              logp2 = log(pfull(j,k2))
	      atd = max(tauchk,abs(at(j,k2) - at(j,k1)))
              logp=logp1+(logp2-logp1)*abs(tb(j,ibox)-at(j,k1))/atd
              ptop(j,ibox) = exp(logp)
	      if(abs(pfull(j,k1)-ptop(j,ibox)) .lt.
     &            abs(pfull(j,k2)-ptop(j,ibox))) then
                 levmatch(j,ibox)=k1
              else
                 levmatch(j,ibox)=k2
              end if   
            else
              if (tb(j,ibox) .le. attrop(j)) then
                ptop(j,ibox)=ptrop(j)
                levmatch(j,ibox)=itrop(j)
              end if
              if (tb(j,ibox) .ge. atmax(j)) then
                ptop(j,ibox)=pfull(j,nlev)
                levmatch(j,ibox)=nlev
              end if                                
            end if
          enddo ! j

        else ! if (top_height .eq. 1 .or. top_height .eq. 3) 
 
          do j=1,npoints     
            ptop(j,ibox)=0.
          enddo
          do ilev=1,nlev
            do j=1,npoints     
              if ((ptop(j,ibox) .eq. 0. )
     &           .and.(frac_out(j,ibox,ilev) .ne. 0)) then
                ptop(j,ibox)=phalf(j,ilev)
              levmatch(j,ibox)=ilev
              end if
            end do
          end do
        end if                            
          
        do j=1,npoints
          if (tau(j,ibox) .le. (tauchk            )) then
            ptop(j,ibox)=0.
            levmatch(j,ibox)=0      
          endif 
        enddo

30    continue
              
!
!
!     ---------------------------------------------------!


!     
!     ---------------------------------------------------!
!     DETERMINE ISCCP CLOUD TYPE FREQUENCIES
!
!     Now that ptop and tau have been determined, 
!     determine amount of each of the 49 ISCCP cloud
!     types
!
!     Also compute grid box mean cloud top pressure and
!     optical thickness.  The mean cloud top pressure and
!     optical thickness are averages over the cloudy 
!     area only. The mean cloud top pressure is a linear
!     average of the cloud top pressures.  The mean cloud
!     optical thickness is computed by converting optical
!     thickness to an albedo, averaging in albedo units,
!     then converting the average albedo back to a mean
!     optical thickness.  
!

      !compute isccp frequencies

      !reset frequencies
      do 38 ilev=1,7
      do 38 ilev2=1,7
        do j=1,npoints ! 
             if (sunlit(j).eq.1 .or. top_height .eq. 3) then 
                fq_isccp(j,ilev,ilev2)= 0.
	     else
	        fq_isccp(j,ilev,ilev2)= output_missing_value
	     end if
        enddo
38    continue

      !reset variables need for averaging cloud properties
      do j=1,npoints 
        if (sunlit(j).eq.1 .or. top_height .eq. 3) then 
             totalcldarea(j) = 0.
             meanalbedocld(j) = 0.
             meanptop(j) = 0.
             meantaucld(j) = 0.
	else
             totalcldarea(j) = output_missing_value
             meanalbedocld(j) = output_missing_value
             meanptop(j) = output_missing_value
             meantaucld(j) = output_missing_value
	end if
      enddo ! j

      boxarea = 1./real(ncol)
     
      do 39 ibox=1,ncol
        do j=1,npoints 

          if (tau(j,ibox) .gt. (tauchk            )
     &      .and. ptop(j,ibox) .gt. 0.) then
              box_cloudy(j,ibox)=.true.
          endif

          if (box_cloudy(j,ibox)) then

              if (sunlit(j).eq.1 .or. top_height .eq. 3) then

                boxtau(j,ibox) = tau(j,ibox)

		if (tau(j,ibox) .ge. isccp_taumin) then
		   totalcldarea(j) = totalcldarea(j) + boxarea
		
                   !convert optical thickness to albedo
                   albedocld(j,ibox)
     &		   = (tau(j,ibox)**0.895)/((tau(j,ibox)**0.895)+6.82)
         
                   !contribute to averaging
                   meanalbedocld(j) = meanalbedocld(j) 
     &                                +albedocld(j,ibox)*boxarea

                end if

            endif

          endif

          if (sunlit(j).eq.1 .or. top_height .eq. 3) then 

           if (box_cloudy(j,ibox)) then
          
              !convert ptop to millibars
              ptop(j,ibox)=ptop(j,ibox) / 100.
            
              !save for output cloud top pressure and optical thickness
              boxptop(j,ibox) = ptop(j,ibox)
    
              if (tau(j,ibox) .ge. isccp_taumin) then
	      	meanptop(j) = meanptop(j) + ptop(j,ibox)*boxarea
              end if		

              !reset itau(j), ipres(j)
              itau(j) = 0
              ipres(j) = 0

              !determine optical depth category
              if (tau(j,ibox) .lt. isccp_taumin) then
                  itau(j)=1
              else if (tau(j,ibox) .ge. isccp_taumin
     &                                    
     &          .and. tau(j,ibox) .lt. 1.3) then
                itau(j)=2
              else if (tau(j,ibox) .ge. 1.3 
     &          .and. tau(j,ibox) .lt. 3.6) then
                itau(j)=3
              else if (tau(j,ibox) .ge. 3.6 
     &          .and. tau(j,ibox) .lt. 9.4) then
                  itau(j)=4
              else if (tau(j,ibox) .ge. 9.4 
     &          .and. tau(j,ibox) .lt. 23.) then
                  itau(j)=5
              else if (tau(j,ibox) .ge. 23. 
     &          .and. tau(j,ibox) .lt. 60.) then
                  itau(j)=6
              else if (tau(j,ibox) .ge. 60.) then
                  itau(j)=7
              end if

              !determine cloud top pressure category
              if (    ptop(j,ibox) .gt. 0.  
     &          .and.ptop(j,ibox) .lt. 180.) then
                  ipres(j)=1
              else if(ptop(j,ibox) .ge. 180.
     &          .and.ptop(j,ibox) .lt. 310.) then
                  ipres(j)=2
              else if(ptop(j,ibox) .ge. 310.
     &          .and.ptop(j,ibox) .lt. 440.) then
                  ipres(j)=3
              else if(ptop(j,ibox) .ge. 440.
     &          .and.ptop(j,ibox) .lt. 560.) then
                  ipres(j)=4
              else if(ptop(j,ibox) .ge. 560.
     &          .and.ptop(j,ibox) .lt. 680.) then
                  ipres(j)=5
              else if(ptop(j,ibox) .ge. 680.
     &          .and.ptop(j,ibox) .lt. 800.) then
                  ipres(j)=6
              else if(ptop(j,ibox) .ge. 800.) then
                  ipres(j)=7
              end if 

              !update frequencies
              if(ipres(j) .gt. 0.and.itau(j) .gt. 0) then
              fq_isccp(j,itau(j),ipres(j))=
     &          fq_isccp(j,itau(j),ipres(j))+ boxarea
              end if

            end if

          end if
                       
        enddo ! j
39    continue
      
      !compute mean cloud properties
      do j=1,npoints 
        if (totalcldarea(j) .gt. 0.) then
	  ! code above guarantees that totalcldarea > 0 
	  ! only if sunlit .eq. 1 .or. top_height = 3 
	  ! and applies only to clouds with tau > isccp_taumin
          meanptop(j) = meanptop(j) / totalcldarea(j)
          meanalbedocld(j) = meanalbedocld(j) / totalcldarea(j)
          meantaucld(j) = (6.82/((1./meanalbedocld(j))-1.))**(1./0.895)
	else
	  ! this code is necessary so that in the case that totalcldarea = 0.,
	  ! that these variables, which are in-cloud averages, are set to missing
	  ! note that totalcldarea will be 0. if all the clouds in the grid box have
	  ! tau < isccp_taumin 
	  meanptop(j) = output_missing_value
          meanalbedocld(j) = output_missing_value
          meantaucld(j) = output_missing_value
        end if
      enddo ! j
!
!     ---------------------------------------------------!

!     ---------------------------------------------------!
!     OPTIONAL PRINTOUT OF DATA TO CHECK PROGRAM
!
      if (debugcol.ne.0) then
!     
         do j=1,npoints,debugcol

            !produce character output
            do ilev=1,nlev
              do ibox=1,ncol
                   acc(ilev,ibox)=0
              enddo
            enddo

            do ilev=1,nlev
              do ibox=1,ncol
                   acc(ilev,ibox)=frac_out(j,ibox,ilev)*2
                   if (levmatch(j,ibox) .eq. ilev) 
     &                 acc(ilev,ibox)=acc(ilev,ibox)+1
              enddo
            enddo

             !print test

          write(ftn09,11) j
11        format('ftn09.',i4.4)
          open(9, FILE=ftn09, FORM='FORMATTED')

             write(9,'(a1)') ' '
             write(9,'(10i5)')
     &                  (ilev,ilev=5,nlev,5)
             write(9,'(a1)') ' '
             
             do ibox=1,ncol
               write(9,'(40(a1),1x,40(a1))')
     &           (cchar_realtops(acc(ilev,ibox)+1),ilev=1,nlev) 
     &           ,(cchar(acc(ilev,ibox)+1),ilev=1,nlev) 
             end do
             close(9)

             if (ncolprint.ne.0) then
               write(6,'(a1)') ' '
                    write(6,'(a2,1X,5(a7,1X),a50)') 
     &                  'ilev',
     &                  'pfull','at',
     &                  'cc*100','dem_s','dtau_s',
     &                  'cchar'

!               do 4012 ilev=1,nlev
!                    write(6,'(60i2)') (box(i,ilev),i=1,ncolprint)
!                   write(6,'(i2,1X,5(f7.2,1X),50(a1))') 
!     &                  ilev,
!     &                  pfull(j,ilev)/100.,at(j,ilev),
!     &                  cc(j,ilev)*100.0,dem_s(j,ilev),dtau_s(j,ilev)
!     &                  ,(cchar(acc(ilev,ibox)+1),ibox=1,ncolprint)
!4012           continue
               write (6,'(a)') 'skt(j):'
               write (6,'(8f7.2)') skt(j)
                                      
               write (6,'(8I7)') (ibox,ibox=1,ncolprint)
            
               write (6,'(a)') 'tau:'
               write (6,'(8f7.2)') (tau(j,ibox),ibox=1,ncolprint)
    
               write (6,'(a)') 'tb:'
               write (6,'(8f7.2)') (tb(j,ibox),ibox=1,ncolprint)
    
               write (6,'(a)') 'ptop:'
               write (6,'(8f7.2)') (ptop(j,ibox),ibox=1,ncolprint)
             endif 
    
        enddo
       
      end if 

      return
      end 

module nc_utils
	use netcdf
	implicit none
contains
	subroutine nc_check(status)
		integer, intent(in) :: status

		if(status /= nf90_noerr) then
			print *, trim(nf90_strerror(status))
			stop ''
		end if
	end subroutine

	subroutine nc_inq_var(ncid, name, varid, dims)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		integer, intent(out) :: varid
		integer, dimension(:), allocatable, intent(out) :: dims

		integer :: xtype, ndims
		character(len=NF90_MAX_NAME) :: xname
		integer, dimension(NF90_MAX_VAR_DIMS) :: dimids
		integer :: i
		integer :: status

		status = nf90_inq_varid(ncid, name, varid)
		if(status /= nf90_noerr) then
			write(*, "(a,': ',a)") trim(name), trim(nf90_strerror(status))
			stop ''
		end if

		call nc_check(nf90_inquire_variable(ncid, varid, xname, xtype, ndims, dimids))

		allocate(dims(ndims))
		dims = 0

		do i=1,ndims
			call nc_check(nf90_inquire_dimension(ncid, dimids(i), len=dims(i)))
		end do
	end subroutine

	function nc_count(dims, start, count) result(count_new)
		integer, dimension(:), intent(in) :: dims
		integer, dimension(:), intent(in), optional :: start
		integer, dimension(:), intent(in), optional :: count
		integer, dimension(size(dims)) :: count_new

		if (present(start) .and. present(count)) then
			count_new = count
			where (count == -1)
				count_new = dims - start + 1
			end where
		else
			count_new = dims
		end if
	end function

	subroutine nc_get_var_0d_real(ncid, name, var)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		real(8), intent(out) :: var

		integer, dimension(:), allocatable :: dims
		integer :: varid

		call nc_inq_var(ncid, name, varid, dims)
		call nc_check(nf90_get_var(ncid, varid, var))
	end subroutine

	subroutine nc_get_var_1d_real(ncid, name, var, start, count)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		real(8), dimension(:), allocatable, intent(out) :: var
		integer, dimension(:), intent(in), optional :: start, count

		integer, dimension(:), allocatable :: dims
		integer :: varid
		integer, dimension(1) :: count_new

		call nc_inq_var(ncid, name, varid, dims)
		count_new = nc_count(dims, start, count)
		allocate(var(count_new(1)))
		call nc_check(nf90_get_var(ncid, varid, var, start, count_new))
	end subroutine

	subroutine nc_get_var_2d_real(ncid, name, var, start, count)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		real(8), dimension(:, :), allocatable, intent(out) :: var
		integer, dimension(:), intent(in), optional :: start, count

		integer, dimension(:), allocatable :: dims
		integer :: varid
		integer, dimension(2) :: count_new

		call nc_inq_var(ncid, name, varid, dims)
		count_new = nc_count(dims, start, count)
		allocate(var(count_new(1), count_new(2)))
		call nc_check(nf90_get_var(ncid, varid, var, start, count_new))
	end subroutine

	subroutine nc_get_var_3d_real(ncid, name, var, start, count)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		real(8), dimension(:, :, :), allocatable, intent(out) :: var
		integer, dimension(:), intent(in), optional :: start, count

		integer, dimension(:), allocatable :: dims
		integer :: varid
		integer, dimension(3) :: count_new

		call nc_inq_var(ncid, name, varid, dims)
		count_new = nc_count(dims, start, count)
		allocate(var(count_new(1), count_new(2), count_new(3)))
		call nc_check(nf90_get_var(ncid, varid, var))
	end subroutine

	subroutine nc_get_var_4d_real(ncid, name, var, start, count)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		real(8), dimension(:, :, :, :), allocatable, intent(out) :: var
		integer, dimension(:), intent(in), optional :: start, count

		integer, dimension(:), allocatable :: dims
		integer :: varid
		integer, dimension(4) :: count_new

		call nc_inq_var(ncid, name, varid, dims)
		count_new = nc_count(dims, start, count)
		allocate(var(count_new(1), count_new(2), count_new(3), count_new(4)))
		call nc_check(nf90_get_var(ncid, varid, var, start, count_new))
	end subroutine

	subroutine nc_def_var(ncid, name, xtype, dims, varid)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		integer, dimension(:), intent(in) :: dims
		integer, intent(in) :: xtype
		integer, intent(out) :: varid

		character(len=NF90_MAX_NAME) :: dimname
		integer :: status
		integer :: i
		integer, dimension(:), allocatable :: dimids

		allocate(dimids(size(dims)))
		status = nf90_redef(ncid)
		do i = 1, size(dims)
			write(dimname, "(I32)") i
			call nc_check(nf90_def_dim( &
				ncid, &
				name // '_' // adjustl(dimname), &
				dims(i), &
				dimids(i) &
			))
		end do
		call nc_check(nf90_def_var( &
			ncid, &
			name, &
			xtype, &
			dimids, &
			varid &
		))
		call nc_check(nf90_enddef(ncid))
	end subroutine

	subroutine nc_put_var_1d_real(ncid, name, var, dimids)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		real(8), dimension(:), intent(in) :: var
		integer, dimension(1), intent(in), optional :: dimids

		integer :: varid
		character(len=NF90_MAX_NAME) :: dimname
		integer, dimension(1) :: xdimids
		integer :: status

		status = nf90_redef(ncid)
		if (present(dimids)) then
			xdimids = dimids
		else
			write(dimname, "(A,'_',I0)") name, 1
			call nc_check(nf90_def_dim( &
				ncid, &
				dimname, &
				size(var), &
				xdimids(1) &
			))
		end if
		call nc_def_var(ncid, name, nf90_double, xdimids, varid)
		call nc_check(nf90_put_var(ncid, varid, var))
	end subroutine

	subroutine nc_put_var_2d_real(ncid, name, var, dimids)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		real(8), dimension(:, :), intent(in) :: var
		integer, dimension(2), intent(in), optional :: dimids

		character(len=NF90_MAX_NAME) :: dimname
		integer, dimension(2) :: xdimids
		integer :: varid
		integer :: i
		integer :: status

		status = nf90_redef(ncid)
		if (present(dimids)) then
			xdimids = dimids
		else
			do i = 1, 2
				write(dimname, "(A,'_',I0)") name, i
				call nc_check(nf90_def_dim( &
					ncid, &
					dimname, &
					size(var, i), &
					xdimids(i) &
				))
			end do
		end if
		call nc_check(nf90_def_var( &
			ncid, &
			name, &
			nf90_double, &
			xdimids, &
			varid &
		))
		call nc_check(nf90_enddef(ncid))
		call nc_check(nf90_put_var(ncid, varid, var))
	end subroutine

	subroutine nc_put_var_3d_real(ncid, name, var, dimids)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		real(8), dimension(:, :, :), intent(in) :: var
		integer, dimension(3), intent(in), optional :: dimids

		character(len=NF90_MAX_NAME) :: dimname
		integer, dimension(3) :: xdimids
		integer :: varid
		integer :: i
		integer :: status

		status = nf90_redef(ncid)
		if (present(dimids)) then
			xdimids = dimids
		else
			do i = 1, 3
				write(dimname, "(A,'_',I0)") name, i
				call nc_check(nf90_def_dim( &
					ncid, &
					dimname, &
					size(var, i), &
					xdimids(i) &
				))
			end do
		end if
		call nc_check(nf90_def_var( &
			ncid, &
			name, &
			nf90_double, &
			xdimids, &
			varid &
		))
		call nc_check(nf90_enddef(ncid))
		call nc_check(nf90_put_var(ncid, varid, var))
	end subroutine

	subroutine nc_put_var_4d_real(ncid, name, var, dimids)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: name
		real(8), dimension(:,:,:,:), intent(in) :: var
		integer, dimension(4), intent(in), optional :: dimids

		character(len=NF90_MAX_NAME) :: dimname
		integer, dimension(4) :: xdimids
		integer :: varid
		integer :: i
		integer :: status

		status = nf90_redef(ncid)
		if (present(dimids)) then
			xdimids = dimids
		else
			do i = 1, 4
				write(dimname, "(A,'_',I0)") name, i
				call nc_check(nf90_def_dim( &
					ncid, &
					dimname, &
					size(var, i), &
					xdimids(i) &
				))
			end do
		end if
		call nc_check(nf90_def_var( &
			ncid, &
			name, &
			nf90_double, &
			xdimids, &
			varid &
		))
		call nc_check(nf90_enddef(ncid))
		call nc_check(nf90_put_var(ncid, varid, var))
	end subroutine

	subroutine nc_get_att(ncid, varname, name, att)
		integer, intent(in) :: ncid
		character(len=*), intent(in) :: varname
		character(len=*), intent(in) :: name
		character(len=:), allocatable, intent(out) :: att

		integer :: varid
		integer, dimension(:), allocatable :: dims
		integer :: len

		call nc_inq_var(ncid, varname, varid, dims)
		call nc_check(nf90_inquire_attribute(ncid, varid, name, len=len))
		allocate(character(len=len) :: att)
		call nc_check(nf90_get_att(ncid, varid, name, att))
	end subroutine
end module

! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/icarus-scops-4.1-bsd/isccp_cloud_types.f $
      SUBROUTINE ISCCP_CLOUD_TYPES(
     &     debug,
     &     debugcol,
     &     npoints,
     &     sunlit,
     &     nlev,
     &     ncol,
     &     seed,
     &     pfull,
     &     phalf,
     &     qv,
     &     cc,
     &     conv,
     &     dtau_s,
     &     dtau_c,
     &     top_height,
     &     top_height_direction,
     &     overlap,
     &     frac_out,
     &     skt,
     &     emsfc_lw,
     &     at,
     &     dem_s,
     &     dem_c,
     &     fq_isccp,
     &     totalcldarea,
     &     meanptop,
     &     meantaucld,
     &     meanalbedocld,
     &     meantb,
     &     meantbclr,
     &     boxtau,
     &     boxptop
     &)

!$Id: isccp_cloud_types.f,v 4.0 2009/03/06 11:05:11 hadmw Exp $

! *****************************COPYRIGHT****************************
! (c) British Crown Copyright 2009, the Met Office.
! All rights reserved.
! 
! Redistribution and use in source and binary forms, with or without 
! modification, are permitted provided that the
! following conditions are met:
! 
!     * Redistributions of source code must retain the above 
!       copyright  notice, this list of conditions and the following 
!       disclaimer.
!     * Redistributions in binary form must reproduce the above 
!       copyright notice, this list of conditions and the following 
!       disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its 
!       contributors may be used to endorse or promote products
!       derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
! 
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************

      implicit none

!     NOTE:   the maximum number of levels and columns is set by
!             the following parameter statement

      INTEGER ncolprint
      
!     -----
!     Input 
!     -----

      INTEGER npoints       !  number of model points in the horizontal
      INTEGER nlev          !  number of model levels in column
      INTEGER ncol          !  number of subcolumns

      INTEGER sunlit(npoints) !  1 for day points, 0 for night time

      INTEGER seed(npoints)
      !  seed values for marsaglia  random number generator
      !  It is recommended that the seed is set
      !  to a different value for each model
      !  gridbox it is called on, as it is
      !  possible that the choice of the same
      !  seed value every time may introduce some
      !  statistical bias in the results, particularly
      !  for low values of NCOL.

      REAL pfull(npoints,nlev)
                       !  pressure of full model levels (Pascals)
                  !  pfull(npoints,1) is top level of model
                  !  pfull(npoints,nlev) is bot of model

      REAL phalf(npoints,nlev+1)
                  !  pressure of half model levels (Pascals)
                  !  phalf(npoints,1) is top of model
                  !  phalf(npoints,nlev+1) is the surface pressure

      REAL qv(npoints,nlev)
                  !  water vapor specific humidity (kg vapor/ kg air)
                  !         on full model levels

      REAL cc(npoints,nlev)   
                  !  input cloud cover in each model level (fraction) 
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by clouds

      REAL conv(npoints,nlev) 
                  !  input convective cloud cover in each model
                  !   level (fraction) 
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by convective clouds

      REAL dtau_s(npoints,nlev) 
                  !  mean 0.67 micron optical depth of stratiform
                !  clouds in each model level
                  !  NOTE:  this the cloud optical depth of only the
                  !  cloudy part of the grid box, it is not weighted
                  !  with the 0 cloud optical depth of the clear
                  !         part of the grid box

      REAL dtau_c(npoints,nlev) 
                  !  mean 0.67 micron optical depth of convective
                !  clouds in each
                  !  model level.  Same note applies as in dtau_s.

      INTEGER overlap                   !  overlap type
                              !  1=max
                              !  2=rand
                              !  3=max/rand

      INTEGER top_height                !  1 = adjust top height using both a computed
                                        !  infrared brightness temperature and the visible
                              !  optical depth to adjust cloud top pressure. Note
                              !  that this calculation is most appropriate to compare
                              !  to ISCCP data during sunlit hours.
                                        !  2 = do not adjust top height, that is cloud top
                                        !  pressure is the actual cloud top pressure
                                        !  in the model
                              !  3 = adjust top height using only the computed
                              !  infrared brightness temperature. Note that this
                              !  calculation is most appropriate to compare to ISCCP
                              !  IR only algortihm (i.e. you can compare to nighttime
                              !  ISCCP data with this option)

      INTEGER top_height_direction ! direction for finding atmosphere pressure level
                                 ! with interpolated temperature equal to the radiance
				 ! determined cloud-top temperature
				 !
				 ! 1 = find the *lowest* altitude (highest pressure) level
				 ! with interpolated temperature equal to the radiance
				 ! determined cloud-top temperature
				 !
				 ! 2 = find the *highest* altitude (lowest pressure) level
				 ! with interpolated temperature equal to the radiance 
				 ! determined cloud-top temperature
				 ! 
				 ! ONLY APPLICABLE IF top_height EQUALS 1 or 3
				 !
				 ! 1 = old setting: matches all versions of 
				 ! ISCCP simulator with versions numbers 3.5.1 and lower
				 !
				 ! 2 = default setting: for version numbers 4.0 and higher  
!
!     The following input variables are used only if top_height = 1 or top_height = 3
!
      REAL skt(npoints)                 !  skin Temperature (K)
      REAL emsfc_lw                     !  10.5 micron emissivity of surface (fraction)                                            
      REAL at(npoints,nlev)                   !  temperature in each model level (K)
      REAL dem_s(npoints,nlev)                !  10.5 micron longwave emissivity of stratiform
                              !  clouds in each
                                        !  model level.  Same note applies as in dtau_s.
      REAL dem_c(npoints,nlev)                  !  10.5 micron longwave emissivity of convective
                              !  clouds in each
                                        !  model level.  Same note applies as in dtau_s.

      REAL frac_out(npoints,ncol,nlev) ! boxes gridbox divided up into
                              ! Equivalent of BOX in original version, but
                              ! indexed by column then row, rather than
                              ! by row then column



!     ------
!     Output
!     ------

      REAL fq_isccp(npoints,7,7)        !  the fraction of the model grid box covered by
                                        !  each of the 49 ISCCP D level cloud types

      REAL totalcldarea(npoints)        !  the fraction of model grid box columns
                                        !  with cloud somewhere in them.  NOTE: This diagnostic
					! does not count model clouds with tau < isccp_taumin
                              ! Thus this diagnostic does not equal the sum over all entries of fq_isccp.
			      ! However, this diagnostic does equal the sum over entries of fq_isccp with
			      ! itau = 2:7 (omitting itau = 1)
      
      
      ! The following three means are averages only over the cloudy areas with tau > isccp_taumin.  
      ! If no clouds with tau > isccp_taumin are in grid box all three quantities should equal zero.      
                              
      REAL meanptop(npoints)            !  mean cloud top pressure (mb) - linear averaging
                                        !  in cloud top pressure.
                              
      REAL meantaucld(npoints)          !  mean optical thickness 
                                        !  linear averaging in albedo performed.
      
      real meanalbedocld(npoints)        ! mean cloud albedo
                                        ! linear averaging in albedo performed
					
      real meantb(npoints)              ! mean all-sky 10.5 micron brightness temperature
      
      real meantbclr(npoints)           ! mean clear-sky 10.5 micron brightness temperature
      
      REAL boxtau(npoints,ncol)         !  optical thickness in each column
      
      REAL boxptop(npoints,ncol)        !  cloud top pressure (mb) in each column
                              
                                                                                          
!
!     ------
!     Working variables added when program updated to mimic Mark Webb's PV-Wave code
!     ------

      REAL dem(npoints,ncol),bb(npoints)     !  working variables for 10.5 micron longwave 
                              !  emissivity in part of
                              !  gridbox under consideration

      REAL ptrop(npoints)
      REAL attrop(npoints)
      REAL attropmin (npoints)
      REAL atmax(npoints)
      REAL atmin(npoints)
      REAL btcmin(npoints)
      REAL transmax(npoints)

      INTEGER i,j,ilev,ibox,itrop(npoints)
      INTEGER ipres(npoints)
      INTEGER itau(npoints),ilev2
      INTEGER acc(nlev,ncol)
      INTEGER match(npoints,nlev-1)
      INTEGER nmatch(npoints)
      INTEGER levmatch(npoints,ncol)
      
      !variables needed for water vapor continuum absorption
      real fluxtop_clrsky(npoints),trans_layers_above_clrsky(npoints)
      real taumin(npoints)
      real dem_wv(npoints,nlev), wtmair, wtmh20, Navo, grav, pstd, t0
      real press(npoints), dpress(npoints), atmden(npoints)
      real rvh20(npoints), wk(npoints), rhoave(npoints)
      real rh20s(npoints), rfrgn(npoints)
      real tmpexp(npoints),tauwv(npoints)
      
      character*1 cchar(6),cchar_realtops(6)
      integer icycle
      REAL tau(npoints,ncol)
      LOGICAL box_cloudy(npoints,ncol)
      REAL tb(npoints,ncol)
      REAL ptop(npoints,ncol)
      REAL emcld(npoints,ncol)
      REAL fluxtop(npoints,ncol)
      REAL trans_layers_above(npoints,ncol)
      real isccp_taumin,fluxtopinit(npoints),tauir(npoints)
      REAL albedocld(npoints,ncol)
      real boxarea
      integer debug       ! set to non-zero value to print out inputs
                    ! with step debug
      integer debugcol    ! set to non-zero value to print out column
                    ! decomposition with step debugcol
      integer rangevec(npoints),rangeerror

      integer index1(npoints),num1,jj,k1,k2
      real rec2p13,tauchk,logp,logp1,logp2,atd

      character*10 ftn09
      
      DATA isccp_taumin / 0.3 /
      DATA cchar / ' ','-','1','+','I','+'/
      DATA cchar_realtops / ' ',' ','1','1','I','I'/

!     ------ End duplicate definitions common to wrapper routine

       ncolprint=0

      CALL SCOPS(
     &     npoints,
     &     nlev,
     &     ncol,
     &     seed,
     &     cc,
     &     conv,
     &     overlap,
     &     frac_out,
     &     ncolprint
     &)

      CALL ICARUS(
     &     debug,
     &     debugcol,
     &     npoints,
     &     sunlit,
     &     nlev,
     &     ncol,
     &     pfull,
     &     phalf,
     &     qv,
     &     cc,
     &     conv,
     &     dtau_s,
     &     dtau_c,
     &     top_height,
     &     top_height_direction,
     &     overlap,
     &     frac_out,
     &     skt,
     &     emsfc_lw,
     &     at,
     &     dem_s,
     &     dem_c,
     &     fq_isccp,
     &     totalcldarea,
     &     meanptop,
     &     meantaucld,
     &     meanalbedocld,
     &     meantb,
     &     meantbclr,
     &     boxtau,
     &     boxptop
     &)

      return
      end

! (c) British Crown Copyright 2008, the Met Office.
! All rights reserved.
! $Revision: 88 $, $Date: 2013-11-13 07:08:38 -0700 (Wed, 13 Nov 2013) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/cosp_io.F90 $
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its contributors may be used 
!       to endorse or promote products derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

!
! History:
! Jul 2008 - A. Bodas-Salcedo - Initial version
! Oct 2008 - S. Bony - In nc_write_cosp_1d and nc_write_cosp_2d :
!                      the label of layered cloud fractions was wrong -> corrected
!                      (before: low was actually mid, mid was high, high was total,
!                      total was low)
! Sep 2009 - A. Bodas-Salcedo - CMIP5 variable names implemented
!
! Jan 2013 - G. Cesana - Add new phase variables for outputs

#include "cosp_defs.h" 
MODULE MOD_COSP_IO
  USE MOD_COSP_CONSTANTS
  USE MOD_COSP_TYPES
  USE netcdf
  use MOD_COSP_Modis_Simulator
  IMPLICIT NONE

  ! Types to be used as arrays of pointers
  TYPE var1d
     character(len=16) :: name
     character(len=16) :: units
     integer :: dimsid(3)
     integer :: dimssz(2)
     integer :: vid
     logical :: lout
     real,pointer,dimension(:) :: pntr
  END TYPE
  TYPE var2d
     character(len=16) :: name
     character(len=16) :: units
     integer :: dimsid(4)
     integer :: dimssz(3)
     integer :: vid
     logical :: lout
     real,pointer,dimension(:,:) :: pntr
  END TYPE
  TYPE var3d
     character(len=16) :: name
     character(len=16) :: units
     integer :: dimsid(5)
     integer :: dimssz(4)
     integer :: vid
     logical :: lout
     real,pointer,dimension(:,:,:) :: pntr
  END TYPE
CONTAINS

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE CONSTRUCT_VAR1D --------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_VAR1D(name,dimsid,dimssz,pntr,y,units)
     ! Input arguments
     character(len=*),intent(in) :: name
     integer,intent(in) :: dimsid(3)
     integer,intent(in) :: dimssz(2)
     real,dimension(:),target,intent(in) :: pntr
     type(var1d),intent(out) :: y
     character(len=*),optional,intent(in) :: units

     y%name =  name
     if (present(units)) y%units   =  units
     y%dimsid =  dimsid
     y%dimssz =  dimssz
     y%pntr => pntr

  END SUBROUTINE CONSTRUCT_VAR1D
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE CONSTRUCT_VAR2D --------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_VAR2D(name,dimsid,dimssz,pntr,y,units)
     ! Input arguments
     character(len=*),intent(in) :: name
     integer,intent(in) :: dimsid(4)
     integer,intent(in) :: dimssz(3)
     real,dimension(:,:),target,intent(in) :: pntr
     type(var2d),intent(out) :: y
     character(len=*),optional,intent(in) :: units

     y%name =  name
     if (present(units)) y%units   =  units
     y%dimsid =  dimsid
     y%dimssz =  dimssz
     y%pntr => pntr

  END SUBROUTINE CONSTRUCT_VAR2D
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE CONSTRUCT_VAR3D --------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE CONSTRUCT_VAR3D(name,dimsid,dimssz,pntr,y,units)
     ! Input arguments
     character(len=*),intent(in) :: name
     integer,intent(in) :: dimsid(5)
     integer,intent(in) :: dimssz(4)
     real,dimension(:,:,:),target,intent(in) :: pntr
     type(var3d),intent(out) :: y
     character(len=*),optional,intent(in) :: units

     y%name =  name
     if (present(units)) y%units   =  units
     y%dimsid =  dimsid
     y%dimssz =  dimssz
     y%pntr => pntr

  END SUBROUTINE CONSTRUCT_VAR3D

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE MAP_POINT_TO_LL---------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE MAP_POINT_TO_LL(Nx,Ny,geomode,x1,x2,x3,x4,y2,y3,y4,y5)
     ! Input arguments
     integer,intent(in) :: Nx,Ny,geomode
     real,intent(in),optional :: x1(:),x2(:,:),x3(:,:,:), &
                                 x4(:,:,:,:)
     real,intent(out),optional :: y2(:,:),y3(:,:,:), &
                                  y4(:,:,:,:),y5(:,:,:,:,:)
     ! Local variables
     integer :: Npoints
     integer :: px(Nx*Ny),py(Nx*Ny)
     integer :: i,j,k,l,m
     integer :: Ni,Nj,Nk,Nl
     integer :: Mi,Mj,Mk,Ml,Mm
     character(len=128) :: proname='MAP_POINT_TO_LL'

     Npoints = Nx*Ny
     
     px=0
     py=0
     ! Obtain pointers to do the mapping
     if (geomode == 2) then ! (lon,lat) mode
      do j=1,Ny
        do i=1,Nx
            k = (j-1)*Nx+i
            px(k) = i  
            py(k) = j  
        enddo
      enddo
     else if (geomode == 3) then ! (lon,lat) mode
      do j=1,Nx
        do i=1,Ny
            k = (j-1)*Ny+i
            px(k) = j
            py(k) = i  
        enddo
      enddo
     else
       print *, ' -- '//trim(proname)//': geomode not supported, ',geomode
       stop
     endif

     if (present(x1).and.present(y2)) then
        Ni = size(x1,1)
        Mi = size(y2,1)
        Mj = size(y2,2)
        if (Mi*Mj /= Ni) then
          print *, ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 1)'
          stop
        endif
        do i=1,Npoints
          y2(px(i),py(i)) = x1(i)
        enddo
     else if (present(x2).and.present(y3)) then
        Ni = size(x2,1)
        Nj = size(x2,2)
        Mi = size(y3,1)
        Mj = size(y3,2)
        Mk = size(y3,3)
        if (Mi*Mj /= Ni) then
          print *, ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 2)'
          stop
        endif
        if (Nj /= Mk) then
          print *, ' -- '//trim(proname)//': Nj /= Mk (opt 2)'
          print *, Ni,Nj,Mi,Mj,Mk
          stop
        endif
        do k=1,Mk
         do i=1,Npoints
            y3(px(i),py(i),k) = x2(i,k)
         enddo
        enddo
     else if (present(x3).and.present(y4)) then
        Ni = size(x3,1)
        Nj = size(x3,2)
        Nk = size(x3,3)
        Mi = size(y4,1)
        Mj = size(y4,2)
        Mk = size(y4,3)
        Ml = size(y4,4)
        if (Mi*Mj /= Ni) then
          print *, ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 3)'
          stop
        endif
        if (Nj /= Mk) then
          print *, ' -- '//trim(proname)//': Nj /= Mk (opt 3)'
          stop
        endif
        if (Nk /= Ml) then
          print *, ' -- '//trim(proname)//': Nk /= Ml (opt 3)'
          stop
        endif
        do l=1,Ml
         do k=1,Mk
          do i=1,Npoints
            y4(px(i),py(i),k,l) = x3(i,k,l)
          enddo
         enddo
        enddo
     else if (present(x4).and.present(y5)) then
        Ni = size(x4,1)
        Nj = size(x4,2)
        Nk = size(x4,3)
        Nl = size(x4,4)
        Mi = size(y5,1)
        Mj = size(y5,2)
        Mk = size(y5,3)
        Ml = size(y5,4)
        Mm = size(y5,5)
        if (Mi*Mj /= Ni) then
          print *, ' -- '//trim(proname)//': Nlon*Nlat /= Npoints (opt 4)'
          stop
        endif
        if (Nj /= Mk) then
          print *, ' -- '//trim(proname)//': Nj /= Mk (opt 4)'
          stop
        endif
        if (Nk /= Ml) then
          print *, ' -- '//trim(proname)//': Nk /= Ml (opt 4)'
          stop
        endif
        if (Nl /= Mm) then
          print *, ' -- '//trim(proname)//': Nl /= Mm (opt 4)'
          stop
        endif
        do m=1,Mm
         do l=1,Ml
          do k=1,Mk
            do i=1,Npoints
                y5(px(i),py(i),k,l,m) = x4(i,k,l,m)
            enddo
          enddo
         enddo
        enddo
     else
        print *, ' -- '//trim(proname)//': wrong option'
        stop
     endif

     
  END SUBROUTINE MAP_POINT_TO_LL

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE MAP_LL_TO_POINT---------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE MAP_LL_TO_POINT(Nx,Ny,Np,x2,x3,x4,x5,y1,y2,y3,y4)
     ! Input arguments
     integer,intent(in) :: Nx,Ny,Np
     real,intent(in),optional :: x2(:,:),x3(:,:,:), &
                                 x4(:,:,:,:),x5(:,:,:,:,:)
     real,intent(out),optional :: y1(:),y2(:,:),y3(:,:,:), &
                                 y4(:,:,:,:)
     ! Local variables
     integer :: px(Nx*Ny),py(Nx*Ny)
     integer :: i,j,k,l,m
     integer :: Ni,Nj,Nk,Nl,Nm
     integer :: Mi,Mj,Mk,Ml
     character(len=128) :: proname='MAP_LL_TO_POINT'
     
     px=0
     py=0
     if (Nx*Ny < Np) then
       print *, ' -- '//trim(proname)//': Nx*Ny < Np'
       stop
     endif
     do j=1,Ny
       do i=1,Nx
          k = (j-1)*Nx+i
          px(k) = i  
          py(k) = j  
       enddo
     enddo
     
     if (present(x2).and.present(y1)) then
        Ni = size(x2,1)
        Nj = size(x2,2)
        Mi = size(y1,1)
        if (Ni*Nj < Mi) then
          print *, ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 1)'
          stop
        endif
        do j=1,Np
          y1(j) = x2(px(j),py(j))
        enddo
     else if (present(x3).and.present(y2)) then
        Ni = size(x3,1)
        Nj = size(x3,2)
        Nk = size(x3,3)
        Mi = size(y2,1)
        Mj = size(y2,2)
        if (Ni*Nj < Mi) then
          print *, ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 2)'
          stop
        endif
        if (Nk /= Mj) then
          print *, ' -- '//trim(proname)//': Nk /= Mj (opt 2)'
          stop
        endif
        do k=1,Nk
          do j=1,Np
            y2(j,k) = x3(px(j),py(j),k)
          enddo
        enddo
     else if (present(x4).and.present(y3)) then
        Ni = size(x4,1)
        Nj = size(x4,2)
        Nk = size(x4,3)
        Nl = size(x4,4)
        Mi = size(y3,1)
        Mj = size(y3,2)
        Mk = size(y3,3)
        if (Ni*Nj < Mi) then
          print *, ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 3)'
          stop
        endif
        if (Nk /= Mj) then
          print *, ' -- '//trim(proname)//': Nk /= Mj (opt 3)'
          stop
        endif
        if (Nl /= Mk) then
          print *, ' -- '//trim(proname)//': Nl /= Mk (opt 3)'
          stop
        endif
        do l=1,Nl
         do k=1,Nk
          do j=1,Np
            y3(j,k,l) = x4(px(j),py(j),k,l)
          enddo
         enddo
        enddo
     else if (present(x5).and.present(y4)) then
        Ni = size(x5,1)
        Nj = size(x5,2)
        Nk = size(x5,3)
        Nl = size(x5,4)
        Nm = size(x5,5)
        Mi = size(y4,1)
        Mj = size(y4,2)
        Mk = size(y4,3)
        Ml = size(y4,4)
        if (Ni*Nj < Mi) then
          print *, ' -- '//trim(proname)//': Nlon*Nlat < Npoints (opt 4)'
          stop
        endif
        if (Nk /= Mj) then
          print *, ' -- '//trim(proname)//': Nk /= Mj (opt 4)'
          stop
        endif
        if (Nl /= Mk) then
          print *, ' -- '//trim(proname)//': Nl /= Mk (opt 4)'
          stop
        endif
        if (Nm /= Ml) then
          print *, ' -- '//trim(proname)//': Nm /= Ml (opt 4)'
          stop
        endif
        do m=1,Nm
         do l=1,Nl
          do k=1,Nk
           do j=1,Np
            y4(j,k,l,m) = x5(px(j),py(j),k,l,m)
           enddo
          enddo
         enddo
        enddo
     else
        print *, ' -- '//trim(proname)//': wrong option'
        stop
     endif
  
  END SUBROUTINE MAP_LL_TO_POINT
  
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!----------------- SUBROUTINE NC_READ_INPUT_FILE -----------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE NC_READ_INPUT_FILE(fname,Npnts,Nl,Nhydro,lon,lat,p,ph,z,zh,T,qv,rh,tca,cca, &
            mr_lsliq,mr_lsice,mr_ccliq,mr_ccice,fl_lsrain,fl_lssnow,fl_lsgrpl, &
            fl_ccrain,fl_ccsnow,Reff,dtau_s,dtau_c,dem_s,dem_c,skt,landmask, &
            mr_ozone,u_wind,v_wind,sunlit,emsfc_lw,mode,Nlon,Nlat,verbosity)
    
    !Arguments
    character(len=512),intent(in) :: fname ! File name
    integer,intent(in) :: Npnts,Nl,Nhydro
    real,dimension(Npnts),intent(out) :: lon,lat
    real,dimension(Npnts,Nl),target,intent(out) :: p,ph,z,zh,T,qv,rh,tca,cca, &
                  mr_lsliq,mr_lsice,mr_ccliq,mr_ccice,fl_lsrain,fl_lssnow,fl_lsgrpl, &
                  fl_ccrain,fl_ccsnow,dtau_s,dtau_c,dem_s,dem_c,mr_ozone
    real,dimension(Npnts,Nl,Nhydro),intent(out) :: Reff
    real,dimension(Npnts),intent(out) :: skt,landmask,u_wind,v_wind,sunlit
    real,intent(out) :: emsfc_lw
    integer,intent(out) :: mode,Nlon,Nlat
    integer,optional :: verbosity
        
    !Local variables
    integer :: Npoints,Nlevels,i,j,k
    character(len=128) :: vname
    integer,parameter :: NMAX_DIM=5
    integer :: vrank,vdimid(NMAX_DIM)
    character(len=256) :: dimname(NMAX_DIM) ! 256 hardcoded, instead of MAXNCNAM. This works for NetCDF 3 and 4.
    integer :: ncid,vid,ndims,nvars,ngatts,recdim,dimsize(NMAX_DIM)
    integer :: errst
    logical :: Llat,Llon,Lpoint
    integer :: Na,Nb,Nc,Nd,Ne
    real,dimension(Npnts) :: ll
    integer,dimension(:),allocatable :: plon,plat
    real,allocatable :: x1(:),x2(:,:),x3(:,:,:),x4(:,:,:,:),x5(:,:,:,:,:) ! Temporary arrays
    character(len=64) :: routine_name='NC_READ_INPUT_FILE'
    character(len=128) :: errmsg,straux
    
    mode = 0
    Nlon = 0
    Nlat = 0
    
    Npoints = Npnts
    Nlevels = Nl
    
    ! Open file
    errst = nf90_open(fname, nf90_nowrite, ncid)
    if (errst /= 0) then
      errmsg="Couldn't open "//trim(fname)
      call cosp_error(routine_name,errmsg)
    endif
    
    ! Get information about dimensions. Curtain mode or lat/lon mode?
    Llat  =.false.
    Llon  =.false.
    Lpoint=.false.
    errst = nf90_inquire(ncid, ndims, nvars, ngatts, recdim)
    if (errst /= 0) then
      errmsg="Error in  nf90_inquire"
      call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    do i = 1,ndims
       errst = nf90_Inquire_Dimension(ncid,i,name=dimname(i),len=dimsize(i))
       if (errst /= 0) then
         write(straux, *)  i
         errmsg="Error in nf90_Inquire_Dimension, i: "//trim(straux)
         call cosp_error(routine_name,errmsg)
       endif
       if ((trim(dimname(i)).eq.'level').and.(Nlevels > dimsize(i))) then
         errmsg='Number of levels selected is greater than in input file '//trim(fname)
         call cosp_error(routine_name,errmsg)
       endif
       if (trim(dimname(i)).eq.'point') then
         Lpoint = .true.
         if (Npnts > dimsize(i)) then
           errmsg='Number of points selected is greater than in input file '//trim(fname)
           call cosp_error(routine_name,errmsg)
         endif
       endif
       if (trim(dimname(i)).eq.'lon') then
         Llon = .true.
         Nlon = dimsize(i)
       endif
       if (trim(dimname(i)).eq.'lat') then
         Llat = .true.
         Nlat = dimsize(i)
       endif
    enddo

    ! Get lon and lat
    if (Llon.and.Llat) then ! 2D mode
        if ((Npnts) > Nlon*Nlat) Npoints=Nlon*Nlat
        lon = R_UNDEF
        lat = R_UNDEF
        mode = 2 ! Don't know yet if (lon,lat) or (lat,lon) at this point
    else if (Lpoint) then ! 1D mode
        Nlon = Npoints
        Nlat = Npoints
        mode = 1
    else
        errmsg= trim(fname)//' file contains wrong dimensions'
        call cosp_error(routine_name,errmsg)
    endif
    errst = nf90_inq_varid(ncid, 'lon', vid)
    if (errst /= 0) then
        errmsg="Error in nf90_inq_varid, var: lon"
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    errst = nf90_get_var(ncid, vid, lon, start = (/1/), count = (/Nlon/))
    if (errst /= 0) then
        errmsg="Error in nf90_get_var, var: lon"
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    errst = nf90_inq_varid(ncid, 'lat', vid)
    if (errst /= 0) then
        errmsg="Error in nf90_inq_varid, var: lat"
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    errst = nf90_get_var(ncid, vid, lat, start = (/1/), count = (/Nlat/))
    if (errst /= 0) then
        errmsg="Error in nf90_get_var, var: lat"
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif
    
    ! Get all variables
    do vid = 1,nvars
       vdimid=0
       errst = nf90_Inquire_Variable(ncid, vid, name=vname, ndims=vrank, dimids=vdimid)
       if (errst /= 0) then
         write(straux, *)  vid
         errmsg='Error in nf90_Inquire_Variable, vid '//trim(straux)
         call cosp_error(routine_name,errmsg,errcode=errst)
       endif
       ! Read in into temporary array of correct shape
       !if (present(verbosity).and.(verbosity == 1)) print *, 'Reading '//trim(vname)//' ...'
       if (vrank == 1) then
          Na = dimsize(vdimid(1))
          allocate(x1(Na))
          errst = nf90_get_var(ncid, vid, x1, start=(/1/), count=(/Na/))
       endif
       if (vrank == 2) then
          Na = dimsize(vdimid(1))
          Nb = dimsize(vdimid(2))
          allocate(x2(Na,Nb))
          errst = nf90_get_var(ncid, vid, x2, start=(/1,1/), count=(/Na,Nb/))
       endif
       if (vrank == 3) then
          Na = dimsize(vdimid(1))
          Nb = dimsize(vdimid(2))
          Nc = dimsize(vdimid(3))
          allocate(x3(Na,Nb,Nc))
          errst = nf90_get_var(ncid, vid, x3, start=(/1,1,1/), count=(/Na,Nb,Nc/))
          if ((mode == 2).or.(mode == 3)) then
            if ((Na == Nlon).and.(Nb == Nlat)) then
              mode = 2
            else if ((Na == Nlat).and.(Nb == Nlon)) then
              mode = 3
            else
              errmsg='Wrong mode for variable '//trim(vname)
              call cosp_error(routine_name,errmsg)
            endif
          endif
       endif
       if (vrank == 4) then
          Na = dimsize(vdimid(1))
          Nb = dimsize(vdimid(2))
          Nc = dimsize(vdimid(3))
          Nd = dimsize(vdimid(4))
          allocate(x4(Na,Nb,Nc,Nd))
          errst = nf90_get_var(ncid, vid, x4, start=(/1,1,1,1/), count=(/Na,Nb,Nc,Nd/))
       endif
       if (vrank == 5) then
          Na = dimsize(vdimid(1))
          Nb = dimsize(vdimid(2))
          Nc = dimsize(vdimid(3))
          Nd = dimsize(vdimid(4))
          Ne = dimsize(vdimid(5))
          allocate(x5(Na,Nb,Nc,Nd,Ne))
          errst = nf90_get_var(ncid, vid, x5, start=(/1,1,1,1,1/), count=(/Na,Nb,Nc,Nd,Ne/))
       endif
       if (errst /= 0) then
          write(straux, *)  vid
          errmsg='Error in nf90_get_var, vid '//trim(straux)
          call cosp_error(routine_name,errmsg,errcode=errst)
       endif
       ! Map to the right input argument
       select case (trim(vname))
       case ('pfull')
         if (Lpoint) then
           p(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=p)
         endif
       case ('phalf')
         if (Lpoint) then
           ph(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=ph)
         endif
       case ('height')
         if (Lpoint) then
           z(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=z)
         endif
       case ('height_half')
         if (Lpoint) then
           zh(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=zh)
         endif
       case ('T_abs')
         if (Lpoint) then
           T(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=T)
         endif
       case ('qv')
         if (Lpoint) then
           qv(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=qv)
         endif
       case ('rh')
         if (Lpoint) then
           rh(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=rh)
         endif
       case ('tca')
         if (Lpoint) then
           tca(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=tca)
         endif
         tca = tca
       case ('cca')
         if (Lpoint) then
           cca(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=cca)
         endif
         cca = cca
       case ('mr_lsliq')
         if (Lpoint) then
           mr_lsliq(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_lsliq)
         endif
       case ('mr_lsice')
         if (Lpoint) then
           mr_lsice(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_lsice)
         endif
       case ('mr_ccliq')
         if (Lpoint) then
           mr_ccliq(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_ccliq)
         endif
       case ('mr_ccice')
         if (Lpoint) then
           mr_ccice(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_ccice)
         endif
       case ('fl_lsrain')
         if (Lpoint) then
           fl_lsrain(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_lsrain)
         endif
       case ('fl_lssnow')
         if (Lpoint) then
           fl_lssnow(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_lssnow)
         endif
       case ('fl_lsgrpl')
         if (Lpoint) then
           fl_lsgrpl(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_lsgrpl)
         endif
       case ('fl_ccrain')
         if (Lpoint) then
           fl_ccrain(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_ccrain)
         endif
       case ('fl_ccsnow')
         if (Lpoint) then
           fl_ccsnow(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=fl_ccsnow)
         endif
       case ('dtau_s')
         if (Lpoint) then
           dtau_s(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dtau_s)
         endif
       case ('dtau_c')
         if (Lpoint) then
           dtau_c(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dtau_c)
         endif
       case ('dem_s')
         if (Lpoint) then
           dem_s(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dem_s)
         endif
       case ('dem_c')
         if (Lpoint) then
           dem_c(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=dem_c)
         endif
       case ('Reff')
         if (Lpoint) then
           Reff(1:Npoints,:,:) = x3(1:Npoints,1:Nlevels,:)
         else
           call map_ll_to_point(Na,Nb,Npoints,x4=x4,y3=Reff)
         endif
       case ('skt')
         if (Lpoint) then
           skt(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=skt)
         endif
       case ('landmask')
         if (Lpoint) then
           landmask(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=landmask)
         endif
       case ('mr_ozone')
         if (Lpoint) then
           mr_ozone(1:Npoints,:) = x2(1:Npoints,1:Nlevels)
         else
           call map_ll_to_point(Na,Nb,Npoints,x3=x3,y2=mr_ozone)
         endif
       case ('u_wind')
         if (Lpoint) then
           u_wind(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=u_wind)
         endif
       case ('v_wind')
         if (Lpoint) then
           v_wind(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=v_wind)
         endif
       case ('sunlit')
         if (Lpoint) then
           sunlit(1:Npoints) = x1(1:Npoints)
         else
           call map_ll_to_point(Na,Nb,Npoints,x2=x2,y1=sunlit)
         endif
       end select
       ! Free memory
       if (vrank == 1) deallocate(x1)
       if (vrank == 2) deallocate(x2)
       if (vrank == 3) deallocate(x3)
       if (vrank == 4) deallocate(x4)
       if (vrank == 5) deallocate(x5)
    enddo
       
    ! SFC emissivity
    errst = nf90_inq_varid(ncid, 'emsfc_lw', vid)
    if (errst /= 0) then
        if (errst == nf90_enotvar) then ! Does not exist, use 1.0
            emsfc_lw = 1.0
            print *, ' ********* COSP Warning:  emsfc_lw does not exist in input file. Set to 1.0.'
        else  ! Other error, stop
            errmsg='Error in nf90_inq_varid, var: emsfc_lw'
            call cosp_error(routine_name,errmsg,errcode=errst)
        endif
    else
        errst = nf90_get_var(ncid, vid, emsfc_lw)
        if (errst /= 0) then
            errmsg='Error in nf90_get_var, var: emsfc_lw'
            call cosp_error(routine_name,errmsg,errcode=errst)
        endif
    endif

    
    ! Fill in the lat/lon vectors with the right values for 2D modes
    ! This might be helpful if the inputs are 2D (gridded) and 
    ! you want outputs in 1D mode
    allocate(plon(Npoints),plat(Npoints))
    if (mode == 2) then !(lon,lat)
      ll = lat
      do j=1,Nb
        do i=1,Na
          k = (j-1)*Na + i
          plon(k) = i  
          plat(k) = j
        enddo
      enddo
      lon(1:Npoints) = lon(plon(1:Npoints))
      lat(1:Npoints) = ll(plat(1:Npoints))
    else if (mode == 3) then !(lat,lon)
      ll = lon
      do j=1,Nb
        do i=1,Na
          k = (j-1)*Na + i
          lon(k) = ll(j)
          lat(k) = lat(i)
        enddo
      enddo
      lon(1:Npoints) = ll(plon(1:Npoints))
      lat(1:Npoints) = lat(plat(1:Npoints))
    endif
    deallocate(plon,plat)
    
    ! Close file
    errst = nf90_close(ncid)
    if (errst /= 0) then
        errmsg='Error in nf90_close'
        call cosp_error(routine_name,errmsg,errcode=errst)
    endif

  END SUBROUTINE NC_READ_INPUT_FILE

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------- SUBROUTINE READ_COSP_OUTPUT_NL -------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 SUBROUTINE READ_COSP_OUTPUT_NL(cosp_nl,cfg)
  character(len=*),intent(in) :: cosp_nl
  type(cosp_config),intent(out) :: cfg
  ! Local variables
  integer :: i
  logical :: Lradar_sim,Llidar_sim,Lisccp_sim,Lmodis_sim,Lmisr_sim,Lrttov_sim, &
             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,LcfadDbze94, &
             LcfadLidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp,Lcllcalipso, &
             Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lpctisccp,Ldbze94,Ltauisccp,Lcltisccp, &
             Lclcalipsoliq,Lclcalipsoice,Lclcalipsoun, &
             Lclcalipsotmp,Lclcalipsotmpliq,Lclcalipsotmpice,Lclcalipsotmpun, &
             Lcltcalipsoliq,Lcltcalipsoice,Lcltcalipsoun, &
             Lclhcalipsoliq,Lclhcalipsoice,Lclhcalipsoun, &
             Lclmcalipsoliq,Lclmcalipsoice,Lclmcalipsoun, &
             Lcllcalipsoliq,Lcllcalipsoice,Lcllcalipsoun, &
             Ltoffset,LparasolRefl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
             Lfracout,LlidarBetaMol532,Ltbrttov, &
             Lcltmodis,Lclwmodis,Lclimodis,Lclhmodis,Lclmmodis,Lcllmodis,Ltautmodis,Ltauwmodis,Ltauimodis,Ltautlogmodis, &
             Ltauwlogmodis,Ltauilogmodis,Lreffclwmodis,Lreffclimodis,Lpctmodis,Llwpmodis, &
             Liwpmodis,Lclmodis,Lcrimodis,Lcrlmodis

  namelist/COSP_OUTPUT/Lradar_sim,Llidar_sim,Lisccp_sim,Lmodis_sim,Lmisr_sim,Lrttov_sim, &
             Lalbisccp,Latb532,Lboxptopisccp,Lboxtauisccp,LcfadDbze94, &
             LcfadLidarsr532,Lclcalipso2,Lclcalipso,Lclhcalipso,Lclisccp, &
             Lcllcalipso,Lclmcalipso,Lcltcalipso,Lcltlidarradar,Lpctisccp,Ldbze94,Ltauisccp, &
             Lclcalipsoliq,Lclcalipsoice,Lclcalipsoun, &
             Lclcalipsotmp,Lclcalipsotmpliq,Lclcalipsotmpice,Lclcalipsotmpun, &
             Lcltcalipsoliq,Lcltcalipsoice,Lcltcalipsoun, &
             Lclhcalipsoliq,Lclhcalipsoice,Lclhcalipsoun, &
             Lclmcalipsoliq,Lclmcalipsoice,Lclmcalipsoun, &
             Lcllcalipsoliq,Lcllcalipsoice,Lcllcalipsoun, &
             Lcltisccp,Ltoffset,LparasolRefl,LclMISR,Lmeantbisccp,Lmeantbclrisccp, &
             Lfracout,LlidarBetaMol532,Ltbrttov, &
             Lcltmodis,Lclwmodis,Lclimodis,Lclhmodis,Lclmmodis,Lcllmodis,Ltautmodis,Ltauwmodis,Ltauimodis,Ltautlogmodis, &
             Ltauwlogmodis,Ltauilogmodis,Lreffclwmodis,Lreffclimodis,Lpctmodis,Llwpmodis, &
             Liwpmodis,Lclmodis,Lcrimodis,Lcrlmodis

  do i=1,N_OUT_LIST
    cfg%out_list(i)=''
  enddo
  open(10,file=cosp_nl,status='old')
  read(10,nml=cosp_output)
  close(10)
  
  ! Deal with dependencies
  if (.not.Lradar_sim) then
    LcfadDbze94   = .false.
    Lclcalipso2    = .false.
    Lcltlidarradar = .false. ! Needs radar & lidar
    Ldbze94        = .false.
    Lclcalipso2    = .false. ! Needs radar & lidar
  endif
  if (.not.Llidar_sim) then
    Latb532 = .false.
    LcfadLidarsr532 = .false.
    Lclcalipso2      = .false. ! Needs radar & lidar
    Lclcalipso       = .false.
    Lclhcalipso      = .false.
    Lcllcalipso      = .false.
    Lclmcalipso      = .false.
    Lcltcalipso      = .false.
    Lcltlidarradar   = .false.
    LparasolRefl    = .false.
    LlidarBetaMol532 = .false.
    Lcltlidarradar = .false. ! Needs radar & lidar
    Lclcalipsoliq    = .false.
    Lclcalipsoice    = .false.
    Lclcalipsoun    = .false.
    Lclcalipsotmp    = .false.
    Lclcalipsotmpun    = .false.
    Lclcalipsotmpliq    = .false.
    Lclcalipsotmpice    = .false.
    Lclhcalipsoliq      = .false.
    Lcllcalipsoliq      = .false.
    Lclmcalipsoliq     = .false.
    Lcltcalipsoliq      = .false.
    Lclhcalipsoice      = .false.
    Lcllcalipsoice      = .false.
    Lclmcalipsoice      = .false.
    Lcltcalipsoice      = .false.
    Lclhcalipsoun      = .false.
    Lcllcalipsoun      = .false.
    Lclmcalipsoun      = .false.
    Lcltcalipsoun      = .false.
  endif
  if (.not.Lisccp_sim) then
    Lalbisccp       = .false.
    Lboxptopisccp   = .false.
    Lboxtauisccp    = .false.
    Lclisccp        = .false.
    Lpctisccp       = .false.
    Ltauisccp       = .false.
    Lcltisccp       = .false.
    Lmeantbisccp    = .false.
    Lmeantbclrisccp = .false.
  endif
  if (.not.Lmisr_sim) then
    LclMISR = .false.
  endif
  if (.not.Lrttov_sim) then
    Ltbrttov = .false.
  endif
  if ((.not.Lradar_sim).and.(.not.Llidar_sim).and. &
      (.not.Lisccp_sim).and.(.not.Lmisr_sim)) then
    Lfracout = .false.
  endif
  if (.not.Lmodis_sim) then
    Lcltmodis=.false.
    Lclwmodis=.false.
    Lclimodis=.false.
    Lclhmodis=.false.
    Lclmmodis=.false.
    Lcllmodis=.false.
    Ltautmodis=.false.
    Ltauwmodis=.false.
    Ltauimodis=.false.
    Ltautlogmodis=.false.
    Ltauwlogmodis=.false.
    Ltauilogmodis=.false.
    Lreffclwmodis=.false.
    Lreffclimodis=.false.
    Lpctmodis=.false.
    Llwpmodis=.false.
    Liwpmodis=.false.
    Lclmodis=.false.
    Lcrimodis=.false.
    Lcrlmodis=.false.
 endif
  if (Lmodis_sim) Lisccp_sim = .true.
  
  cfg%Lstats = .false.
  if ((Lradar_sim).or.(Llidar_sim).or.(Lisccp_sim)) cfg%Lstats = .true.
  
  ! Copy instrument flags to cfg structure
  cfg%Lradar_sim = Lradar_sim
  cfg%Llidar_sim = Llidar_sim
  cfg%Lisccp_sim = Lisccp_sim
  cfg%Lmodis_sim = Lmodis_sim
  cfg%Lmisr_sim  = Lmisr_sim
  cfg%Lrttov_sim = Lrttov_sim
  
  ! Flag to control output to file
  cfg%Lwrite_output = .false.
  if (cfg%Lstats.or.cfg%Lmisr_sim.or.cfg%Lrttov_sim) then
    cfg%Lwrite_output = .true.
  endif
  
  ! Output diagnostics
  i = 1
  if (Lalbisccp)        cfg%out_list(i) = 'albisccp'
  i = i+1
  if (Latb532)          cfg%out_list(i) = 'atb532'
  i = i+1
  if (Lboxptopisccp)    cfg%out_list(i) = 'boxptopisccp'
  i = i+1
  if (Lboxtauisccp)     cfg%out_list(i) = 'boxtauisccp'
  i = i+1
  if (LcfadDbze94)      cfg%out_list(i) = 'cfadDbze94'
  i = i+1
  if (LcfadLidarsr532)  cfg%out_list(i) = 'cfadLidarsr532'
  i = i+1
  if (Lclcalipso2)      cfg%out_list(i) = 'clcalipso2'
  i = i+1
  if (Lclcalipso)       cfg%out_list(i) = 'clcalipso'
  i = i+1
  if (Lclhcalipso)      cfg%out_list(i) = 'clhcalipso'
  i = i+1
  if (Lclisccp)         cfg%out_list(i) = 'clisccp'
  i = i+1
  if (Lcllcalipso)      cfg%out_list(i) = 'cllcalipso'
  i = i+1
  if (Lclmcalipso)      cfg%out_list(i) = 'clmcalipso'
  i = i+1
  if (Lcltcalipso)      cfg%out_list(i) = 'cltcalipso'
  i = i+1

  if (Lcllcalipsoice)      cfg%out_list(i) = 'cllcalipsoice'
  i = i+1
  if (Lclmcalipsoice)      cfg%out_list(i) = 'clmcalipsoice'
  i = i+1
  if (Lclhcalipsoice)      cfg%out_list(i) = 'clhcalipsoice'
  i = i+1
  if (Lcltcalipsoice)      cfg%out_list(i) = 'cltcalipsoice'
  i = i+1
  if (Lcllcalipsoliq)      cfg%out_list(i) = 'cllcalipsoliq'
  i = i+1
  if (Lclmcalipsoliq)      cfg%out_list(i) = 'clmcalipsoliq'
  i = i+1
  if (Lclhcalipsoliq)      cfg%out_list(i) = 'clhcalipsoliq'
  i = i+1
  if (Lcltcalipsoliq)      cfg%out_list(i) = 'cltcalipsoliq'
  i = i+1
  if (Lcllcalipsoun)      cfg%out_list(i) = 'cllcalipsoun'
  i = i+1
  if (Lclmcalipsoun)      cfg%out_list(i) = 'clmcalipsoun'
  i = i+1
  if (Lclhcalipsoun)      cfg%out_list(i) = 'clhcalipsoun'
  i = i+1
  if (Lcltcalipsoun)      cfg%out_list(i) = 'cltcalipsoun'
  i = i+1

  if (Lclcalipsoice)       cfg%out_list(i) = 'clcalipsoice'
  i = i+1
  if (Lclcalipsoliq)       cfg%out_list(i) = 'clcalipsoliq'
  i = i+1
  if (Lclcalipsoun)       cfg%out_list(i) = 'clcalipsoun'
  i = i+1

  if (Lclcalipsotmp)       cfg%out_list(i) = 'clcalipsotmp'
  i = i+1
  if (Lclcalipsotmpice)       cfg%out_list(i) = 'clcalipsotmpice'
  i = i+1
  if (Lclcalipsotmpliq)       cfg%out_list(i) = 'clcalipsotmpliq'
  i = i+1
  if (Lclcalipsotmpun)       cfg%out_list(i) = 'clcalipsotmpun'
  i = i+1
  if (Lcltlidarradar)   cfg%out_list(i) = 'cltlidarradar'
  i = i+1
  if (Lpctisccp)        cfg%out_list(i) = 'pctisccp'
  i = i+1
  if (Ldbze94)          cfg%out_list(i) = 'dbze94'
  i = i+1
  if (Ltauisccp)        cfg%out_list(i) = 'tauisccp'
  i = i+1
  if (Lcltisccp)        cfg%out_list(i) = 'cltisccp'
  i = i+1
  if (Ltoffset)         cfg%out_list(i) = 'toffset'
  i = i+1
  if (LparasolRefl)     cfg%out_list(i) = 'parasolRefl'
  i = i+1
  if (LclMISR)          cfg%out_list(i) = 'clMISR'
  i = i+1
  if (Lmeantbisccp)     cfg%out_list(i) = 'meantbisccp'
  i = i+1
  if (Lmeantbclrisccp)  cfg%out_list(i) = 'meantbclrisccp'
  i = i+1
  if (Lfracout)         cfg%out_list(i) = 'fracout'
  i = i+1
  if (LlidarBetaMol532) cfg%out_list(i) = 'lidarBetaMol532'
  i = i+1
  if (Ltbrttov)         cfg%out_list(i) = 'tbrttov'
  i = i+1
  if (Lcltmodis)        cfg%out_list(i) = 'cltmodis'
  i = i+1
  if (Lclwmodis)        cfg%out_list(i) = 'clwmodis'
  i = i+1
  if (Lclimodis)        cfg%out_list(i) = 'climodis'
  i = i+1
  if (Lclhmodis)        cfg%out_list(i) = 'clhmodis'
  i = i+1
  if (Lclmmodis)        cfg%out_list(i) = 'clmmodis'
  i = i+1
  if (Lcllmodis)        cfg%out_list(i) = 'cllmodis'
  i = i+1
  if (Ltautmodis)       cfg%out_list(i) = 'tautmodis'
  i = i+1
  if (Ltauwmodis)       cfg%out_list(i) = 'tauwmodis'
  i = i+1
  if (Ltauimodis)       cfg%out_list(i) = 'tauimodis'
  i = i+1
  if (Ltautlogmodis)    cfg%out_list(i) = 'tautlogmodis'
  i = i+1
  if (Ltauwlogmodis)    cfg%out_list(i) = 'tauwlogmodis'
  i = i+1
  if (Ltauilogmodis)    cfg%out_list(i) = 'tauilogmodis'
  i = i+1
  if (Lreffclwmodis)    cfg%out_list(i) = 'reffclwmodis'
  i = i+1
  if (Lreffclimodis)    cfg%out_list(i) = 'reffclimodis'
  i = i+1
  if (Lpctmodis)        cfg%out_list(i) = 'pctmodis'
  i = i+1
  if (Llwpmodis)        cfg%out_list(i) = 'lwpmodis'
  i = i+1
  if (Liwpmodis)        cfg%out_list(i) = 'iwpmodis'
  i = i+1
  if (Lclmodis)         cfg%out_list(i) = 'clmodis'
  i = i+1
  if (Lcrimodis)        cfg%out_list(i) = 'crimodis'
  i = i+1
  if (Lcrlmodis)        cfg%out_list(i) = 'crlmodis'
      
  if (i /= N_OUT_LIST) then
     print *, 'COSP_IO: wrong number of output diagnostics'
     print *, i,N_OUT_LIST
     stop
  endif

  ! Copy diagnostic flags to cfg structure
  ! ISCCP simulator  
  cfg%Lalbisccp = Lalbisccp
  cfg%Latb532 = Latb532
  cfg%Lboxptopisccp = Lboxptopisccp
  cfg%Lboxtauisccp = Lboxtauisccp
  cfg%Lmeantbisccp = Lmeantbisccp
  cfg%Lmeantbclrisccp = Lmeantbclrisccp
  cfg%Lclisccp = Lclisccp
  cfg%Lpctisccp = Lpctisccp
  cfg%Ltauisccp = Ltauisccp
  cfg%Lcltisccp = Lcltisccp
  ! CloudSat simulator  
  cfg%Ldbze94 = Ldbze94
  cfg%LcfadDbze94 = LcfadDbze94
  ! CALIPSO/PARASOL simulator  
  cfg%LcfadLidarsr532 = LcfadLidarsr532
  cfg%Lclcalipso2 = Lclcalipso2
  cfg%Lclcalipso = Lclcalipso
  cfg%Lclhcalipso = Lclhcalipso
  cfg%Lcllcalipso = Lcllcalipso
  cfg%Lclmcalipso = Lclmcalipso
  cfg%Lcltcalipso = Lcltcalipso
  cfg%Lclhcalipsoice = Lclhcalipsoice
  cfg%Lcllcalipsoice = Lcllcalipsoice
  cfg%Lclmcalipsoice = Lclmcalipsoice
  cfg%Lcltcalipsoice = Lcltcalipsoice
  cfg%Lclhcalipsoliq = Lclhcalipsoliq
  cfg%Lcllcalipsoliq = Lcllcalipsoliq
  cfg%Lclmcalipsoliq = Lclmcalipsoliq
  cfg%Lcltcalipsoliq = Lcltcalipsoliq
  cfg%Lclhcalipsoun = Lclhcalipsoun
  cfg%Lcllcalipsoun = Lcllcalipsoun
  cfg%Lclmcalipsoun = Lclmcalipsoun
  cfg%Lcltcalipsoun = Lcltcalipsoun
  cfg%Lclcalipsoice = Lclcalipsoice
  cfg%Lclcalipsoliq = Lclcalipsoliq
  cfg%Lclcalipsoun = Lclcalipsoun
  cfg%Lclcalipsotmp = Lclcalipsotmp
  cfg%Lclcalipsotmpice = Lclcalipsotmpice
  cfg%Lclcalipsotmpliq = Lclcalipsotmpliq
  cfg%Lclcalipsotmpun = Lclcalipsotmpun
  cfg%Lcltlidarradar = Lcltlidarradar
  cfg%LparasolRefl = LparasolRefl
  ! MISR simulator  
  cfg%LclMISR = LclMISR
  ! Other
  cfg%Ltoffset = Ltoffset
  cfg%Lfracout = Lfracout
  cfg%LlidarBetaMol532 = LlidarBetaMol532
  ! RTTOV
  cfg%Ltbrttov = Ltbrttov
  ! MODIS simulator  
  cfg%Lcltmodis=Lcltmodis
  cfg%Lclwmodis=Lclwmodis
  cfg%Lclimodis=Lclimodis
  cfg%Lclhmodis=Lclhmodis
  cfg%Lclmmodis=Lclmmodis
  cfg%Lcllmodis=Lcllmodis
  cfg%Ltautmodis=Ltautmodis
  cfg%Ltauwmodis=Ltauwmodis
  cfg%Ltauimodis=Ltauimodis
  cfg%Ltautlogmodis=Ltautlogmodis
  cfg%Ltauwlogmodis=Ltauwlogmodis
  cfg%Ltauilogmodis=Ltauilogmodis
  cfg%Lreffclwmodis=Lreffclwmodis
  cfg%Lreffclimodis=Lreffclimodis
  cfg%Lpctmodis=Lpctmodis
  cfg%Llwpmodis=Llwpmodis
  cfg%Liwpmodis=Liwpmodis
  cfg%Lclmodis=Lclmodis
 END SUBROUTINE READ_COSP_OUTPUT_NL

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!--------------- SUBROUTINE ERROR_CONTROL ------------------------
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  SUBROUTINE COSP_ERROR(routine_name,message,errcode) 
    character(len = *), intent(in) :: routine_name
    character(len = *), intent(in) :: message
    integer,optional :: errcode
    
    write(6, *) " ********** Failure in ", trim(routine_name)
    write(6, *) " ********** ", trim(message)
    if (present(errcode)) write(6, *) " ********** errcode: ", errcode
    flush(6)
    stop
  END SUBROUTINE COSP_ERROR

END MODULE MOD_COSP_IO

      subroutine scops(npoints,nlev,ncol,seed,cc,conv,
     &                 overlap,frac_out,ncolprint)


! *****************************COPYRIGHT****************************
! (c) British Crown Copyright 2009, the Met Office.
! All rights reserved.
! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/icarus-scops-4.1-bsd/scops.f $
! 
! Redistribution and use in source and binary forms, with or without 
! modification, are permitted provided that the
! following conditions are met:
! 
!     * Redistributions of source code must retain the above 
!       copyright  notice, this list of conditions and the following 
!       disclaimer.
!     * Redistributions in binary form must reproduce the above 
!       copyright notice, this list of conditions and the following 
!       disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Met Office nor the names of its 
!       contributors may be used to endorse or promote products
!       derived from this software without specific prior written 
!       permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
! 
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************
! *****************************COPYRIGHT*******************************

      implicit none

      INTEGER npoints       !  number of model points in the horizontal
      INTEGER nlev          !  number of model levels in column
      INTEGER ncol          !  number of subcolumns


      INTEGER overlap         !  overlap type
                              !  1=max
                              !  2=rand
                              !  3=max/rand
      REAL cc(npoints,nlev)
                  !  input cloud cover in each model level (fraction)
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by clouds

      REAL conv(npoints,nlev)
                  !  input convective cloud cover in each model
                  !   level (fraction)
                  !  NOTE:  This is the HORIZONTAL area of each
                  !         grid box covered by convective clouds

      INTEGER i,j,ilev,ibox,ncolprint,ilev2

      REAL frac_out(npoints,ncol,nlev) ! boxes gridbox divided up into
                              ! Equivalent of BOX in original version, but
                              ! indexed by column then row, rather than
                              ! by row then column


      INTEGER seed(npoints)
      !  seed values for marsaglia  random number generator
      !  It is recommended that the seed is set
      !  to a different value for each model
      !  gridbox it is called on, as it is
      !  possible that the choice of the same
      !  seed value every time may introduce some
      !  statistical bias in the results, particularly
      !  for low values of NCOL.

      REAL tca(npoints,0:nlev) ! total cloud cover in each model level (fraction)
                                        ! with extra layer of zeroes on top
                                        ! in this version this just contains the values input
                                        ! from cc but with an extra level

      REAL threshold(npoints,ncol)   ! pointer to position in gridbox
      REAL maxocc(npoints,ncol)      ! Flag for max overlapped conv cld
      REAL maxosc(npoints,ncol)      ! Flag for max overlapped strat cld

      REAL boxpos(npoints,ncol)      ! ordered pointer to position in gridbox

      REAL threshold_min(npoints,ncol) ! minimum value to define range in with new threshold
                                        ! is chosen

      REAL ran(npoints)                 ! vector of random numbers

      INTEGER irand,i2_16,huge32,overflow_32  ! variables for RNG
      PARAMETER(huge32=2147483647)
      i2_16=65536

      do ibox=1,ncol
        do j=1,npoints 
        boxpos(j,ibox)=(ibox-.5)/ncol
        enddo
      enddo

!     ---------------------------------------------------!
!     Initialise working variables
!     ---------------------------------------------------!

!     Initialised frac_out to zero

      do ilev=1,nlev
        do ibox=1,ncol
          do j=1,npoints
          frac_out(j,ibox,ilev)=0.0
          enddo
        enddo
      enddo

!     assign 2d tca array using 1d input array cc

      do j=1,npoints
        tca(j,0)=0
      enddo

      do ilev=1,nlev
        do j=1,npoints
          tca(j,ilev)=cc(j,ilev)
        enddo
      enddo

      if (ncolprint.ne.0) then
        write (6,'(a)') 'frac_out_pp_rev:'
          do j=1,npoints,1000
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write (6,'(8f5.2)') 
     &     ((frac_out(j,ibox,ilev),ibox=1,ncolprint),ilev=1,nlev)

          enddo
        write (6,'(a)') 'ncol:'
        write (6,'(I3)') ncol
      endif
      if (ncolprint.ne.0) then
        write (6,'(a)') 'last_frac_pp:'
          do j=1,npoints,1000
          write(6,'(a10)') 'j='
          write(6,'(8I10)') j
          write (6,'(8f5.2)') (tca(j,0))
          enddo
      endif

!     ---------------------------------------------------!
!     ALLOCATE CLOUD INTO BOXES, FOR NCOLUMNS, NLEVELS
!     frac_out is the array that contains the information 
!     where 0 is no cloud, 1 is a stratiform cloud and 2 is a
!     convective cloud
      
      !loop over vertical levels
      DO 200 ilev = 1,nlev
                                  
!     Initialise threshold

        IF (ilev.eq.1) then
          ! If max overlap 
          IF (overlap.eq.1) then
            ! select pixels spread evenly
            ! across the gridbox
              DO ibox=1,ncol
                do j=1,npoints
                  threshold(j,ibox)=boxpos(j,ibox)
                enddo
              enddo
          ELSE
              DO ibox=1,ncol
                include 'congvec.f'
                ! select random pixels from the non-convective
                ! part the gridbox ( some will be converted into
                ! convective pixels below )
                do j=1,npoints
                  threshold(j,ibox)=
     &            conv(j,ilev)+(1-conv(j,ilev))*ran(j)
                enddo
              enddo
            ENDIF
            IF (ncolprint.ne.0) then
              write (6,'(a)') 'threshold_nsf2:'
                do j=1,npoints,1000
                write(6,'(a10)') 'j='
                write(6,'(8I10)') j
                write (6,'(8f5.2)') (threshold(j,ibox),ibox=1,ncolprint)
                enddo
            ENDIF
        ENDIF

        IF (ncolprint.ne.0) then
            write (6,'(a)') 'ilev:'
            write (6,'(I2)') ilev
        ENDIF

        DO ibox=1,ncol

          ! All versions
          do j=1,npoints
            if (boxpos(j,ibox).le.conv(j,ilev)) then
              maxocc(j,ibox) = 1
            else
              maxocc(j,ibox) = 0
            end if
          enddo

          ! Max overlap
          if (overlap.eq.1) then 
            do j=1,npoints
              threshold_min(j,ibox)=conv(j,ilev)
              maxosc(j,ibox)=1
            enddo
          endif

          ! Random overlap
          if (overlap.eq.2) then 
            do j=1,npoints
              threshold_min(j,ibox)=conv(j,ilev)
              maxosc(j,ibox)=0
            enddo
          endif

          ! Max/Random overlap
          if (overlap.eq.3) then 
            do j=1,npoints
              threshold_min(j,ibox)=max(conv(j,ilev),
     &          min(tca(j,ilev-1),tca(j,ilev)))
              if (threshold(j,ibox)
     &          .lt.min(tca(j,ilev-1),tca(j,ilev))
     &          .and.(threshold(j,ibox).gt.conv(j,ilev))) then
                   maxosc(j,ibox)= 1
              else
                   maxosc(j,ibox)= 0
              end if
            enddo
          endif
    
          ! Reset threshold 

          include 'congvec.f'

          do j=1,npoints
            threshold(j,ibox)=
              !if max overlapped conv cloud
     &        maxocc(j,ibox) * (                                       
     &            boxpos(j,ibox)                                               
     &        ) +                                                      
              !else
     &        (1-maxocc(j,ibox)) * (                                   
                  !if max overlapped strat cloud
     &            (maxosc(j,ibox)) * (                                 
                      !threshold=boxpos
     &                threshold(j,ibox)                                        
     &            ) +                                                  
                  !else
     &            (1-maxosc(j,ibox)) * (                               
                      !threshold_min=random[thrmin,1]
     &                threshold_min(j,ibox)+
     &                  (1-threshold_min(j,ibox))*ran(j)  
     &           ) 
     &        )
          enddo

        ENDDO ! ibox

!          Fill frac_out with 1's where tca is greater than the threshold

           DO ibox=1,ncol
             do j=1,npoints 
               if (tca(j,ilev).gt.threshold(j,ibox)) then
               frac_out(j,ibox,ilev)=1
               else
               frac_out(j,ibox,ilev)=0
               end if               
             enddo
           ENDDO

!         Code to partition boxes into startiform and convective parts
!         goes here

           DO ibox=1,ncol
             do j=1,npoints 
                if (threshold(j,ibox).le.conv(j,ilev)) then
                    ! = 2 IF threshold le conv(j)
                    frac_out(j,ibox,ilev) = 2 
                else
                    ! = the same IF NOT threshold le conv(j) 
                    frac_out(j,ibox,ilev) = frac_out(j,ibox,ilev)
                end if
             enddo
           ENDDO

!         Set last_frac to tca at this level, so as to be tca 
!         from last level next time round

          if (ncolprint.ne.0) then

            do j=1,npoints ,1000
            write(6,'(a10)') 'j='
            write(6,'(8I10)') j
            write (6,'(a)') 'last_frac:'
            write (6,'(8f5.2)') (tca(j,ilev-1))
    
            write (6,'(a)') 'conv:'
            write (6,'(8f5.2)') (conv(j,ilev),ibox=1,ncolprint)
    
            write (6,'(a)') 'max_overlap_cc:'
            write (6,'(8f5.2)') (maxocc(j,ibox),ibox=1,ncolprint)
    
            write (6,'(a)') 'max_overlap_sc:'
            write (6,'(8f5.2)') (maxosc(j,ibox),ibox=1,ncolprint)
    
            write (6,'(a)') 'threshold_min_nsf2:'
            write (6,'(8f5.2)') (threshold_min(j,ibox),ibox=1,ncolprint)
    
            write (6,'(a)') 'threshold_nsf2:'
            write (6,'(8f5.2)') (threshold(j,ibox),ibox=1,ncolprint)
    
            write (6,'(a)') 'frac_out_pp_rev:'
            write (6,'(8f5.2)') 
     &       ((frac_out(j,ibox,ilev2),ibox=1,ncolprint),ilev2=1,nlev)
          enddo
          endif

200   CONTINUE    !loop over nlev


      end

module cosp_run_mod
    use mod_cosp_constants
    use mod_cosp_types
    use mod_cosp
    use mod_cosp_io
    implicit none

    type cosp_run_config
        type(cosp_config) output
        integer :: &
            overlap, &
            isccp_topheight, &
            isccp_topheight_direction, &
            npoints_it, &
            ncolumns, &
            nlevels, &
            nprmts_max_hydro, &
            naero, &
            nprmts_max_aero, &
            lidar_ice_type, &
            lidar_wavelength, &
            surface_lidar, &
            nlr, &
            platform, &
            satellite, &
            instrument, &
            nchannels, &
            surface_radar, &
            use_mie_tables, &
            use_gas_abs, &
            do_ray, &
            melt_lay
        logical :: &
            use_vgrid, &
            csat_vgrid, &
            use_precipitation_fluxes, &
            use_reff
        real :: &
            radar_freq, &
            k2, &
            ZenAng, &
            co2, &
            ch4, &
            n2o, &
            co, &
            lidar_max_range
        integer, dimension(RTTOV_MAX_CHANNELS) :: channels
        real, dimension(RTTOV_MAX_CHANNELS) :: surfem
    end type

    type cosp_input_fields
        integer :: npoints
        integer :: ncolumns
        integer :: nlevels
        real :: emsfc_lw
        real :: time
        real, dimension(:), allocatable :: &
            lon, &
            lat, &
            skt, &
            land, &
            u_wind, &
            v_wind, &
            sunlit, &
            orog
        real, dimension(:, :), allocatable :: &
            p, &
            ph, &
            zlev, &
            zlev_half, &
            T, &
            sh, &
            rh, &
            tca, &
            cca, &
            !mr_lsliq, &
            !mr_lsice, &
            !mr_ccliq, &
            !mr_ccice, &
            rain_ls, &
            snow_ls, &
            grpl_ls, &
            rain_cv, &
            snow_cv, &
            dtau_s, &
            dtau_c, &
            dem_s, &
            dem_c, &
            mr_ozone
        real, dimension(:, :, :), allocatable :: &
            mr_hydro, &
            Reff
    end type

    type cosp_output_fields
        type(cosp_subgrid) :: sgx
        type(cosp_sgradar) :: sgradar
        type(cosp_sglidar) :: sglidar
        type(cosp_isccp) :: isccp
        type(cosp_modis) :: modis
        type(cosp_misr) :: misr
        type(cosp_rttov) :: rttov
        type(cosp_vgrid) :: vgrid
        type(cosp_radarstats) :: stradar
        type(cosp_lidarstats) :: stlidar
    end type
contains
    subroutine cosp_run(config, input, output)
        type(cosp_run_config), intent(in) :: config
        type(cosp_input_fields), intent(in) :: input
        type(cosp_output_fields), intent(inout) :: output
        type(cosp_gridbox) :: gbx

        integer :: k
        double precision :: time, time_bnds(2), time_step
        real :: toffset_step, half_time_step

        time_step      = 3.D0/24.D0
        time           = 8*1.D0/8.D0
        toffset_step   = time_step/input%npoints
        half_time_step = 0.5*time_step

        call construct_cosp_gridbox( &
            time=time, &
            time_bnds=time_bnds, &
            radar_freq=config%radar_freq, &
            surface_radar=config%surface_radar, &
            use_mie_tables=config%use_mie_tables, &
            use_gas_abs=config%use_gas_abs, &
            do_ray=config%do_ray, &
            melt_lay=config%melt_lay, &
            k2=config%k2, &
            Npoints=input%npoints, &
            Nlevels=input%nlevels, &
            Ncolumns=config%ncolumns, &
            Nhydro=N_HYDRO, &
            Nprmts_max_hydro=config%Nprmts_max_hydro, &
            Naero=config%naero, &
            Nprmts_max_aero=config%nprmts_max_aero, &
            Npoints_it=config%npoints_it, &
            lidar_ice_type=config%lidar_ice_type, &
            lidar_wavelength=config%lidar_wavelength, &
            surface_lidar=config%surface_lidar, &
            isccp_top_height=config%isccp_topheight, &
            isccp_top_height_direction=config%isccp_topheight_direction, &
            isccp_overlap=config%overlap, &
            isccp_emsfc_lw=input%emsfc_lw, &
            use_precipitation_fluxes=config%use_precipitation_fluxes, &
            use_reff=config%use_reff, &
            plat=config%platform, &
            sat=config%satellite, &
            inst=config%instrument, &
            nchan=config%nchannels, &
            zenang=config%zenang, &
            ichan=config%channels(1:config%nchannels), &
            surfem=config%surfem(1:config%nchannels), &
            co2=config%co2, &
            ch4=config%ch4, &
            n2o=config%n2o, &
            co=config%co, &
            y=gbx &
        )

        gbx%longitude = input%lon
        gbx%latitude = input%lat
        ! Toffset. This assumes that time is the mid-point of the interval.

        do k=1,input%npoints
            gbx%toffset(k) = -half_time_step + toffset_step*(k - 0.5)
        end do

        gbx%p = input%p
        gbx%ph = input%ph
        gbx%zlev = input%zlev
        gbx%zlev_half = input%zlev_half
        gbx%T = input%T
        gbx%q = input%rh
        gbx%sh = input%sh
        gbx%cca = input%cca
        gbx%tca = input%tca
        gbx%psfc = input%ph(:,1)
        gbx%skt = input%skt
        gbx%land = input%land
        gbx%mr_ozone = input%mr_ozone
        gbx%u_wind = input%u_wind
        gbx%v_wind = input%v_wind
        gbx%sunlit = input%sunlit
        gbx%mr_hydro = input%mr_hydro
        ! gbx%mr_hydro(:,:,I_LSCLIQ) = input%mr_lsliq
        ! gbx%mr_hydro(:,:,I_LSCICE) = input%mr_lsice
        ! gbx%mr_hydro(:,:,I_CVCLIQ) = input%mr_ccliq
        ! gbx%mr_hydro(:,:,I_CVCICE) = input%mr_ccice
        gbx%rain_ls = input%rain_ls
        gbx%snow_ls = input%snow_ls
        gbx%grpl_ls = input%grpl_ls
        gbx%rain_cv = input%rain_cv
        gbx%snow_cv = input%snow_cv
        gbx%Reff = input%Reff
        gbx%Reff(:,:,I_LSRAIN) = 0.0
        gbx%dtau_s = input%dtau_s
        gbx%dtau_c = input%dtau_c
        gbx%dem_s = input%dem_s
        gbx%dem_c = input%dem_c

        call construct_cosp_vgrid( &
            gbx, &
            config%nlr, &
            config%use_vgrid, &
            config%csat_vgrid, &
            output%vgrid &
        )
        call construct_cosp_subgrid( &
            input%npoints, &
            config%ncolumns, &
            input%nlevels, &
            output%sgx &
        )
        call construct_cosp_sgradar( &
            config%output, &
            input%npoints, &
            config%ncolumns, &
            input%nlevels, &
            N_HYDRO, &
            output%sgradar &
        )
        call construct_cosp_radarstats( &
            config%output, &
            input%npoints, &
            config%ncolumns, &
            output%vgrid%nlvgrid, &
            N_HYDRO, &
            output%stradar &
        )
        call construct_cosp_sglidar( &
            config%output, &
            input%npoints, &
            config%ncolumns, &
            input%nlevels, &
            N_HYDRO, &
            PARASOL_NREFL, &
            output%sglidar &
        )
        call construct_cosp_lidarstats( &
            config%output, &
            input%npoints, &
            config%ncolumns, &
            output%vgrid%nlvgrid, &
            N_HYDRO, &
            PARASOL_NREFL, &
            output%stlidar &
        )
        call construct_cosp_isccp( &
            config%output, &
            input%npoints, &
            config%ncolumns, &
            input%nlevels, &
            output%isccp &
        )
        call construct_cosp_modis( &
            config%output, &
            input%npoints, &
            output%modis &
        )
        call construct_cosp_misr( &
            config%output, &
            input%npoints, &
            output%misr &
        )
        call construct_cosp_rttov( &
            config%output, &
            input%npoints, &
            config%nchannels, &
            output%rttov &
        )

        call cosp( &
            config%overlap, &
            config%ncolumns, &
            config%output, &
            output%vgrid, &
            gbx, &
            output%sgx, &
            output%sgradar, &
            output%sglidar, &
            output%isccp, &
            output%misr, &
            output%modis, &
            output%stradar, &
            output%stlidar &
        )

        gbx%time = time
    end subroutine

    subroutine cosp_run_free_output(output)
        type(cosp_output_fields), intent(inout) :: output

        !call free_cosp_gridbox(output%gbx)
        call free_cosp_subgrid(output%sgx)
        call free_cosp_sgradar(output%sgradar)
        call free_cosp_radarstats(output%stradar)
        call free_cosp_sglidar(output%sglidar)
        call free_cosp_lidarstats(output%stlidar)
        call free_cosp_isccp(output%isccp)
        call free_cosp_misr(output%misr)
        call free_cosp_modis(output%modis)
        call free_cosp_rttov(output%rttov)
        call free_cosp_vgrid(output%vgrid)
    end subroutine

    subroutine allocate_cosp_input_fields(fields, npoints, nlevels)
        type(cosp_input_fields), intent(inout) :: fields
        integer, intent(in) :: &
            npoints, &
            nlevels

        integer, parameter :: nhydro = N_HYDRO

        allocate( &
            fields%lon(npoints), &
            fields%lat(npoints), &
            fields%skt(npoints), &
            fields%land(npoints), &
            fields%u_wind(npoints), &
            fields%v_wind(npoints), &
            fields%sunlit(npoints), &
            fields%orog(npoints), &
            fields%p(npoints, nlevels), &
            fields%ph(npoints, nlevels), &
            fields%zlev(npoints, nlevels), &
            fields%zlev_half(npoints, nlevels), &
            fields%T(npoints, nlevels), &
            fields%sh(npoints, nlevels), &
            fields%rh(npoints, nlevels), &
            fields%tca(npoints, nlevels), &
            fields%cca(npoints, nlevels), &
            fields%rain_ls(npoints, nlevels), &
            fields%snow_ls(npoints, nlevels), &
            fields%grpl_ls(npoints, nlevels), &
            fields%rain_cv(npoints, nlevels), &
            fields%snow_cv(npoints, nlevels), &
            fields%dtau_s(npoints, nlevels), &
            fields%dtau_c(npoints, nlevels), &
            fields%dem_s(npoints, nlevels), &
            fields%dem_c(npoints, nlevels), &
            fields%mr_ozone(npoints, nlevels), &
            fields%mr_hydro(npoints, nlevels, nhydro), &
            fields%Reff(npoints, nlevels, nhydro) &
        )

        fields%lon = 0
        fields%lat = 0
        fields%skt = 0
        fields%land = 0
        fields%u_wind  = 0
        fields%v_wind = 0
        fields%sunlit = 0
        fields%orog = 0
        fields%p = 0
        fields%ph = 0
        fields%zlev = 0
        fields%zlev_half = 0
        fields%T = 0
        fields%sh = 0
        fields%rh = 0
        fields%tca = 0
        fields%cca = 0
        fields%rain_ls = 0
        fields%snow_ls = 0
        fields%grpl_ls = 0
        fields%rain_cv = 0
        fields%snow_cv = 0
        fields%dtau_s = 0
        fields%dtau_c = 0
        fields%dem_s = 0
        fields%dem_c = 0
        fields%mr_ozone = 0
        fields%mr_hydro = 0
        fields%Reff = 0
    end subroutine

    subroutine deallocate_cosp_input_fields(fields, npoints, nlevels)
        type(cosp_input_fields), intent(inout) :: fields
        integer, intent(in) :: &
            npoints, &
            nlevels

        integer, parameter :: nhydro = 4

        deallocate( &
            fields%lon, &
            fields%lat, &
            fields%skt, &
            fields%land, &
            fields%u_wind, &
            fields%v_wind, &
            fields%sunlit, &
            fields%p, &
            fields%ph, &
            fields%zlev, &
            fields%zlev_half, &
            fields%T, &
            fields%sh, &
            fields%rh, &
            fields%tca, &
            fields%cca, &
            fields%rain_ls, &
            fields%snow_ls, &
            fields%grpl_ls, &
            fields%rain_cv, &
            fields%snow_cv, &
            fields%dtau_s, &
            fields%dtau_c, &
            fields%dem_s, &
            fields%dem_c, &
            fields%mr_ozone, &
            fields%mr_hydro, &
            fields%Reff &
        )
    end subroutine
end module

! (c) 2008, Lawrence Livermore National Security Limited Liability Corporation.
! All rights reserved.
! $Revision: 23 $, $Date: 2011-03-31 07:41:37 -0600 (Thu, 31 Mar 2011) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/llnl/pf_to_mr.f $
! 
! Redistribution and use in source and binary forms, with or without modification, are permitted 
! provided that the following conditions are met:
! 
!     * Redistributions of source code must retain the above copyright notice, this list 
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list 
!       of conditions and the following disclaimer in the documentation and/or other materials 
!       provided with the distribution.
!     * Neither the name of the Lawrence Livermore National Security Limited Liability Corporation 
!       nor the names of its contributors may be used to endorse or promote products derived from 
!       this software without specific prior written permission.
! 
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
      
      subroutine pf_to_mr(npoints,nlev,ncol,rain_ls,snow_ls,grpl_ls,
     &                    rain_cv,snow_cv,prec_frac,
     &                    p,t,mx_rain_ls,mx_snow_ls,mx_grpl_ls,
     &                    mx_rain_cv,mx_snow_cv)


      implicit none

      INTEGER npoints       !  number of model points in the horizontal
      INTEGER nlev          !  number of model levels in column
      INTEGER ncol          !  number of subcolumns

      INTEGER j,ilev,ibox
      
      REAL rain_ls(npoints,nlev),snow_ls(npoints,nlev) ! large-scale precip. flux
      REAL grpl_ls(npoints,nlev)
      REAL rain_cv(npoints,nlev),snow_cv(npoints,nlev) ! convective precip. flux

      REAL prec_frac(npoints,ncol,nlev) ! 0 -> clear sky
                                        ! 1 -> LS precipitation
                                        ! 2 -> CONV precipitation
                                        ! 3 -> both
      REAL mx_rain_ls(npoints,ncol,nlev),mx_snow_ls(npoints,ncol,nlev)
      REAL mx_grpl_ls(npoints,ncol,nlev)
      REAL mx_rain_cv(npoints,ncol,nlev),mx_snow_cv(npoints,ncol,nlev)
      REAL p(npoints,nlev),t(npoints,nlev)
      REAL ar,as,ag,br,bs,bg,nr,ns,ng,rho0,rhor,rhos,rhog,rho
      REAL term1r,term1s,term1g,term2r,term2s,term2g,term3
      REAL term4r_ls,term4s_ls,term4g_ls,term4r_cv,term4s_cv
      REAL term1x2r,term1x2s,term1x2g,t123r,t123s,t123g
      
      ! method from Khairoutdinov and Randall (2003 JAS)

      ! --- List of constants from Appendix B
      ! Constant in fall speed formula
      ar=842.
      as=4.84
      ag=94.5
      ! Exponent in fall speed formula
      br=0.8
      bs=0.25
      bg=0.5
      ! Intercept parameter
      nr=8.*1000.*1000.
      ns=3.*1000.*1000.
      ng=4.*1000.*1000.
      ! Densities for air and hydrometeors
      rho0=1.29
      rhor=1000.
      rhos=100.
      rhog=400.
      ! Term 1 of Eq. (A19).
      term1r=ar*17.8379/6.
      term1s=as*8.28508/6.
      term1g=ag*11.6317/6.
      ! Term 2 of Eq. (A19).
      term2r=(3.14159265*rhor*nr)**(-br/4.)
      term2s=(3.14159265*rhos*ns)**(-bs/4.)
      term2g=(3.14159265*rhog*ng)**(-bg/4.)
      
      term1x2r=term1r*term2r
      term1x2s=term1s*term2s
      term1x2g=term1g*term2g
      do ilev=1,nlev
        do j=1,npoints
            rho=p(j,ilev)/(287.05*t(j,ilev))
            term3=(rho0/rho)**0.5
            ! Term 4 of Eq. (A19).
            t123r=term1x2r*term3
            t123s=term1x2s*term3
            t123g=term1x2g*term3
            term4r_ls=rain_ls(j,ilev)/(t123r)
            term4s_ls=snow_ls(j,ilev)/(t123s)
            term4g_ls=grpl_ls(j,ilev)/(t123g)
            term4r_cv=rain_cv(j,ilev)/(t123r)
            term4s_cv=snow_cv(j,ilev)/(t123s)
            do ibox=1,ncol
                mx_rain_ls(j,ibox,ilev)=0.
                mx_snow_ls(j,ibox,ilev)=0.
                mx_grpl_ls(j,ibox,ilev)=0.
                mx_rain_cv(j,ibox,ilev)=0.
                mx_snow_cv(j,ibox,ilev)=0.
                if ((prec_frac(j,ibox,ilev) .eq. 1.) .or.
     &              (prec_frac(j,ibox,ilev) .eq. 3.)) then 
                    mx_rain_ls(j,ibox,ilev)=
     &                     (term4r_ls**(1./(1.+br/4.)))/rho
                    mx_snow_ls(j,ibox,ilev)=
     &                     (term4s_ls**(1./(1.+bs/4.)))/rho
                    mx_grpl_ls(j,ibox,ilev)=
     &                     (term4g_ls**(1./(1.+bg/4.)))/rho
                endif
                if ((prec_frac(j,ibox,ilev) .eq. 2.) .or.
     &              (prec_frac(j,ibox,ilev) .eq. 3.)) then 
                    mx_rain_cv(j,ibox,ilev)=
     &                     (term4r_cv**(1./(1.+br/4.)))/rho
                    mx_snow_cv(j,ibox,ilev)=
     &                     (term4s_cv**(1./(1.+bs/4.)))/rho
                endif
            enddo ! loop over ncol
        enddo ! loop over npoints
      enddo ! loop over nlev
  
      end

! Copyright (c) 2009, Centre National de la Recherche Scientifique
! All rights reserved.
! $Revision: 88 $, $Date: 2013-11-13 07:08:38 -0700 (Wed, 13 Nov 2013) $
! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/actsim/lidar_simulator.F90 $
!
! Redistribution and use in source and binary forms, with or without modification, are permitted
! provided that the following conditions are met:
!
!     * Redistributions of source code must retain the above copyright notice, this list
!       of conditions and the following disclaimer.
!     * Redistributions in binary form must reproduce the above copyright notice, this list
!       of conditions and the following disclaimer in the documentation and/or other materials
!       provided with the distribution.
!     * Neither the name of the LMD/IPSL/CNRS/UPMC nor the names of its
!       contributors may be used to endorse or promote products derived from this software without
!       specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

SUBROUTINE ice_optical_params(npoints, nlev, temp, kp_part, rdiffm, rad)
    IMPLICIT NONE

    INTEGER, INTENT(IN) :: npoints ! number of points
    INTEGER, INTENT(IN) :: nlev ! number of levels
    REAL, INTENT(IN) :: temp(npoints, nlev) ! air temperature (K)
    REAL, INTENT(OUT) :: kp_part(npoints, nlev) ! backscattering-to-extinction ratio (sr^-1)
    REAL, INTENT(OUT) :: rdiffm(npoints, nlev) ! multiple scattering coefficinent (1)
    REAL, INTENT(OUT) :: rad(npoints, nlev) ! effective radius (meters)

    REAL s(npoints, nlev) ! lidar ratio (sr)
    REAL, PARAMETER, DIMENSION(*) :: s_c = &
        (/ 20.0, 34.0, 200.0, 230.0 /) ! lidar ratio coefficients
    REAL, PARAMETER, DIMENSION(*) :: rdiffm_c = &
        (/ 0.8, 0.5, 200.0, 240.0 /) ! multiple scattering coefficients
    REAL, PARAMETER, DIMENSION(*) :: rad_c = &
        (/ 16.4e-6, 49.2e-6, 213.15, 253.15 /) ! effective radius coefficients

    s = exp( &
        log(s_c(1)) + (log(s_c(2)) - log(s_c(1)))* &
        (1.0/temp - 1.0/s_c(3))/(1.0/s_c(4) - 1.0/s_c(3)))

    kp_part = 1.0/s

    rdiffm = exp( &
        log(rdiffm_c(1)) + (log(rdiffm_c(2)) - log(rdiffm_c(1)))* &
        (1.0/temp - 1.0/rdiffm_c(3))/(1.0/rdiffm_c(4) - 1.0/rdiffm_c(3)))

    rad = exp( &
        log(rad_c(1)) + (log(rad_c(2)) - log(rad_c(1)))* &
        (1.0/temp - 1.0/rad_c(3))/(1.0/rad_c(4) - 1.0/rad_c(3)))
END SUBROUTINE ice_optical_params

      SUBROUTINE lidar_simulator(npoints,nlev,npart,nrefl &
                , undef &
                , pres, presf, temp &
                , q_lsliq, q_lsice, q_cvliq, q_cvice &
                , ls_radliq, ls_radice, cv_radliq, cv_radice &
                , ice_type, lidar_wavelength, surface_lidar &
                , pmol, pnorm, pnorm_perp_tot,tautot, refl, ice_temp_param )
!
!---------------------------------------------------------------------------------
! Purpose: To compute lidar signal from model-simulated profiles of cloud water
!          and cloud fraction in each sub-column of each model gridbox.
!
! References:
! Chepfer H., S. Bony, D. Winker, M. Chiriaco, J.-L. Dufresne, G. Seze (2008),
! Use of CALIPSO lidar observations to evaluate the cloudiness simulated by a
! climate model, Geophys. Res. Lett., 35, L15704, doi:10.1029/2008GL034207.
!
! Previous references:
! Chiriaco et al, MWR, 2006; Chepfer et al., MWR, 2007
!
! Contacts: Helene Chepfer (chepfer@lmd.polytechnique.fr), Sandrine Bony (bony@lmd.jussieu.fr)
!
! May 2007: ActSim code of M. Chiriaco and H. Chepfer rewritten by S. Bony
!
! May 2008, H. Chepfer:
! - Units of pressure inputs: Pa
! - Non Spherical particles : LS Ice NS coefficients, CONV Ice NS coefficients
! - New input: ice_type (0=ice-spheres ; 1=ice-non-spherical)
!
! June 2008, A. Bodas-Salcedo:
! - Ported to Fortran 90 and optimisation changes
!
! August 2008, J-L Dufresne:
! - Optimisation changes (sum instructions suppressed)
!
! October 2008, S. Bony,  H. Chepfer and J-L. Dufresne :
! - Interface with COSP v2.0:
!      cloud fraction removed from inputs
!      in-cloud condensed water now in input (instead of grid-averaged value)
!      depolarisation diagnostic removed
!      parasol (polder) reflectances (for 5 different solar zenith angles) added
!
! December 2008, S. Bony,  H. Chepfer and J-L. Dufresne :
! - Modification of the integration of the lidar equation.
! - change the cloud detection threshold
!
! April 2008, A. Bodas-Salcedo:
! - Bug fix in computation of pmol and pnorm of upper layer
!
! April 2008, J-L. Dufresne
! - Bug fix in computation of pmol and pnorm, thanks to Masaki Satoh: a factor 2
! was missing. This affects the ATB values but not the cloud fraction.
!
! January 2013, G. Cesana and H. Chepfer:
! - Add the perpendicular component of the backscattered signal (pnorm_perp_tot) in the arguments
! - Add the temperature for each levels (temp) in the arguments
! - Add the computation of the perpendicular component of the backscattered lidar signal
! Reference: Cesana G. and H. Chepfer (2013): Evaluation of the cloud water phase
! in a climate model using CALIPSO-GOCCP, J. Geophys. Res., doi: 10.1002/jgrd.50376
!
!---------------------------------------------------------------------------------
!
! Inputs:
!  npoints  : number of horizontal points
!  nlev : number of vertical levels
!  npart: numberb of cloud meteors (stratiform_liq, stratiform_ice, conv_liq, conv_ice).
!        Currently npart must be 4
!  nrefl: number of solar zenith angles for parasol reflectances
!  pres : pressure in the middle of atmospheric layers (full levels): Pa
!  presf: pressure in the interface of atmospheric layers (half levels): Pa
!     presf(..,1) : surface pressure ; presf(..,nlev+1)= TOA pressure
!  temp : temperature of atmospheric layers: K
!  q_lsliq: LS sub-column liquid water mixing ratio (kg/kg)
!  q_lsice: LS sub-column ice water mixing ratio (kg/kg)
!  q_cvliq: CONV sub-column liquid water mixing ratio (kg/kg)
!  q_cvice: CONV sub-column ice water mixing ratio (kg/kg)
!  ls_radliq: effective radius of LS liquid particles (meters)
!  ls_radice: effective radius of LS ice particles (meters)
!  cv_radliq: effective radius of CONV liquid particles (meters)
!  cv_radice: effective radius of CONV ice particles (meters)
!  ice_type : ice particle shape hypothesis (ice_type=0 for spheres, ice_type=1
!             for non spherical particles)
!  ice_temp_param: use ice temperature-based parametrization
!
! Outputs:
!  pmol : molecular attenuated backscatter lidar signal power (m^-1.sr^-1)
!  pnorm: total attenuated backscatter lidar signal power (m^-1.sr^-1)
!  pnorm_perp_tot: perpendicular attenuated backscatter lidar signal power (m^-1.sr^-1)
!  tautot: optical thickess integrated from top to level z
!  refl : parasol(polder) reflectance
!
! Version 1.0 (June 2007)
! Version 1.1 (May 2008)
! Version 1.2 (June 2008)
! Version 2.0 (October 2008)
! Version 2.1 (December 2008)
!---------------------------------------------------------------------------------

      IMPLICIT NONE
      REAL :: SRsat
      PARAMETER (SRsat = 0.01) ! threshold full attenuation

      LOGICAL ok_parasol
      PARAMETER (ok_parasol=.true.)  ! set to .true. if you want to activate parasol reflectances

      INTEGER i, j, k, n

      INTEGER INDX_LSLIQ,INDX_LSICE,INDX_CVLIQ,INDX_CVICE
      PARAMETER (INDX_LSLIQ=1,INDX_LSICE=2,INDX_CVLIQ=3,INDX_CVICE=4)
! inputs:
      INTEGER npoints,nlev,npart,ice_type
      INTEGER nrefl
      real undef                 ! undefined value
      REAL pres(npoints,nlev)    ! pressure full levels
      REAL presf(npoints,nlev+1) ! pressure half levels
      REAL q_lsliq(npoints,nlev), q_lsice(npoints,nlev)
      REAL q_cvliq(npoints,nlev), q_cvice(npoints,nlev)
      REAL ls_radliq(npoints,nlev), ls_radice(npoints,nlev)
      REAL cv_radliq(npoints,nlev), cv_radice(npoints,nlev)
      INTEGER lidar_wavelength, surface_lidar
      LOGICAL ice_temp_param ! use ice temperature parametrization

! outputs (for each subcolumn):

      REAL pmol(npoints,nlev)  ! molecular backscatter signal power (m^-1.sr^-1)
      REAL pnorm(npoints,nlev) ! total lidar backscatter signal power (m^-1.sr^-1)
      REAL tautot(npoints,nlev)! optical thickess integrated from top
      REAL refl(npoints,nrefl)! parasol reflectance ! parasol

! actsim variables:

      REAL km, rdiffm_const, Qscat, Cmol, Cmol_532
      PARAMETER (Cmol_532 = 6.2446e-32) ! Rayleigh scattering cross section (532 nm)
      PARAMETER (km = 1.38e-23)     ! Boltzmann constant (J/K)

      PARAMETER (rdiffm_const = 0.7)      ! multiple scattering correction parameter
      PARAMETER (Qscat = 2.0)       ! particle scattering efficiency at 532 nm

      REAL rholiq, rhoice
      PARAMETER (rholiq=1.0e+03)     ! liquid water (kg/m3)
      PARAMETER (rhoice=0.5e+03)     ! ice (kg/m3)

      REAL mie_backscatter(500) ! Mie backscatter as a function of effective radius ([5, 50] um in 500 steps)
#include "mie_backscatter_532.F90"
#include "mie_backscatter_910.F90"
#include "mie_backscatter_1064.F90"

      REAL rdiffm(npoints,nlev,npart)

      REAL rdiffm_ice(npoints,nlev)
      REAL kp_part_ice(npoints,nlev)
      REAL rad_ice(npoints,nlev)

      REAL pi, rhopart(npart)
      REAL polpart(npart,5)  ! polynomial coefficients derived for spherical and non spherical
                             ! particules

!   grid-box variables:
      REAL rad_part(npoints,nlev,npart)
      REAL rhoair(npoints,nlev), zheight(npoints,nlev+1)
      REAL beta_mol(npoints,nlev), alpha_mol(npoints,nlev)
      REAL kp_part(npoints,nlev,npart)

!   sub-column variables:
      REAL qpart(npoints,nlev,npart) ! mixing ratio particles in each subcolumn
      REAL alpha_part(npoints,nlev,npart)
      REAL tau_mol_lay(npoints)  ! temporary variable, moL. opt. thickness of layer k
      REAL tau_mol(npoints,nlev) ! optical thickness between TOA and bottom of layer k
      REAL tau_part(npoints,nlev,npart)
      REAL betatot(npoints,nlev)
      REAL tautot_lay(npoints)   ! temporary variable, total opt. thickness of layer k
!     Optical thickness from TOA to surface for Parasol
     REAL tautot_S_liq(npoints),tautot_S_ice(npoints)     ! for liq and ice clouds


! Local variables
      REAL Alpha, Beta, Gamma  ! Polynomial coefficient for ATBperp computation
      REAL temp(npoints,nlev)                   ! temperature of layer k
      REAL betatot_ice(npoints,nlev)    ! backscatter coefficient for ice particles
      REAL beta_perp_ice(npoints,nlev)  ! perpendicular backscatter coefficient for ice
      REAL betatot_liq(npoints,nlev)    ! backscatter coefficient for liquid particles
      REAL beta_perp_liq(npoints,nlev)  ! perpendicular backscatter coefficient for liq
      REAL tautot_ice(npoints,nlev)     ! total optical thickness of ice
      REAL tautot_liq(npoints,nlev)     ! total optical thickness of liq
      REAL tautot_lay_ice(npoints)    ! total optical thickness of ice in the layer k
      REAL tautot_lay_liq(npoints)    ! total optical thickness of liq in the layer k
      REAL pnorm_liq(npoints,nlev)    ! lidar backscattered signal power for liquid
      REAL pnorm_ice(npoints,nlev)    ! lidar backscattered signal power for ice
      REAL pnorm_perp_ice(npoints,nlev) ! perpendicular lidar backscattered signal power for ice
      REAL pnorm_perp_liq(npoints,nlev) ! perpendicular lidar backscattered signal power for liq
      REAL presf_new(npoints,nlev+1)
      REAL presf_old(npoints,nlev+1)

! Output variable
      REAL pnorm_perp_tot (npoints,nlev) ! perpendicular lidar backscattered signal power

! Vertical field reversal if surface lidar
if ( surface_lidar .eq. 1 ) then
  presf_old(:,:) = presf(:,:)
  presf_new(:,nlev+1) = 0
  do k = nlev, 1, -1
    presf_new(:,k) = presf_new(:,k+1) + presf(:,nlev-k+1) - presf(:,nlev-k+2)
  end do
  presf(:,:) = presf_new(:,:)

  pres(:,:) = pres(:,nlev:1:-1)
  temp(:,:) = temp(:,nlev:1:-1)
  q_lsliq(:,:) = q_lsliq(:,nlev:1:-1)
  q_lsice(:,:) = q_lsice(:,nlev:1:-1)
  q_cvliq(:,:) = q_cvliq(:,nlev:1:-1)
  q_cvice(:,:) = q_cvice(:,nlev:1:-1)
  ls_radliq(:,:) = ls_radliq(:,nlev:1:-1)
  ls_radice(:,:) = ls_radice(:,nlev:1:-1)
  cv_radliq(:,:) = cv_radliq(:,nlev:1:-1)
  cv_radice(:,:) = cv_radice(:,nlev:1:-1)
end if

!------------------------------------------------------------
!---- 0. Initialisation :
!------------------------------------------------------------
betatot_ice(:,:)=0
betatot_liq(:,:)=0
beta_perp_ice(:,:)=0
beta_perp_liq(:,:)=0
tautot_ice(:,:)=0
tautot_liq(:,:)=0
tautot_lay_ice(:)=0;
tautot_lay_liq(:)=0;
pnorm_liq(:,:)=0
pnorm_ice(:,:)=0
pnorm_perp_ice(:,:)=0
pnorm_perp_liq(:,:)=0
pnorm_perp_tot(:,:)=0


! Polynomial coefficients (Alpha, Beta, Gamma) which allow to compute the ATBperpendicular
! as a function of the ATB for ice or liquid cloud particles derived from CALIPSO-GOCCP
! observations at 120m vertical grid (Cesana and Chepfer, JGR, 2013).
!
! Relationship between ATBice and ATBperp,ice for ice particles
!  ATBperp,ice = Alpha*ATBice
         Alpha = 0.2904

! Relationship between ATBice and ATBperp,ice for liquid particles
!  ATBperp,ice = Beta*ATBice^2 + Gamma*ATBice
         Beta = 0.4099
         Gamma = 0.009

!------------------------------------------------------------
!---- 1. Preliminary definitions and calculations :
!------------------------------------------------------------

      if ( npart .ne. 4 ) then
        print *,'Error in lidar_simulator, npart should be 4, not',npart
        stop
      endif

      pi = dacos(-1.D0)

! Polynomial coefficients for spherical liq/ice particles derived from Mie theory.
! Polynomial coefficients for non spherical particles derived from a composite of
! Ray-tracing theory for large particles (e.g. Noel et al., Appl. Opt., 2001)
! and FDTD theory for very small particles (Yang et al., JQSRT, 2003).

! We repeat the same coefficients for LS and CONV cloud to make code more readable
!*     LS Liquid water coefficients:
         polpart(INDX_LSLIQ,1) =  2.6980e-8
         polpart(INDX_LSLIQ,2) = -3.7701e-6
         polpart(INDX_LSLIQ,3) =  1.6594e-4
         polpart(INDX_LSLIQ,4) = -0.0024
         polpart(INDX_LSLIQ,5) =  0.0626
!*     LS Ice coefficients:
      if (ice_type.eq.0) then
         polpart(INDX_LSICE,1) = -1.0176e-8
         polpart(INDX_LSICE,2) =  1.7615e-6
         polpart(INDX_LSICE,3) = -1.0480e-4
         polpart(INDX_LSICE,4) =  0.0019
         polpart(INDX_LSICE,5) =  0.0460
      endif
!*     LS Ice NS coefficients:
      if (ice_type.eq.1) then
         polpart(INDX_LSICE,1) = 1.3615e-8
         polpart(INDX_LSICE,2) = -2.04206e-6
         polpart(INDX_LSICE,3) = 7.51799e-5
         polpart(INDX_LSICE,4) = 0.00078213
         polpart(INDX_LSICE,5) = 0.0182131
      endif
!*     CONV Liquid water coefficients:
         polpart(INDX_CVLIQ,1) =  2.6980e-8
         polpart(INDX_CVLIQ,2) = -3.7701e-6
         polpart(INDX_CVLIQ,3) =  1.6594e-4
         polpart(INDX_CVLIQ,4) = -0.0024
         polpart(INDX_CVLIQ,5) =  0.0626
!*     CONV Ice coefficients:
      if (ice_type.eq.0) then
         polpart(INDX_CVICE,1) = -1.0176e-8
         polpart(INDX_CVICE,2) =  1.7615e-6
         polpart(INDX_CVICE,3) = -1.0480e-4
         polpart(INDX_CVICE,4) =  0.0019
         polpart(INDX_CVICE,5) =  0.0460
      endif
      if (ice_type.eq.1) then
         polpart(INDX_CVICE,1) = 1.3615e-8
         polpart(INDX_CVICE,2) = -2.04206e-6
         polpart(INDX_CVICE,3) = 7.51799e-5
         polpart(INDX_CVICE,4) = 0.00078213
         polpart(INDX_CVICE,5) = 0.0182131
      endif

! density:
!*    clear-sky air:
      rhoair = pres/(287.04*temp)

!*    liquid/ice particules:
      rhopart(INDX_LSLIQ) = rholiq
      rhopart(INDX_LSICE) = rhoice
      rhopart(INDX_CVLIQ) = rholiq
      rhopart(INDX_CVICE) = rhoice

! effective radius particles:
      rad_part(:,:,INDX_LSLIQ) = ls_radliq(:,:)
      rad_part(:,:,INDX_LSICE) = ls_radice(:,:)
      rad_part(:,:,INDX_CVLIQ) = cv_radliq(:,:)
      rad_part(:,:,INDX_CVICE) = cv_radice(:,:)
      rad_part(:,:,:)=MAX(rad_part(:,:,:),0.)
      rad_part(:,:,:)=MIN(rad_part(:,:,:),70.0e-6)

! altitude at half pressure levels:
      zheight(:,1) = 0.0
      do k = 2, nlev+1
        zheight(:,k) = zheight(:,k-1) &
                  -(presf(:,k)-presf(:,k-1))/(rhoair(:,k-1)*9.81)
      enddo

!------------------------------------------------------------
!---- 2. Molecular alpha and beta:
!------------------------------------------------------------

      Cmol = Cmol_532*EXP(4.09*(LOG(532.0) - LOG(1.0*lidar_wavelength)))
      beta_mol = pres/km/temp * Cmol
      alpha_mol = 8.0*pi/3.0 * beta_mol

!------------------------------------------------------------
!---- 3. Particles alpha and beta:
!------------------------------------------------------------

! polynomes kp_lidar derived from Mie theory:
      !do i = 1, npart
      ! where ( rad_part(:,:,i).gt.0.0)
      !   kp_part(:,:,i) = &
      !      polpart(i,1)*(rad_part(:,:,i)*1e6)**4 &
      !    + polpart(i,2)*(rad_part(:,:,i)*1e6)**3 &
      !    + polpart(i,3)*(rad_part(:,:,i)*1e6)**2 &
      !    + polpart(i,4)*(rad_part(:,:,i)*1e6) &
      !    + polpart(i,5)
      !  elsewhere
      !   kp_part(:,:,i) = 0.
      !  endwhere
      !  kp_part(:,:,i) = kp_part(:,:,i)*EXP(2*(LOG(1.0*lidar_wavelength) - LOG(532.0)))
      !enddo

      if (lidar_wavelength == 532) then
        mie_backscatter = mie_backscatter_532
      elseif (lidar_wavelength == 910) then
        mie_backscatter = mie_backscatter_910
      elseif (lidar_wavelength == 1064) then
        mie_backscatter = mie_backscatter_1064
      else
        stop 'Unsupported lidar wavelength'
      end if

      do i = 1, npart
       do j = 1, npoints
        do k = 1, nlev
         if (rad_part(j,k,i) > 0.0) then
          n = (rad_part(j,k,i)*1e6 - 5)/(50 - 1)*500
          kp_part(j,k,i) = mie_backscatter(n)
         else
          kp_part(j,k,i) = 0
         end if
        enddo
       enddo
      enddo

rdiffm(:,:,:) = rdiffm_const

! ice temperature-based parametrisation

if (ice_temp_param) then
    call ice_optical_params(npoints, nlev, temp, &
        kp_part_ice, rdiffm_ice, rad_ice)
    kp_part(:,:,INDX_LSICE) = kp_part_ice(:,:)
    kp_part(:,:,INDX_CVICE) = kp_part_ice(:,:)
    rdiffm(:,:,INDX_LSICE) = rdiffm_ice(:,:)
    rdiffm(:,:,INDX_CVICE) = rdiffm_ice(:,:)
    rad_part(:,:,INDX_LSICE) = rad_ice(:,:)
    rad_part(:,:,INDX_CVICE) = rad_ice(:,:)
endif

! mixing ratio particules in each subcolumn:
          qpart(:,:,INDX_LSLIQ) = q_lsliq(:,:) ! oct08
          qpart(:,:,INDX_LSICE) = q_lsice(:,:) ! oct08
          qpart(:,:,INDX_CVLIQ) = q_cvliq(:,:) ! oct08
          qpart(:,:,INDX_CVICE) = q_cvice(:,:) ! oct08

! alpha of particles in each subcolumn:
      do i = 1, npart
        where ( rad_part(:,:,i).gt.0.0)
          alpha_part(:,:,i) = 3.0/4.0 * Qscat &
                 * rhoair(:,:) * qpart(:,:,i) &
                 / (rhopart(i) * rad_part(:,:,i) )
        elsewhere
          alpha_part(:,:,i) = 0.
        endwhere
      enddo

!------------------------------------------------------------
!---- 4.1 Total Backscatter signal:
!------------------------------------------------------------

! optical thickness (molecular):
!     opt. thick of each layer
      tau_mol(:,1:nlev) = alpha_mol(:,1:nlev) &
         & *(zheight(:,2:nlev+1)-zheight(:,1:nlev))
!     opt. thick from TOA
      DO k = nlev-1, 1, -1
        tau_mol(:,k) = tau_mol(:,k) + tau_mol(:,k+1)
      ENDDO

! optical thickness (particles):

      tau_part = rdiffm * alpha_part
      DO i = 1, npart
!       opt. thick of each layer
        tau_part(:,:,i) = tau_part(:,:,i) &
           & * (zheight(:,2:nlev+1)-zheight(:,1:nlev) )
!       opt. thick from TOA
        DO k = nlev-1, 1, -1
          tau_part(:,k,i) = tau_part(:,k,i) + tau_part(:,k+1,i)
        ENDDO
      ENDDO

! molecular signal:
!      Upper layer
       WHERE (tau_mol(:,nlev).GT.0.)
         pmol(:,nlev) = beta_mol(:,nlev) / (2.*tau_mol(:,nlev)) &
              & * (1.-exp(-2.0*tau_mol(:,nlev)))
       ELSEWHERE
         pmol(:,nlev) = 0.
       END WHERE
!      Other layers
       DO k= nlev-1, 1, -1
        tau_mol_lay(:) = tau_mol(:,k)-tau_mol(:,k+1) ! opt. thick. of layer k
        WHERE (tau_mol_lay(:).GT.0.)
          pmol(:,k) = beta_mol(:,k) * EXP(-2.0*tau_mol(:,k+1)) / (2.*tau_mol_lay(:)) &
            & * (1.-exp(-2.0*tau_mol_lay(:)))
        ELSEWHERE
!         This must never happend, but just in case, to avoid div. by 0
          pmol(:,k) = beta_mol(:,k) * EXP(-2.0*tau_mol(:,k+1))
        END WHERE
      END DO

! Total signal (molecular + particules):
!
!
! For performance reason on vector computers, the 2 following lines should not be used
! and should be replace by the later one.
!      betatot(:,:) = beta_mol(:,:) + sum(kp_part*alpha_part,dim=3)
!      tautot(:,:)  = tau_mol(:,:)  + sum(tau_part,dim=3)
      betatot(:,:) = beta_mol(:,:)
      tautot(:,:)  = tau_mol(:,:)
      DO i = 1, npart
           betatot(:,:) = betatot(:,:) + kp_part(:,:,i)*alpha_part(:,:,i)
           tautot(:,:) = tautot(:,:)  + tau_part(:,:,i)
      ENDDO ! i
!
!     Upper layer
      WHERE (tautot(:,nlev).GT.0.)
        pnorm(:,nlev) = betatot(:,nlev) / (2.*tautot(:,nlev)) &
              & * (1.-exp(-2.0*tautot(:,nlev)))
      ELSEWHERE
        pnorm(:,nlev) = 0.
      END WHERE

!     Other layers
      DO k= nlev-1, 1, -1
          tautot_lay(:) = tautot(:,k)-tautot(:,k+1) ! optical thickness of layer k
        WHERE (tautot_lay(:).GT.0.)
          pnorm(:,k) = betatot(:,k) * EXP(-2.0*tautot(:,k+1)) / (2.*tautot_lay(:)) &
               & * (1.-EXP(-2.0*tautot_lay(:)))
        ELSEWHERE
!         This must never happend, but just in case, to avoid div. by 0
          pnorm(:,k) = betatot(:,k) * EXP(-2.0*tautot(:,k+1))
        END WHERE
      END DO

!------------------------------------------------------------
!---- 4.2 Ice/Liq Backscatter signal:
!------------------------------------------------------------

! Contribution of the molecular to beta
      betatot_ice(:,:) = beta_mol(:,:)
      betatot_liq(:,:) = beta_mol(:,:)

      tautot_ice(:,:) = tau_mol(:,:)
      tautot_liq(:,:) = tau_mol(:,:)

      DO i = 2, npart,2
           betatot_ice(:,:) = betatot_ice(:,:)+ kp_part(:,:,i)*alpha_part(:,:,i)
           tautot_ice(:,:) = tautot_ice(:,:)  + tau_part(:,:,i)
      ENDDO ! i
      DO i = 1, npart,2
           betatot_liq(:,:) = betatot_liq(:,:)+ kp_part(:,:,i)*alpha_part(:,:,i)
           tautot_liq(:,:) = tautot_liq(:,:)  + tau_part(:,:,i)
      ENDDO ! i


! Computation of the ice and liquid lidar backscattered signal (ATBice and ATBliq)
!     Ice only
!     Upper layer
      WHERE (tautot_ice(:,nlev).GT.0.)
        pnorm_ice(:,nlev) = betatot_ice(:,nlev) / (2.*tautot_ice(:,nlev)) &
              & * (1.-exp(-2.0*tautot_ice(:,nlev)))
      ELSEWHERE
        pnorm_ice(:,nlev) = 0.
      END WHERE

      DO k= nlev-1, 1, -1
          tautot_lay_ice(:) = tautot_ice(:,k)-tautot_ice(:,k+1)
        WHERE (tautot_lay_ice(:).GT.0.)
         pnorm_ice(:,k)=betatot_ice(:,k)*EXP(-2.0*tautot_ice(:,k+1))/(2.*tautot_lay_ice(:)) &
               & * (1.-EXP(-2.0*tautot_lay_ice(:)))
        ELSEWHERE
         pnorm_ice(:,k)=betatot_ice(:,k)*EXP(-2.0*tautot_ice(:,k+1))
        END WHERE
      ENDDO

!     Liquid only
!     Upper layer
      WHERE (tautot_liq(:,nlev).GT.0.)
        pnorm_liq(:,nlev) = betatot_liq(:,nlev) / (2.*tautot_liq(:,nlev)) &
              & * (1.-exp(-2.0*tautot_liq(:,nlev)))
      ELSEWHERE
        pnorm_liq(:,nlev) = 0.
      END WHERE
      DO k= nlev-1, 1, -1
          tautot_lay_liq(:) = tautot_liq(:,k)-tautot_liq(:,k+1)
        WHERE (tautot_lay_liq(:).GT.0.)
          pnorm_liq(:,k)=betatot_liq(:,k)*EXP(-2.0*tautot_liq(:,k+1))/(2.*tautot_lay_liq(:)) &
               & * (1.-EXP(-2.0*tautot_lay_liq(:)))
        ELSEWHERE
          pnorm_liq(:,k)=betatot_liq(:,k)*EXP(-2.0*tautot_liq(:,k+1))
        END WHERE
      ENDDO


! Computation of ATBperp,ice/liq from ATBice/liq including the multiple scattering
! contribution (Cesana and Chepfer 2013, JGR)
!  ATBperp,ice = Alpha*ATBice
!  ATBperp,liq = Beta*ATBliq^2 + Gamma*ATBliq

      DO k= nlev, 1, -1
          pnorm_perp_ice(:,k) = Alpha * pnorm_ice(:,k) ! Ice particles
          pnorm_perp_liq(:,k) = 1000*Beta * pnorm_liq(:,k)**2 + Gamma * pnorm_liq(:,k) ! Liquid particles
      ENDDO

! Computation of beta_perp_ice/liq using the lidar equation
!     Ice only
!     Upper layer
      WHERE (tautot_ice(:,nlev).GT.0.)
        beta_perp_ice(:,nlev) = pnorm_perp_ice(:,nlev) * (2.*tautot_ice(:,nlev)) &
              & / (1.-exp(-2.0*tautot_ice(:,nlev)))
      ELSEWHERE
        beta_perp_ice(:,nlev) = 0.
      END WHERE

      DO k= nlev-1, 1, -1
        tautot_lay_ice(:) = tautot_ice(:,k)-tautot_ice(:,k+1)
        WHERE (tautot_lay_ice(:).GT.0.)
         beta_perp_ice(:,k) = pnorm_perp_ice(:,k)/ EXP(-2.0*tautot_ice(:,k+1)) * (2.*tautot_lay_ice(:)) &
            & / (1.-exp(-2.0*tautot_lay_ice(:)))

        ELSEWHERE
         beta_perp_ice(:,k)=pnorm_perp_ice(:,k)/EXP(-2.0*tautot_ice(:,k+1))
        END WHERE
      ENDDO

!     Liquid only
!     Upper layer
      WHERE (tautot_liq(:,nlev).GT.0.)
        beta_perp_liq(:,nlev) = pnorm_perp_liq(:,nlev) * (2.*tautot_liq(:,nlev)) &
              & / (1.-exp(-2.0*tautot_liq(:,nlev)))
      ELSEWHERE
        beta_perp_liq(:,nlev) = 0.
      END WHERE

      DO k= nlev-1, 1, -1
          tautot_lay_liq(:) = tautot_liq(:,k)-tautot_liq(:,k+1)
        WHERE (tautot_lay_liq(:).GT.0.)
         beta_perp_liq(:,k) = pnorm_perp_liq(:,k)/ EXP(-2.0*tautot_liq(:,k+1)) * (2.*tautot_lay_liq(:)) &
            & / (1.-exp(-2.0*tautot_lay_liq(:)))

        ELSEWHERE
         beta_perp_liq(:,k)=pnorm_perp_liq(:,k)/EXP(-2.0*tautot_liq(:,k+1))
        END WHERE
      ENDDO



!------------------------------------------------------------
!---- 4.3 Perpendicular Backscatter signal:
!------------------------------------------------------------

! Computation of the total perpendicular lidar signal (ATBperp for liq+ice)
!     Upper layer
    WHERE(tautot(:,nlev).GT.0.)
          pnorm_perp_tot(:,nlev) = &
              (beta_perp_ice(:,nlev)+beta_perp_liq(:,nlev)-(beta_mol(:,nlev)/(1+1/0.0284))) / (2.*tautot(:,nlev)) &
              & * (1.-exp(-2.0*tautot(:,nlev)))
    ELSEWHERE
    pnorm_perp_tot(:,nlev) = 0.
    ENDWHERE

!     Other layers
      DO k= nlev-1, 1, -1
          tautot_lay(:) = tautot(:,k)-tautot(:,k+1) ! optical thickness of layer k

          ! The perpendicular component of the molecular backscattered signal (Betaperp) has been
          ! taken into account two times (once for liquid and once for ice).
          ! We remove one contribution using
          ! Betaperp=beta_mol(:,k)/(1+1/0.0284)) [bodhaine et al. 1999] in the following equations:
            WHERE (pnorm(:,k).eq.0)
                  pnorm_perp_tot(:,k)=0.
                  ELSEWHERE
                    WHERE (tautot_lay(:).GT.0.)
                      pnorm_perp_tot(:,k) = &
                          (beta_perp_ice(:,k)+beta_perp_liq(:,k)-(beta_mol(:,k)/(1+1/0.0284))) * &
                          EXP(-2.0*tautot(:,k+1)) / (2.*tautot_lay(:)) &
                          & * (1.-EXP(-2.0*tautot_lay(:)))
                    ELSEWHERE
          !         This must never happen, but just in case, to avoid div. by 0
                      pnorm_perp_tot(:,k) = &
                           (beta_perp_ice(:,k)+beta_perp_liq(:,k)-(beta_mol(:,k)/(1+1/0.0284))) * &
                          EXP(-2.0*tautot(:,k+1))
                    END WHERE
            ENDWHERE

      END DO

! Vertical field reversal if surface lidar
if ( surface_lidar .eq. 1 ) then
  pmol(:,:) = pmol(:,nlev:1:-1)
  pnorm(:,:) = pnorm(:,nlev:1:-1)
  pnorm_perp_tot(:,:) = pnorm_perp_tot(:,nlev:1:-1)
  tautot(:,:) = tautot(:,nlev:1:-1)

  presf(:,:) = presf_old(:,:)
  pres(:,:) = pres(:,nlev:1:-1)
  temp(:,:) = temp(:,nlev:1:-1)
  q_lsliq(:,:) = q_lsliq(:,nlev:1:-1)
  q_lsice(:,:) = q_lsice(:,nlev:1:-1)
  q_cvliq(:,:) = q_cvliq(:,nlev:1:-1)
  q_cvice(:,:) = q_cvice(:,nlev:1:-1)
  ls_radliq(:,:) = ls_radliq(:,nlev:1:-1)
  ls_radice(:,:) = ls_radice(:,nlev:1:-1)
  cv_radliq(:,:) = cv_radliq(:,nlev:1:-1)
  cv_radice(:,:) = cv_radice(:,nlev:1:-1)
endif

!-------- End computation Lidar --------------------------

!---------------------------------------------------------
!  Parasol/Polder module
!
!  Purpose : Compute reflectance for one particular viewing direction
!  and 5 solar zenith angles (calculation valid only over ocean)
! ---------------------------------------------------------

! initialization:
    refl(:,:) = 0.0

! activate parasol calculations:
    if (ok_parasol) then

!     Optical thickness from TOA to surface
      tautot_S_liq = 0.
      tautot_S_ice = 0.
      tautot_S_liq(:) = tautot_S_liq(:) &
         + tau_part(:,1,1) + tau_part(:,1,3)
      tautot_S_ice(:) = tautot_S_ice(:) &
         + tau_part(:,1,2) + tau_part(:,1,4)

      call parasol(npoints,nrefl,undef  &
                 ,tautot_S_liq,tautot_S_ice &
                 ,refl)

    endif ! ok_parasol

  END SUBROUTINE lidar_simulator
!
!---------------------------------------------------------------------------------
!
  SUBROUTINE parasol(npoints,nrefl,undef  &
                       ,tautot_S_liq,tautot_S_ice  &
                       ,refl)
!---------------------------------------------------------------------------------
! Purpose: To compute Parasol reflectance signal from model-simulated profiles
!          of cloud water and cloud fraction in each sub-column of each model
!          gridbox.
!
!
! December 2008, S. Bony,  H. Chepfer and J-L. Dufresne :
! - optimization for vectorization
!
! Version 2.0 (October 2008)
! Version 2.1 (December 2008)
!---------------------------------------------------------------------------------

    IMPLICIT NONE

! inputs
    INTEGER npoints              ! Number of horizontal gridpoints
    INTEGER nrefl                ! Number of angles for which the reflectance
                                 ! is computed. Can not be greater then ntetas
    REAL undef                   ! Undefined value. Currently not used
    REAL tautot_S_liq(npoints)   ! liquid water cloud optical thickness,
                                   ! integrated from TOA to surface
    REAL tautot_S_ice(npoints)   ! same for ice water clouds only
! outputs
    REAL refl(npoints,nrefl)     ! Parasol reflectances
!
! Local variables
    REAL tautot_S(npoints)       ! cloud optical thickness, from TOA to surface
    REAL frac_taucol_liq(npoints), frac_taucol_ice(npoints)

    REAL pi
!   look up table variables:
    INTEGER ny, it
    INTEGER ntetas, nbtau        ! number of angle and of optical thickness
                                   ! of the look-up table
    PARAMETER (ntetas=5, nbtau=7)
    REAL aa(ntetas,nbtau-1), ab(ntetas,nbtau-1)
    REAL ba(ntetas,nbtau-1), bb(ntetas,nbtau-1)
    REAL tetas(ntetas),tau(nbtau)
    REAL r_norm(ntetas)
    REAL rlumA(ntetas,nbtau), rlumB(ntetas,nbtau)
    REAL rlumA_mod(npoints,5), rlumB_mod(npoints,5)

    DATA tau   /0., 1., 5., 10., 20., 50., 100./
    DATA tetas /0., 20., 40., 60., 80./

! Look-up table for spherical liquid particles:
    DATA (rlumA(1,ny),ny=1,nbtau) /0.03, 0.090886, 0.283965, &
     0.480587, 0.695235, 0.908229, 1.0 /
    DATA (rlumA(2,ny),ny=1,nbtau) /0.03, 0.072185, 0.252596, &
      0.436401,  0.631352, 0.823924, 0.909013 /
    DATA (rlumA(3,ny),ny=1,nbtau) /0.03, 0.058410, 0.224707, &
      0.367451,  0.509180, 0.648152, 0.709554 /
    DATA (rlumA(4,ny),ny=1,nbtau) /0.03, 0.052498, 0.175844, &
      0.252916,  0.326551, 0.398581, 0.430405 /
    DATA (rlumA(5,ny),ny=1,nbtau) /0.03, 0.034730, 0.064488, &
      0.081667,  0.098215, 0.114411, 0.121567 /

! Look-up table for ice particles:
    DATA (rlumB(1,ny),ny=1,nbtau) /0.03, 0.092170, 0.311941, &
       0.511298, 0.712079 , 0.898243 , 0.976646 /
    DATA (rlumB(2,ny),ny=1,nbtau) /0.03, 0.087082, 0.304293, &
       0.490879,  0.673565, 0.842026, 0.912966 /
    DATA (rlumB(3,ny),ny=1,nbtau) /0.03, 0.083325, 0.285193, &
      0.430266,  0.563747, 0.685773,  0.737154 /
    DATA (rlumB(4,ny),ny=1,nbtau) /0.03, 0.084935, 0.233450, &
      0.312280, 0.382376, 0.446371, 0.473317 /
    DATA (rlumB(5,ny),ny=1,nbtau) /0.03, 0.054157, 0.089911, &
      0.107854, 0.124127, 0.139004, 0.145269 /

!--------------------------------------------------------------------------------
! Lum_norm=f(tetaS,tau_cloud) derived from adding-doubling calculations
!        valid ONLY ABOVE OCEAN (albedo_sfce=5%)
!        valid only in one viewing direction (theta_v=30�, phi_s-phi_v=320�)
!        based on adding-doubling radiative transfer computation
!        for tau values (0 to 100) and for tetas values (0 to 80)
!        for 2 scattering phase functions: liquid spherical, ice non spherical

    IF ( nrefl.GT. ntetas ) THEN
        PRINT *,'Error in lidar_simulator, nrefl should be less then ',ntetas,' not',nrefl
        STOP
    ENDIF

    rlumA_mod=0
    rlumB_mod=0
!
    pi = ACOS(-1.0)
    r_norm(:)=1./ COS(pi/180.*tetas(:))
!
    tautot_S_liq(:)=MAX(tautot_S_liq(:),tau(1))
    tautot_S_ice(:)=MAX(tautot_S_ice(:),tau(1))
    tautot_S(:) = tautot_S_ice(:) + tautot_S_liq(:)
!
! relative fraction of the opt. thick due to liquid or ice clouds
    WHERE (tautot_S(:) .GT. 0.)
        frac_taucol_liq(:) = tautot_S_liq(:) / tautot_S(:)
        frac_taucol_ice(:) = tautot_S_ice(:) / tautot_S(:)
    ELSEWHERE
        frac_taucol_liq(:) = 1.
        frac_taucol_ice(:) = 0.
    END WHERE
    tautot_S(:)=MIN(tautot_S(:),tau(nbtau))
!
! Linear interpolation :

    DO ny=1,nbtau-1
! microphysics A (liquid clouds)
      aA(:,ny) = (rlumA(:,ny+1)-rlumA(:,ny))/(tau(ny+1)-tau(ny))
      bA(:,ny) = rlumA(:,ny) - aA(:,ny)*tau(ny)
! microphysics B (ice clouds)
      aB(:,ny) = (rlumB(:,ny+1)-rlumB(:,ny))/(tau(ny+1)-tau(ny))
      bB(:,ny) = rlumB(:,ny) - aB(:,ny)*tau(ny)
    ENDDO
!
    DO it=1,ntetas
      DO ny=1,nbtau-1
        WHERE (tautot_S(:).GE.tau(ny).AND.tautot_S(:).LE.tau(ny+1))
            rlumA_mod(:,it) = aA(it,ny)*tautot_S(:) + bA(it,ny)
            rlumB_mod(:,it) = aB(it,ny)*tautot_S(:) + bB(it,ny)
        END WHERE
      END DO
    END DO
!
    DO it=1,ntetas
      refl(:,it) = frac_taucol_liq(:) * rlumA_mod(:,it) &
         + frac_taucol_ice(:) * rlumB_mod(:,it)
! normalized radiance -> reflectance:
      refl(:,it) = refl(:,it) * r_norm(it)
    ENDDO

    RETURN
  END SUBROUTINE parasol

#!/bin/sh
# ! (c) British Crown Copyright 2010, the Met Office.
# ! All rights reserved.
# ! 
# ! Redistribution and use in source and binary forms, with or without modification, are permitted 
# ! provided that the following conditions are met:
# ! 
# !     * Redistributions of source code must retain the above copyright notice, this list 
# !       of conditions and the following disclaimer.
# !     * Redistributions in binary form must reproduce the above copyright notice, this list
# !       of conditions and the following disclaimer in the documentation and/or other materials 
# !       provided with the distribution.
# !     * Neither the name of the Met Office nor the names of its contributors may be used 
# !       to endorse or promote products derived from this software without specific prior written 
# !       permission.
# ! 
# ! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
# ! IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
# ! FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
# ! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
# ! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
# ! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
# ! IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
# ! OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# !
# ! History:
# ! Oct 2010 - A. Bodas-Salcedo - Initial version
# !
# !

# $1 is the directory with the input files
# $2 is the directory where the outputs will be written. This needs to be the absolute path, not relative.

DIRIN=$1 
DIROUT=$2
TABLE='cf3hr'
# cfadDbze94_cf3hr_HadGEM2-ES_amip_r1i1p1_200801010130-200801010130.nc
# cfadLidarsr532_cf3hr_HadGEM2-ES_amip_r1i1p1_200801010130-200801010130.nc
# clcalipso_cf3hr_HadGEM2-ES_amip_r1i1p1_200801010130-200801010130.nc
# clhcalipso_cf3hr_HadGEM2-ES_amip_r1i1p1_200801010130-200801010130.nc
# cllcalipso_cf3hr_HadGEM2-ES_amip_r1i1p1_200801010130-200801010130.nc
# clmcalipso_cf3hr_HadGEM2-ES_amip_r1i1p1_200801010130-200801010130.nc
# cltcalipso_cf3hr_HadGEM2-ES_amip_r1i1p1_200801010130-200801010130.nc
# parasolRefl_cf3hr_HadGEM2-ES_amip_r1i1p1_200801010130-200801010130.nc

cd ${DIRIN}
VNAME=(cfadDbze94 \
    cfadLidarsr532 \
    clcalipso \
    clhcalipso \
    cllcalipso \
    clmcalipso \
    cltcalipso \
    parasolRefl)
N=8
for ((i = 0;i < $N;i++))
do
    echo ${VNAME[$i]}
    FLIST=$(/bin/ls ${VNAME[$i]}_${TABLE}_*.nc)
    M=$(/bin/ls ${VNAME[$i]}_${TABLE}_*.nc -w3 | wc -l)
    # Find first and last time
    j=0
    for FILE in $FLIST; do
       TIME=$(echo ${FILE} | cut -d_ -f6)
       T1=$(echo ${TIME} | cut -d- -f1)
       T2=$(echo ${TIME} | cut -d- -f2)
       T2=$(echo ${T2} | cut -d. -f1)
       if [[ $j == 0 ]] ; then
         FNAME=$(echo ${FILE} | cut -d_ -f1-5)
         TIME1=$T1
       fi
       j=$j+1
    done
    TIME2=$T2
    echo "Time 1: "$TIME1
    echo "Time 2: "$TIME2
    # Create output file name
    FNAME=${FNAME}_${TIME1}-${TIME2}.nc
    echo "Output: "$FNAME
    # Concatenate files
    ncrcat ${FLIST} ${DIROUT}/${FNAME}
done
